     case 185:        // prolog_path constant
      Buda1[Return]=TT_STR;
      Buda2[Return]=sv_StStore;
      strcpy((LPSTR)(StringStore+sv_StStore),make_short(ProgramPath));
      sv_StStore+=my_strlen(ProgramPath);
      StringStore[sv_StStore-1]=0;
      if (sv_StStore>=STRING_STORE && correct_STR_ST() )
        goto FULL;
      return(1);
     case 186:        // windows_path constant
      Buda1[Return]=TT_STR;
      Buda2[Return]=sv_StStore;
      GetWindowsDirectory(string3,MAX_PATH);
      i=ChangeCharset(M64_ch, ch_set, (BYTE *)string3, StringStore+sv_StStore, &kk, default_char);
      if ((sv_StStore+=i+1)>=STRING_STORE && correct_STR_ST() )
        goto FULL;
      return(1);
     case 187:        // this_program_path constant
      Buda1[Return]=TT_STR;
      Buda2[Return]=sv_StStore;
      strcpy((LPSTR)string2, make_short(namef));
      for (i=strlen((LPSTR)string2); string2[--i]!='\\' && i!=0; );
      string2[i]=0;
      strcpy((LPSTR)(StringStore+sv_StStore),string2);
      sv_StStore+=strlen(string2)+1;
      if (sv_StStore>=STRING_STORE && correct_STR_ST() )
        goto FULL;
      return(1);
     case 188:        // this_program_name constant
      Buda1[Return]=TT_STR;
      Buda2[Return]=sv_StStore;
      strcpy((LPSTR)string2, make_short(namef));
      for (i=strlen((LPSTR)string2); string2[--i]!='\\' && i!=0; );
      strcpy((LPSTR)(StringStore+sv_StStore),string2+i+1);
      sv_StStore+=strlen(string2+i);
      if (sv_StStore>=STRING_STORE && correct_STR_ST() )
        goto FULL;
      return(1);
     case 163:        // get_handle
      if (Buda1[Arguments]==TT_OBJ)
      {
        CHECK_TYPE(0,C_S_WIN)
        Buda2[Return]=(DWORD)((CWnd*)ObjectStore[Buda2[Arguments]+2])->m_hWnd;
      }
      else if (Buda1[Arguments]==TT_LINK && pMainWindow)
        Buda2[Return]=(DWORD)pMainWindow->m_hWnd;
      else
        return(0);
      Buda1[Return]=TT_INT;
      return(1);
     case 153:        // set_current_directory
      if (Buda1[Arguments]==TT_STR)
      {
        if(SetCurrentDirectory(make_long(StringStore+Buda2[Arguments])))
          return(1);
      }
      else // Buda1[Arguments]==TT_LINK
      {
        my_strcpy((LPTSTR)string3, namef);
        for (i=my_strlen((LPTSTR)string3); string3[--i]!='\\' && i!=0; );
        string3[i]=0;
        if(SetCurrentDirectory((LPTSTR)string3))
          return(1);
      }
      MitiText("Cannot set current directory.\r\n");
      goto E13;
     case 154:        // get_current_directory
      Buda1[Return]=TT_STR;
      Buda2[Return]=sv_StStore;
      GetCurrentDirectory(MAX_PATH,string3);
      i=ChangeCharset(M64_ch, ch_set, (BYTE *)string3, StringStore+sv_StStore, &kk, default_char);
      if ((sv_StStore+=i+1)>=STRING_STORE && correct_STR_ST() )
        goto FULL;
      return(1);
     case 155:        // create_directory
      if(CreateDirectory(make_long(StringStore+Buda2[Arguments]),NULL))
        return(1);
      MitiText("Cannot create a directory.\r\n");
      goto E13;
     case 156:        // remove_directory
      if(RemoveDirectory(make_long(StringStore+Buda2[Arguments])))
        return(1);
      MitiText("Cannot remove a directory.\r\n");
      goto E13;
     case 157:        // delete_file
      //@@@
      if(DeleteFileA((LPSTR)(StringStore+Buda2[Arguments])))
        return(1);
      MitiText("Cannot delete a file.\r\n");
      goto E13;
     case 201:        // copy_file
      if(CopyFile(make_long(StringStore+Buda2[Arguments]),
                   make_long(StringStore+Buda2[Arguments+1]), Buda2[Arguments+2]))
        return(1);
      MitiText("Cannot copy a file.\r\n");
      goto E13;
     case 202:        // move_file
      //i=(Buda2[Arguments+2]!=0)?MOVEFILE_REPLACE_EXISTING:0;
      if(MoveFile(make_long(StringStore+Buda2[Arguments]),
                     make_long(StringStore+Buda2[Arguments+1])))
        return(1);
      MitiText("Cannot move a file.\r\n");
      goto E13;
     case 158:        // set_active_window
      CHECK_TYPE(0,C_S_WIN_Main)
      if (ObjectStore[Buda2[Arguments]+2]) // ? do we need to check this
      {
        pMain_Frame=((C_FrameWnd*)ObjectStore[Buda2[Arguments]+2]);
        return(1);
      }
      else
        return(0);
     case 5:                       // Trace
      Trace=1;
      pMainFrame->SetWindowText(_T("StrProlog is TRACING."));
      return(1);
     case 8:                       // Beep
      MessageBeep(0);
      return(1);
     case 71:                       // Beep(S)
      switch (Buda1[Arguments])
      {
       case 0:
        i=0;
        break;
       case TT_C_QUESTION:  // ? SystemQuestion 
        i=MB_ICONQUESTION;
        break;
       case TT_C_D:  // d SystemDefault
        i=MB_OK;
        break;
       case TT_C_CUT:  // ! SystemExclamation
        i=MB_ICONEXCLAMATION;
        break;
       case TT_C_I:  // i SystemAsterisk
        i=MB_ICONASTERISK;
        break;
       case TT_C_S:  // s SystemHand
        i=MB_ICONHAND;
        break;
       case TT_STR:
          PlaySound(make_long(StringStore+Buda2[Arguments]), NULL, SND_SYNC); 
        return(1);
       default: // Standard beep using the computer speaker
        i=0xFFFFFFFF;
      }
      MessageBeep(i);
      return(1);
     case 14:        // Message box
     case 15:        // message box Yes - no
      // don't calc immediately these predicates
      switch (Buda1[Arguments+2])
      {
       case TT_C_QUESTION:  // ?
        i=MB_ICONQUESTION;
        break;
       case TT_C_CUT:  // !
        i=MB_ICONEXCLAMATION;
        break;
       case TT_C_I:  // i
        i=MB_ICONINFORMATION;
        break;
       case TT_C_S:  // s
        i=MB_ICONSTOP;
        break;
       default:
        i=0;
      }
      {
      CWnd* pWinTemp=(pMain_Frame)?pMain_Frame:(CWnd*)pMainFrame;
      if (p_line==14)
      {
#ifdef UNICODE
        DWORD my_k;
        ChangeCharset(ch_set, 64, StringStore+Buda2[Arguments], (BYTE *)string2, &my_k, default_char);
        MessageBox(pWinTemp->m_hWnd, make_long(StringStore+Buda2[Arguments+1]),
                              (wchar_t *)string2, i | MB_OK);
#else
        MessageBox(pWinTemp->m_hWnd, make_long(StringStore+Buda2[Arguments+1]),
                              (LPSTR)(StringStore+Buda2[Arguments]), i | MB_OK);
#endif
        return(1);  
      }
      else
      {
#ifdef UNICODE
        DWORD my_k;
        ChangeCharset(ch_set, 64, StringStore+Buda2[Arguments], (BYTE *)string2, &my_k, default_char);
        j=MessageBox(pWinTemp->m_hWnd, make_long(StringStore+Buda2[Arguments+1]),
                           (wchar_t *)string2, i | MB_YESNO);
#else
        j=MessageBox(pWinTemp->m_hWnd, make_long(StringStore+Buda2[Arguments+1]),
                           (LPSTR)(StringStore+Buda2[Arguments]), i | MB_YESNO);
#endif
        if (IDYES==j)
          return(1);
        else
          return(0);
      }
      }//for
     case 171:                       // play_sound
      if (Buda1[Arguments+1]==TT_INT)
        k=1000*Buda2[Arguments+1];
      else if (Buda1[Arguments+1]==TT_FLOAT)
        k=(MY_INT)(1000 * (*(MY_FLOAT*)&(Buda2[Arguments+1])) );
      Beep(Buda2[Arguments], k);
      return(1);
     case 198:       // draw_point
     case 199:       // draw_bitmap
      {
        HDC hDC, hMem;
        
        if (pMain_DC)
          hDC=pMain_DC->m_hDC;
        else if (pMain_Frame)
          hDC=GetDC(pMain_Frame->m_hWnd);
        else
          return(0);
        if (p_line==198)  // draw_point
        {
          if (Buda1[Arguments+2]==TT_LINK)
          {
            DWORD color=GetPixel(hDC, Buda2[Arguments], Buda2[Arguments+1]);
            if (color==CLR_INVALID)
              return(0);
            Buda1[Buda2[Arguments+2]]=TT_INT;
            Buda2[Buda2[Arguments+2]]=color;
            WILL_CLEAN(Buda2[Arguments+2]);
          }
          else if (Buda1[Arguments+2]==TT_INT)
            SetPixel(hDC, Buda2[Arguments], Buda2[Arguments+1], Buda2[Arguments+2]);
          else
            return(0);
          return(1);
        }   // draw_bitmap
        CHECK_TYPE(2,CLASS_SYSTEM_BITMAP)
        hMem=CreateCompatibleDC(hDC);
        i=ObjectStore[Buda2[Arguments+2]+4];
        j=ObjectStore[Buda2[Arguments+2]+5];
        if (Buda1[Arguments+3]==TT_LINK)
        {
          if (ObjectStore[Buda2[Arguments+2]+3]==0)
          {
            SelectObject(hMem, (HBITMAP)ObjectStore[Buda2[Arguments+2]+2]);
            BitBlt(hDC, Buda2[Arguments], Buda2[Arguments+1], i, j, hMem, 0, 0, SRCCOPY);
          }
          else
          {
            SelectObject(hMem, (HBITMAP)ObjectStore[Buda2[Arguments+2]+3]);
            BitBlt(hDC, Buda2[Arguments], Buda2[Arguments+1], i, j, hMem, 0, 0, SRCAND);
            SelectObject(hMem, (HBITMAP)ObjectStore[Buda2[Arguments+2]+2]);
            BitBlt(hDC, Buda2[Arguments], Buda2[Arguments+1], i, j, hMem, 0, 0, SRCPAINT);
          }
        }
        else
        {
          MY_FLOAT fl;
          if (Buda1[Arguments+3]==TT_FLOAT)
          {
            fl=*(MY_FLOAT*)&(Buda2[Arguments+3]);
            m=(MY_INT)fl;
          }
          else //if (Buda1[Arguments+3]==TT_INT)
          {
            fl=(MY_FLOAT)(MY_INT)(Buda2[Arguments+3]);
            m=Buda2[Arguments+3];
          }
          if (Buda1[Arguments+4]==TT_LINK)
          {
            m=(MY_INT)(i*fl);
            n=(MY_INT)(j*fl);
          }
          else
            n=Buda2[Arguments+4];
          if (ObjectStore[Buda2[Arguments+2]+3]==0)
          {
            SelectObject(hMem, (HBITMAP)ObjectStore[Buda2[Arguments+2]+2]);
            //k=GetDeviceCaps(hDC, RC_STRETCHBLT); 
            //k=GetDeviceCaps(hMem, RC_STRETCHBLT); 
            //SetStretchBltMode(hMem, COLORONCOLOR); 
            if (StretchBlt(hDC, Buda2[Arguments], Buda2[Arguments+1],m,n,hMem,i,j,0,0,SRCCOPY)==0)
            {
              DWORD theerr = GetLastError();
              FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL,theerr,0,string3,L_BUFER,NULL);
              MitiText(make_utf8(string3));
            }
          }
          else
          {
            SelectObject(hMem, (HBITMAP)ObjectStore[Buda2[Arguments+2]+3]);
            StretchBlt(hDC, Buda2[Arguments], Buda2[Arguments+1],m,n,hMem,i,j,0,0,SRCAND);
            SelectObject(hMem, (HBITMAP)ObjectStore[Buda2[Arguments+2]+2]);
            StretchBlt(hDC, Buda2[Arguments], Buda2[Arguments+1],m,n,hMem,i,j,0,0,SRCPAINT);
          }
        }
        DeleteDC(hMem);
        return(1);
      }
     case 17:        // Polygon
     case 130:       // RoundRect
     case 131:       // Chord
     case 132:       // Pie
     case 133:       // Arc
     case 18:        // PolyBezier
     case 16:        // Line
     case 128:       // Ellipse
     case 129:       // Rectangle
        {
          HDC hDC;
          
          if (pMain_DC)
            hDC=pMain_DC->m_hDC;
          else if (pMain_Frame)
            hDC=GetDC(pMain_Frame->m_hWnd);
          else
          {
            MitiText("You try to draw but you have not where to draw.\r\n");
            return(error_Runtime(0));
          }
          SelectObject(hDC, hPen);
          if (p_line>=16 && p_line<=18)
          {
            MY_WORD *Temp=(LP_MY_WORD)ObjectStore[Buda2[Arguments]+4];
            if (p_line==16)
            {
              MoveToEx(hDC, Temp[0], Temp[1], NULL);
              for (i=2; i<ObjectStore[Buda2[Arguments]+2]; i+=2)
                LineTo(hDC, Temp[i], Temp[i+1]);
            }
#if v32_64==32
            else if (p_line==17)
            {
              SelectObject(hDC, hBrush);
              Polygon(hDC, (POINT*)Temp, ObjectStore[Buda2[Arguments]+2]/2);
            }
            else
              PolyBezier(hDC, (POINT*)Temp, ObjectStore[Buda2[Arguments]+2]/2);
#else
            else
            {
              j=CreateArray(ObjectStore[Buda2[Arguments]+2]/2+1);
              DWORD *TempD=(LPDWORD)ObjectStore[j+4];
              for (i=0; i<ObjectStore[Buda2[Arguments]+2]; i++)
                TempD[i]=Temp[i];
              if (p_line==17)
              {
                SelectObject(hDC, hBrush);
                Polygon(hDC, (POINT*)TempD, ObjectStore[Buda2[Arguments]+2]/2);
              }
              else
                PolyBezier(hDC, (POINT*)TempD, ObjectStore[Buda2[Arguments]+2]/2);
              FreeArray(j);
            }
#endif
            if (ObjectStore[Buda2[Arguments]+1]==M2) // free the list
              FreeArray(Buda2[Arguments]);
          }
          else
          {
            SelectObject(hDC, hBrush);
            if (p_line==128)
              Ellipse(hDC, Buda2[Arguments], Buda2[Arguments+1], Buda2[Arguments+2], Buda2[Arguments+3]);
            else if (p_line==129)
              Rectangle(hDC, Buda2[Arguments], Buda2[Arguments+1], Buda2[Arguments+2], Buda2[Arguments+3]);
            else if (p_line==130)
              RoundRect(hDC, Buda2[Arguments], Buda2[Arguments+1], Buda2[Arguments+2], Buda2[Arguments+3], Buda2[Arguments+4], Buda2[Arguments+5]);
            else if (p_line==131)
              Chord(hDC, Buda2[Arguments], Buda2[Arguments+1], Buda2[Arguments+2], Buda2[Arguments+3], Buda2[Arguments+4], Buda2[Arguments+5], Buda2[Arguments+6], Buda2[Arguments+7]);
            else if (p_line==132)
              Pie(hDC, Buda2[Arguments], Buda2[Arguments+1], Buda2[Arguments+2], Buda2[Arguments+3], Buda2[Arguments+4], Buda2[Arguments+5], Buda2[Arguments+6], Buda2[Arguments+7]);
            else
              Arc(hDC, Buda2[Arguments], Buda2[Arguments+1], Buda2[Arguments+2], Buda2[Arguments+3], Buda2[Arguments+4], Buda2[Arguments+5], Buda2[Arguments+6], Buda2[Arguments+7]);
          }
          if (pMain_DC==NULL)
            ReleaseDC(pMain_Frame->m_hWnd, hDC);
        }
        return(1);
     case 19:        // Pen
      if (Buda1[Arguments]==TT_OBJ)        // Object pen
      {
        CHECK_TYPE(0,CLASS_SYSTEM_PEN)
        hPen=(HPEN)ObjectStore[Buda2[Arguments]+2];
        return(1);
      }
      else if (Buda1[Arguments]==TT_LINK)
      {
        LOGPEN logPen;

        if (Buda1[Arguments+1]==TT_INT)
        {
          j=Buda2[Arguments+1];
          GetObject(hPen, sizeof(LOGPEN), &logPen);
          Buda1[Buda2[Arguments]]=TT_INT;
          i=Buda2[Buda2[Arguments]]=logPen.lopnWidth.x;
          WILL_CLEAN(Buda2[Arguments]);
        }
        else if (Return==M1)// (Buda1[Arguments+1]==TT_LINK)
        {
          GetObject(hPen, sizeof(LOGPEN), &logPen);
          Buda1[Buda2[Arguments]]=Buda1[Buda2[Arguments+1]]=TT_INT;
          Buda2[Buda2[Arguments]]=logPen.lopnWidth.x;
          Buda2[Buda2[Arguments+1]]=logPen.lopnColor;
          WILL_CLEAN(Buda2[Arguments]);
          WILL_CLEAN(Buda2[Arguments+1]);
          return(1);
        }
        else
          return(0);
      }
      else // (Buda1[Arguments]==TT_INT)
      {
        if (Buda1[Arguments+1]==TT_LINK)
        {
          LOGPEN logPen;

          i=Buda2[Arguments];
          GetObject(hPen, sizeof(LOGPEN), &logPen);
          Buda1[Buda2[Arguments+1]]=TT_INT;
          j=Buda2[Buda2[Arguments+1]]=logPen.lopnColor;
          WILL_CLEAN(Buda2[Arguments+1]);
        }
        else // (Buda1[Arguments+1]==TT_INT)
        {
          i=Buda2[Arguments];
          j=Buda2[Arguments+1];
        }
      }
      if (i==0)
        hPen=CreatePen(PS_NULL, 0, 0);
      else if (Buda1[Arguments+2]==73)  // '-' Dash
        hPen=CreatePen(PS_DASH, i, j);
      else if (Buda1[Arguments+2]==67)  // '.' Dot
        hPen=CreatePen(PS_DOT, i, j);
      else  // Normal
        hPen=CreatePen(PS_INSIDEFRAME, i, j); // | 
      if (Return==M1)
      {
        DeleteObject(hSavePen);
        hSavePen=hPen;
      }
      else
      {
        Buda1[Return]=TT_OBJ;
        Buda2[Return]=ObjectStore_br;
        ObjectStore[ObjectStore_br+2]=(DWORD)hPen;
        ObjectStore[ObjectStore_br+1]=M1;  // object name
        ObjectStore[ObjectStore_br]=CLASS_SYSTEM_PEN;
        if ((ObjectStore_br+=3)>=OBJ_STORE && correct_OBJ_ST() )
          goto FULL2;
      }
      return(1);    
     case 74:        // brush(C, Type)
      if (Buda1[Arguments]==TT_OBJ)        // Object brush
      {
        CHECK_TYPE(0,CLASS_SYSTEM_BRUSH)
        hBrush=(HBRUSH)ObjectStore[Buda2[Arguments]+2];
        return(1);
      }
      else if (Buda1[Arguments]==TT_STR)        // brush(Bitmap)
      {
        hBrush=CreatePatternBrush((HBITMAP)LoadImage(NULL, 
            make_long(StringStore+Buda2[Arguments]), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE));
        goto E_brush;
      }
      else if ( Buda2[Arguments]>0xffffff ) //Buda1[Arguments]==TT_INT
        return(0);
      switch(Buda1[Arguments+1])
      {
       case TT_C_H:  // h   Horizontal
       case TT_C_MINUS:  // (-) Horizontal
        hBrush=CreateHatchBrush(HS_HORIZONTAL, Buda2[Arguments]);
        break;
       case TT_C_V:  // v Vertical 
       case TT_C_CUT:  // ! Vertical
        hBrush=CreateHatchBrush(HS_VERTICAL, Buda2[Arguments]);
        break;
       case TT_C_X:  // x Diagcross 
        hBrush=CreateHatchBrush(HS_DIAGCROSS, Buda2[Arguments]);
        break;
       case TT_C_NODIV:  // (\)
        hBrush=CreateHatchBrush(HS_FDIAGONAL, Buda2[Arguments]);
        break;
       case TT_C_PLUS:  // (+) Cross 
        hBrush=CreateHatchBrush(HS_CROSS, Buda2[Arguments]);
        break;
       case TT_C_DIV:  // (/)
        hBrush=CreateHatchBrush(HS_BDIAGONAL, Buda2[Arguments]);
        break;
       default:  // TT_LINK
        hBrush=CreateSolidBrush(Buda2[Arguments]);
      }
E_brush:if (Return==M1)
      {
        DeleteObject(hSaveBrush);
        hSaveBrush=hBrush;
      }
      else
      {
        Buda1[Return]=TT_OBJ;
        Buda2[Return]=ObjectStore_br;
        ObjectStore[ObjectStore_br+2]=(DWORD)hBrush;  // indentifier ?==ObjectStore_br
        ObjectStore[ObjectStore_br+1]=M1;  // object name
        ObjectStore[ObjectStore_br]=CLASS_SYSTEM_BRUSH;
        if ((ObjectStore_br+=3)>=OBJ_STORE && correct_OBJ_ST() )
          goto FULL2;
      }
      return(1);
     case 75:        // window Brush color(W, C, Type)
      if (Buda1[Arguments+1]==TT_STR) // color(W, Bitmap)
      {
        if (Buda1[Arguments]==TT_OBJ)
        {
          i=Buda2[Arguments];
          if (i>=ObjectStore_br)
            return(0);
        }
        else if (pMainWindow && pMainWindow!=pMain_Frame)
          i=pMainWindow->GetDlgCtrlID();
        else if (pMain_Frame)
          i=pMain_Frame->m_Number;
        else
          return(0);
        if (ObjectStore[i+6]!=ObjectStore[i+9])
          DeleteObject((HBRUSH)ObjectStore[i+9]);
        ObjectStore[i+9]=(MY_WORD)CreatePatternBrush((HBITMAP)LoadImage(NULL, 
              make_long(StringStore+Buda2[Arguments+1]), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE));
        ObjectStore[i+4]|=0x8000; // the overlaping brus is bitmap
        return(1);
      }
     case 34:        // window Text color
     case 35:        // window bacK color
      if (Buda1[Arguments+1]==TT_INT && Buda2[Arguments+1]>0xffffff) 
        return(0);  
      if (Buda1[Arguments]==TT_OBJ)
      {
        i=Buda2[Arguments];
        if (i>=ObjectStore_br)
          return(0);
      }
      else if (pMainWindow && pMainWindow!=pMain_Frame)
        i=pMainWindow->GetDlgCtrlID();
      else if (pMain_Frame)
        i=pMain_Frame->m_Number;
      else
        return(0);
      if (p_line==75)// window Brush color
      {
        if (ObjectStore[i+6]!=ObjectStore[i+9])
          DeleteObject((HBRUSH)ObjectStore[i+9]);
        ObjectStore[i+4]|=0x8000; // the overlaping brus is bitmap
        if (Buda1[Arguments+1]!=TT_INT)
        {
           // the overlaping brus is bitmap (Here this can be wrong but in this way it is OK)
          ObjectStore[i+9]=ObjectStore[i+6];
          return(1);
        }
        switch(Buda1[Arguments+2])
        {
         case TT_C_H:  // h   Horizotal
         case TT_C_MINUS:  // (-) Horizotal
          ObjectStore[i+9]=(MY_WORD)CreateHatchBrush(HS_HORIZONTAL, Buda2[Arguments+1]);
          break;
         case TT_C_V:  // v   Vertical 
         case TT_C_CUT:  // ! Vertical
          ObjectStore[i+9]=(MY_WORD)CreateHatchBrush(HS_VERTICAL, Buda2[Arguments+1]);
          break;
         case TT_C_X:  // x Diagcross 
          ObjectStore[i+9]=(MY_WORD)CreateHatchBrush(HS_DIAGCROSS, Buda2[Arguments+1]);
          break;
         case TT_C_NODIV:  // (\)
          ObjectStore[i+9]=(MY_WORD)CreateHatchBrush(HS_FDIAGONAL, Buda2[Arguments+1]);
          break;
         case TT_C_PLUS:  // (+) Cross 
          ObjectStore[i+9]=(MY_WORD)CreateHatchBrush(HS_CROSS, Buda2[Arguments+1]);
          break;
         case TT_C_DIV:  // (/)
          ObjectStore[i+9]=(MY_WORD)CreateHatchBrush(HS_BDIAGONAL, Buda2[Arguments+1]);
          break;
         default:  // TT_LINK
          ObjectStore[i+4]^=0x8000; // the overlaping brus is bitmap (make this false)
          ObjectStore[i+9]=(MY_WORD)CreateSolidBrush(Buda2[Arguments+1]);
        }
      }
      else if (SUBTYPE(ObjectStore[i],C_S_WIN_Edit))
      {
        if (p_line==34)
        {
          CHARFORMAT cf;
          if (Buda1[Arguments+1]==TT_INT)
            cf.crTextColor=ObjectStore[i+7]=Buda2[Arguments+1];
          else
            cf.crTextColor=ObjectStore[i+7]=RGB(0, 0, 0);
          cf.dwMask=CFM_COLOR;
          cf.dwEffects=0; // not CFE_AUTOCOLOR
          ((CRichEditCtrl*)ObjectStore[i+2])->SetDefaultCharFormat(cf);
        }
        else if (Buda1[Arguments+1]==TT_INT)
        {
          ((CRichEditCtrl*)ObjectStore[i+2])->SetBackgroundColor(FALSE, Buda2[Arguments+1]);
          ObjectStore[i+8]=Buda2[Arguments+1];
        }
        else
        {
          ((CRichEditCtrl*)ObjectStore[i+2])->SetBackgroundColor(TRUE, 0);
          ObjectStore[i+8]=GetSysColor(COLOR_WINDOW);
        }
      }
      else if (SUBTYPE(ObjectStore[i],C_S_WIN_ListBox))
      {
        if (p_line==34)
        {
          if (Buda1[Arguments+1]==TT_INT)
            ObjectStore[i+7]=Buda2[Arguments+1];
          else
            ObjectStore[i+7]=RGB(0, 0, 0);
          ((CListCtrl*)ObjectStore[i+2])->SetTextColor(ObjectStore[i+7]);
        }
        else 
        {
          if (Buda1[Arguments+1]==TT_INT)
            ObjectStore[i+8]=Buda2[Arguments+1];
          else
            ObjectStore[i+8]=GetSysColor(COLOR_WINDOW);
          ((CListCtrl*)ObjectStore[i+2])->SetBkColor(ObjectStore[i+8]);
          ((CListCtrl*)ObjectStore[i+2])->SetTextBkColor(ObjectStore[i+8]);
        }
      }
      else if (p_line==34)
      {
        ObjectStore[i+7]=(Buda1[Arguments+1]==TT_INT)?Buda2[Arguments+1]:RGB(0, 0, 0);
        if (pMain_DC)
          SetTextColor(pMain_DC->m_hDC, ObjectStore[i+7]);
      }
      else
      {
        ObjectStore[i+8]=(Buda1[Arguments+1]==TT_INT)?Buda2[Arguments+1]:GetSysColor(COLOR_WINDOW);
        if (pMain_DC)
          SetBkColor(pMain_DC->m_hDC, ObjectStore[i+8]);
      }
      return(1);
     case 159:        // Font
      if (Buda1[Arguments]==TT_OBJ)        // Object font
      {
        CHECK_TYPE(0,CLASS_SYSTEM_FONT)
        hFont=(HFONT)ObjectStore[Buda2[Arguments]+2];
        return(1);
      }
      hFont=CreateFont( 
              (Buda1[Arguments+1]==TT_INT)?Buda2[Arguments+1]:0,
              (Buda1[Arguments]==TT_INT)?Buda2[Arguments]:0,
              0,0,0,0,0,0,0,0,0,0,0,
              (Buda1[Arguments+2]==TT_STR)? make_long(StringStore+Buda2[Arguments+2]):NULL );
      if (Return==M1)
      {
        if (hSaveFont)
          DeleteObject(hSaveFont);
        hSaveFont=hFont;
      }
      else
      {
        Buda1[Return]=TT_OBJ;
        Buda2[Return]=ObjectStore_br;
        ObjectStore[ObjectStore_br+2]=(DWORD)hFont;
        ObjectStore[ObjectStore_br+1]=M1;  // object name
        ObjectStore[ObjectStore_br]=CLASS_SYSTEM_FONT;
        if ((ObjectStore_br+=3)>=OBJ_STORE && correct_OBJ_ST() )
          goto FULL2;
      }
      return(1);    
     case 160:        // font_mask
      {
        CHARFORMAT *cf;

        cf=(CHARFORMAT*)(ObjectStore+ObjectStore_br+2);
        if (Buda1[Arguments]==Definition[DF_DEFAULT])
        {
          cf->dwMask=cf_black.dwMask;
          cf->crTextColor=cf_black.crTextColor;
          my_strcpy(cf->szFaceName, cf_black.szFaceName);
          cf->yHeight=cf_black.yHeight;
          cf->yOffset=cf_black.yOffset;
          cf->dwEffects=cf_black.dwEffects;
        }
        else if (Buda1[Arguments]==TT_OBJ)
        {
          CHARFORMAT *cf2;

          CHECK_TYPE(0,CLASS_SYSTEM_FONTMASK)
          cf2=(CHARFORMAT*)(ObjectStore+Buda2[Arguments]+2);
          cf->dwMask=cf2->dwMask;
          cf->crTextColor=cf2->crTextColor;
          my_strcpy(cf->szFaceName, cf2->szFaceName);
          cf->yHeight=cf2->yHeight;
          if (cf->yHeight <190) cf->yHeight=190; //plamen test
          cf->yOffset=cf2->yOffset;
          cf->dwEffects=cf2->dwEffects;
        }
        else
          cf->dwMask=0;
        cf->cbSize=sizeof(CHARFORMAT); //?
        if (Buda1[Arguments+1]==TT_INT)
        {
          cf->crTextColor=Buda2[Arguments+1];
          cf->dwMask|=CFM_COLOR;
        }
        if (Buda1[Arguments+2]==TT_STR && strlen((LPSTR)(StringStore+Buda2[Arguments+2]))<LF_FACESIZE)
        {
          my_strcpy(cf->szFaceName, make_long(StringStore+Buda2[Arguments+2]));
          cf->dwMask|=CFM_FACE;
        }
        if (Buda1[Arguments+3]==TT_INT)
        {
          cf->yHeight=20*Buda2[Arguments+3];
          if (cf->yHeight <190) cf->yHeight=190; //plamen test
          cf->dwMask|=CFM_SIZE;
        }
        else if (Buda1[Arguments+3]==TT_FLOAT)
        {
          cf->yHeight=(MY_INT)(20* *(MY_FLOAT*)&(Buda2[Arguments+3]));
          if (cf->yHeight <190) cf->yHeight=190; //plamen test
          cf->dwMask|=CFM_SIZE;
        }
        if (Buda1[Arguments+4]==TT_INT)
        {
          cf->yOffset=20*Buda2[Arguments+4];
          cf->dwMask|=CFM_OFFSET;
        }
        else if (Buda1[Arguments+4]==TT_FLOAT)
        {
          cf->yOffset=(MY_INT)(20* *(MY_FLOAT*)&(Buda2[Arguments+4]));
          cf->dwMask|=CFM_OFFSET;
        }
        if (Buda1[Arguments+5]==TT_INT)
        {
          if (Buda2[Arguments+5]&0x10000) // BOLD
          {
            if (Buda2[Arguments+5]&1)
              cf->dwEffects|=CFE_BOLD;
            else
              cf->dwEffects&=CFE_BOLD^M1;
            cf->dwMask|=CFM_BOLD;
          }
          if (Buda2[Arguments+5]&0x20000) // ITALIC
          {
            if (Buda2[Arguments+5]&2)
              cf->dwEffects|=CFE_ITALIC;
            else
              cf->dwEffects&=CFE_ITALIC^M1;
            cf->dwMask|=CFM_ITALIC;
          }
          if (Buda2[Arguments+5]&0x40000) // UNDERLINE
          {
            if (Buda2[Arguments+5]&4)
              cf->dwEffects|=CFE_UNDERLINE;
            else
              cf->dwEffects&=CFE_UNDERLINE^M1;
            cf->dwMask|=CFM_UNDERLINE;
          }
        }
        Buda1[Return]=TT_OBJ;
        Buda2[Return]=ObjectStore_br;
        ObjectStore[ObjectStore_br+1]=M1;  // object name
        ObjectStore[ObjectStore_br]=CLASS_SYSTEM_FONTMASK;
        if ((ObjectStore_br+=2+96/v4_8)>=OBJ_STORE && correct_OBJ_ST() ) // 96>=sizeof(CHARFORMAT), 96 mod 8 = 0
          goto FULL2;
      }
      return(1);    
     case 161:        // set_default
      if (SUBTYPE(ObjectStore[Buda2[Arguments]],CLASS_SYSTEM_PEN))
        hPen=(HPEN)ObjectStore[Buda2[Arguments]+2];
      else if (SUBTYPE(ObjectStore[Buda2[Arguments]],CLASS_SYSTEM_BRUSH))
        hBrush=(HBRUSH)ObjectStore[Buda2[Arguments]+2];
      else if (SUBTYPE(ObjectStore[Buda2[Arguments]],CLASS_SYSTEM_FONT))
        hFont=(HFONT)ObjectStore[Buda2[Arguments]+2];
      else if (SUBTYPE(ObjectStore[Buda2[Arguments]],CLASS_SYSTEM_FONTMASK))
        pFontMask=(CHARFORMAT*)(ObjectStore+Buda2[Arguments]+2);
      else
        return(error_func3(Arguments,p_line,0,CLASS_SYSTEM_PEN,HALF|CLASS_SYSTEM_FONT));
      return(1);
     case 197:        // bitmap_image
      {
        BITMAP bm;
        CBitmap* pBitmap;
        if ((ObjectStore[ObjectStore_br+2]=(DWORD)(HBITMAP)LoadImage(NULL, 
              make_long(StringStore+Buda2[Arguments]), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE))==NULL)
        {
          MitiText("Cannot open the bitmap file:\r\n", &cf_red);
          MitiText((LPSTR)(StringStore+Buda2[Arguments])); MitiText("\r\n");
          return(0);
        }
        pBitmap=pBitmap->FromHandle((HBITMAP)ObjectStore[ObjectStore_br+2]);
        pBitmap->GetBitmap(&bm);
        if (Buda1[Arguments+1]==TT_STR)
        {
          if ((ObjectStore[ObjectStore_br+3]=(DWORD)(HBITMAP)LoadImage(NULL, 
              make_long(StringStore+Buda2[Arguments+1]), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE))==NULL)
          {
            MitiText("Cannot open the bitmap file for the mask:\r\n", &cf_red);
            MitiText((LPSTR)(StringStore+Buda2[Arguments+1])); MitiText("\r\n");
            return(0);
          }
        }
        else
          ObjectStore[ObjectStore_br+3]=0;
        Buda1[Return]=TT_OBJ;
        Buda2[Return]=ObjectStore_br;
        ObjectStore[ObjectStore_br+4]=bm.bmWidth;
        ObjectStore[ObjectStore_br+5]=bm.bmHeight;
        ObjectStore[ObjectStore_br+1]=M1;  // object name
        ObjectStore[ObjectStore_br]=CLASS_SYSTEM_BITMAP;
        if ((ObjectStore_br+=6)>=OBJ_STORE && correct_OBJ_ST() )
          goto FULL2;
      }
      return(1);    
     case 418:        // size
     case 419:        // set_size
     case 420:        // pos
     case 421:        // set_pos
     case 30:       // client_size
     case 31:       // client_pos
      {
        CWnd *pWindow;
        
        if (Buda1[Arguments]==TT_OBJ)
        {
          CHECK_TYPE(0,C_S_WIN)
          if (ObjectStore[Buda2[Arguments]+2])  // ? do we need to check this
            pWindow=((CWnd*)ObjectStore[Buda2[Arguments]+2]);
          else
            return(0);
        }
        else if (Buda1[Arguments] == Definition[DF_SCREEN])
          pWindow=NULL;
        else if ((pWindow=(pMainWindow==NULL)?pMain_Frame:pMainWindow)==NULL)
          return(0);
        if (p_line<32)    // client
        {
          WINDOWINFO wi;
          
          if (pWindow->GetWindowInfo(&wi)==0)
            return(0);
          if (p_line==30)    // client_size
          {
            i=wi.rcClient.right-wi.rcClient.left;
            j=wi.rcClient.bottom-wi.rcClient.top;
          }
          else
          {
            i=wi.rcClient.left;
            j=wi.rcClient.top;
          }
          return( return_and_check_value_2(Arguments+1, i, Arguments+2, j) );
        }
        else if (p_line&1)    // set size or pos
        { 
          if (p_line==421)    // Position
            pWindow->SetWindowPos(0, Buda2[Arguments+1], Buda2[Arguments+2], 0, 0, SWP_NOSIZE | SWP_NOZORDER);
          else
            pWindow->SetWindowPos(0, 0, 0, Buda2[Arguments+1], Buda2[Arguments+2], SWP_NOMOVE | SWP_NOZORDER);
          return(1);
        }
        else
        {
          if (pWindow==NULL)
          {
            i = GetSystemMetrics(SM_CXSCREEN);
            j = GetSystemMetrics(SM_CYSCREEN);
          }
          else
          { 
            RECT TempRect;

            pWindow->GetWindowRect( &TempRect);
            if (p_line==420)   // Position
            {
              POINT Point;

              Point.x=TempRect.left;
              Point.y=TempRect.top;
              if (pWindow->GetParent()!=NULL)
                MapWindowPoints(NULL, pWindow->GetParent()->m_hWnd, &Point, 1);
              i=Point.x;
              j=Point.y;
            }
            else
            {
              i=TempRect.right-TempRect.left;
              j=TempRect.bottom-TempRect.top;
            }
          }
          return( return_and_check_value_2(Arguments+1, i, Arguments+2, j) );
        }
      }
     case 176:        // enable_window
      if (Buda1[Arguments]==TT_LINK)
        ((CWnd*)pMainWindow)->EnableWindow(Buda2[Arguments+1]);
      else
      {
        CHECK_TYPE(0,C_S_WIN)
        ((CWnd*)ObjectStore[Buda2[Arguments]+2])->EnableWindow(Buda2[Arguments+1]);
      }
      return(1);
     case 139:        // set_check_box_value
      if (Buda1[Arguments]==TT_LINK)
        ((CButton*)pMainWindow)->SetCheck(Buda2[Arguments+1]);
      else
      {
        CHECK_TYPE(0,C_S_WIN_CheckBox)
        ((CButton*)ObjectStore[Buda2[Arguments]+2])->SetCheck(Buda2[Arguments+1]);
      }
      return(1);
     case 140:        // get_check_box_value
      Buda1[Return]=TT_INT;
      if (Buda1[Arguments]==TT_LINK)
        Buda2[Return]=((CButton*)pMainWindow)->GetCheck();
      else
      {
        CHECK_TYPE(0,C_S_WIN_CheckBox)
        Buda2[Return]=((CButton*)ObjectStore[Buda2[Arguments]+2])->GetCheck();
      }
      return(1);
     case 141:        // Set Timer
      if (Buda1[Arguments+1]==TT_FLOAT)
        k=(MY_INT)(*(MY_FLOAT*)&(Buda2[Arguments+1])*1000);
      else // (Buda1[Arguments+1]==TT_INT)
        k=Buda2[Arguments+1]*1000;
      if (Buda1[Arguments]==TT_LINK)
      {
        if (pMainWindow==NULL)
        {
          MitiText("Cannot set timer. It has to be attached to a window.\r\n", &cf_red);
          return 0;
        }
        else
          i=pMainWindow->SetTimer( ObjectStore_br, k, NULL);
      }
      else
      {
        CHECK_TYPE(0,C_S_WIN_Main)
        i=((CWnd*)ObjectStore[Buda2[Arguments]+2])->SetTimer( ObjectStore_br, k, NULL);
      }
      if (i==0 || Buda1[Arguments+2]>=MEMORY_c256)
        return(0);
      Buda1[Return]=TT_OBJ;
      Buda2[Return]=ObjectStore_br;
      ObjectStore[ObjectStore_br+3]=Buda1[Arguments+2];  // function
      ObjectStore[ObjectStore_br+2]=i;  // indentifier ?==ObjectStore_br
      ObjectStore[ObjectStore_br+1]=M1;  // object name
      ObjectStore[ObjectStore_br]=CLASS_SYSTEM_TIMER;
      if ((ObjectStore_br+=4)>=OBJ_STORE && correct_OBJ_ST() )
        goto FULL2;
      return(1);
     case 142:        // Kill Timer
      CHECK_TYPE(1,CLASS_SYSTEM_TIMER)
      if (Buda1[Arguments]!=TT_OBJ)
        i=pMainWindow->KillTimer( ObjectStore[Buda2[Arguments+1]+2]);
      else
        i=((CWnd*)ObjectStore[Buda2[Arguments]+2])->KillTimer(ObjectStore[Buda2[Arguments+1]+2]);
      if (i==0)
        return(0);
      return(1);
     case 144:        // add_text
      {
        CRichEditCtrl *Temp;
  
        if (Buda1[Arguments]!=TT_OBJ)
          Temp=(CRichEditCtrl*)pMainWindow;
        else
          Temp=(CRichEditCtrl*)ObjectStore[Buda2[Arguments]+2];
        Temp->GetTextLength();
        Temp->SetSel(-1,-1);
        if (Buda1[Arguments+2]==TT_OBJ)
        {
          CHECK_TYPE(2,CLASS_SYSTEM_FONTMASK)
          Temp->SetSelectionCharFormat(*(CHARFORMAT*)(ObjectStore+Buda2[Arguments+2]+2));
        }
        {
        char* pText = (LPSTR)(StringStore+Buda2[Arguments+1]);
        EDITSTREAM es;
        es.dwCookie = (DWORD)&pText;
        es.pfnCallback = EDITSTREAMCALLBACK(StreamInCallbackEd);
        Temp->StreamIn((CP_UTF8 << 16) | SF_USECODEPAGE | SF_TEXT | SFF_SELECTION, es);
        }
      }
      return(1);
     case 33:        // Get Window Text (get_text) // from X get text
      Buda1[Return]=TT_STR;
      if (Buda1[Arguments]==TT_LINK)
        pMainWindow->GetWindowText(string3, L_BUFER);
      else if (SUBTYPE(ObjectStore[Buda2[Arguments]],C_S_WIN_Edit))
      {
        Buda2[Return]=sv_StStore;
        {
          CRichEditCtrl *Temp=(CRichEditCtrl*)ObjectStore[Buda2[Arguments]+2];
          EDITSTREAM es;
          es.pfnCallback = EDITSTREAMCALLBACK(MyStreamOutCallback);
          Temp->StreamOut((CP_UTF8 << 16) | SF_USECODEPAGE | SF_TEXT, es);
        }
        if (Buda2[Return]==sv_StStore)
          Buda2[Return]=0;
        else
          StringStore[sv_StStore++]=0;
        return(1);
      }
      else
      {
        CHECK_TYPE(0,C_S_WIN)
        ((CWnd*)ObjectStore[Buda2[Arguments]+2])->GetWindowText(string3, L_BUFER);
      }
      i=ChangeCharset(M64_ch, ch_set, (BYTE *)string3, StringStore+sv_StStore, &kk, default_char);
      if (i)
      {
        Buda2[Return]=sv_StStore;
        if ((sv_StStore+=i+1)>=STRING_STORE && correct_STR_ST() )
          goto FULL;
      }
      else
        Buda2[Return]=0;
      return(1);
     case 32:        // Set Window Name (set_text) // to Y set text X
      if (Buda1[Arguments+1]==TT_LINK)
        pMainWindow->SetWindowText(make_long(StringStore+Buda2[Arguments]));
      else if (SUBTYPE(ObjectStore[Buda2[Arguments+1]],C_S_WIN_Edit))
      {
        ChangeCharset(ch_set, 0, StringStore+Buda2[Arguments], (BYTE *)string2, &kk, default_char);
        CRichEditCtrl *Temp=(CRichEditCtrl*)ObjectStore[Buda2[Arguments+1]+2];
        char* pText = string2;
        EDITSTREAM es;
        es.dwCookie = (DWORD)&pText;
        es.pfnCallback = EDITSTREAMCALLBACK(StreamInCallbackEd);
        Temp->StreamIn((CP_UTF8 << 16) | SF_USECODEPAGE | SF_TEXT, es);
      }
      else
      {
        CHECK_TYPE(1,C_S_WIN)
        ((CWnd*)ObjectStore[Buda2[Arguments+1]+2])->SetWindowText(make_long(StringStore+Buda2[Arguments]));
      }
      return(1);
     case 427:        // set_capture
      if (Buda1[Arguments]==TT_LINK)
        pMain_Frame->SetCapture();
      else
      {
        CHECK_TYPE(0,C_S_WIN)
        ((CWnd*)ObjectStore[Buda2[Arguments]+2])->SetCapture();
      }
      return(1);
     case 428:        // release_capture
      ReleaseCapture();
      return(1);
     case 429:        // set_scroll_pos
     case 430:        // set_scroll_page
     case 431:        // set_scroll_range
     case 432:        // get_scroll_pos
     case 433:        // get_scroll_page
     case 434:        // get_scroll_range
      {
      CWnd *Temp;

      if (Buda1[Arguments+1]==Definition[DF_HORIZONTAL])
        i=SB_HORZ;
      else if (Buda1[Arguments+1]==Definition[DF_VERTICAL])
        i=SB_VERT;
      else
      {
        MitiText("The second argument in scroll bar functions should to be \"horizontal\" or \"vertical\".\r\n");
        return(error_Runtime(0));
      }
      if (Buda1[Arguments]==TT_LINK)
        Temp=pMain_Frame;
      else
      {
        CHECK_TYPE(0,C_S_WIN)
        Temp=((CWnd*)ObjectStore[Buda2[Arguments]+2]);
      }
      if (p_line==429)        // set_scroll_pos
        Temp->SetScrollPos(i, Buda2[Arguments+2]);
      else if (p_line==430)   // set_scroll_page
      {
        SCROLLINFO sc_infp;
        sc_infp.fMask=SIF_PAGE;
        sc_infp.nPage=Buda2[Arguments+2];
        Temp->SetScrollInfo(i, &sc_infp);
      }
      else if (p_line==431)   // set_scroll_range
        Temp->SetScrollRange(i, Buda2[Arguments+2], Buda2[Arguments+3]);
      else if (p_line==432)   // get_scroll_pos
      {
        Buda1[Return]=TT_INT;
        Buda2[Return]=Temp->GetScrollPos(i);
      }
      else if (p_line==433)   // get_scroll_page
      {
        SCROLLINFO sc_infp;
        sc_infp.fMask=SIF_PAGE;
        Temp->GetScrollInfo(i, &sc_infp);
        Buda1[Return]=TT_INT;
        Buda2[Return]=sc_infp.nPage;
      }
      else if (p_line==434)   // get_scroll_range
      {
        Temp->GetScrollRange(i, (LPINT)&m, (LPINT)&n);
        Buda1[Buda2[Arguments+2]]=Buda1[Buda2[Arguments+3]]=TT_INT;
        Buda2[Buda2[Arguments+2]]=m;
        Buda2[Buda2[Arguments+3]]=n;
        WILL_CLEAN(Buda2[Arguments+2]);
        WILL_CLEAN(Buda2[Arguments+3]);
      }
      return(1);
      }
     case 439:        // set_slider_pos
     case 440:        // get_slider_pos
      {
      CSliderCtrl *Temp;

      CHECK_TYPE(0,C_S_WIN_Slider)
      Temp=((CSliderCtrl*)ObjectStore[Buda2[Arguments]+2]);

      if (p_line==439)        // set_slider_pos
        Temp->SetPos(Buda2[Arguments+1]);
      else if (p_line==440)   // get_slider_pos
      {
        Buda1[Return]=TT_INT;
        Buda2[Return]=Temp->GetPos();
      }
      return(1);
      }
     case 165:        // set_selection
     case 166:        // get_selection
     case 167:        // get_selected_text
     case 168:        // change_selected_text
     case 169:        // format_selected_text
     case 204:        // position_to_line_number
      {
        CRichEditCtrl *Temp;
  
        if (Buda1[Arguments]!=TT_OBJ)
          Temp=(CRichEditCtrl*)pMainWindow;
        else
        {
          CHECK_TYPE(0,C_S_WIN_Edit)
          Temp=(CRichEditCtrl*)ObjectStore[Buda2[Arguments]+2];
        }
        switch(p_line)
        {
         case 165:        // set_selection
          if (Buda1[Arguments+1]==TT_INT)
            i=Buda2[Arguments+1];
          else if (Buda1[Arguments+1]==Definition[DF_END])
            i=-1;
          else
            return(0);
          if (Buda1[Arguments+2]==TT_INT)
            j=Buda2[Arguments+2];
          else if (Buda1[Arguments+2]==Definition[DF_END])
            j=-1;
          else
            return(0);
          Temp->SetSel(i,j);
          return(1);
         case 166:        // get_selection
          {
            long i, j;

            Temp->GetSel(i, j);
            Buda1[Buda2[Arguments+1]]=Buda1[Buda2[Arguments+2]]=TT_INT;
            Buda2[Buda2[Arguments+1]]=i;
            Buda2[Buda2[Arguments+2]]=j;
            WILL_CLEAN(Buda2[Arguments+1]);
            WILL_CLEAN(Buda2[Arguments+2]);
            return(1);
          }
         case 167:        // get_selected_text
          Buda1[Return]=TT_STR;
          Buda2[Return]=sv_StStore;
          {
            EDITSTREAM es;
            es.pfnCallback = EDITSTREAMCALLBACK(MyStreamOutCallback);
            Temp->StreamOut((CP_UTF8 << 16) | SF_USECODEPAGE | SF_TEXT | SFF_SELECTION, es);
          }
          if (Buda2[Return]==sv_StStore)
            Buda2[Return]=0;
          else
            StringStore[sv_StStore++]=0;
          return(1);
         case 168:        // change_selected_text
          {
          ChangeCharset(ch_set, 0, StringStore+Buda2[Arguments+1], (BYTE *)string2, &kk, default_char);
          char* pText = string2;
          EDITSTREAM es;
          es.dwCookie = (DWORD)&pText;
          es.pfnCallback = EDITSTREAMCALLBACK(StreamInCallbackEd);
          Temp->StreamIn((CP_UTF8 << 16) | SF_USECODEPAGE | SF_TEXT | SFF_SELECTION, es);
          }
          return(1);
         case 169:        // format_selected_text
          CHECK_TYPE(1,CLASS_SYSTEM_FONTMASK)
          Temp->SetSelectionCharFormat(*(CHARFORMAT*)(ObjectStore+Buda2[Arguments+1]+2));
          return(1);
         case 204:        // position_to_line_number
          if (Buda1[Arguments+2]==TT_INT && Buda1[Arguments+3]==TT_INT)
          {
            if (Buda1[Arguments+1]==TT_INT)
            {
              if (Buda2[Arguments+2]!=(DWORD)(Temp->LineFromChar(Buda2[Arguments+1]))
                || Buda2[Arguments+3]!=Buda2[Arguments+1]-Temp->LineIndex(Buda2[Arguments+2]))
                return(0);
            }
            else
            {
              Buda1[Buda2[Arguments+1]]=TT_INT;
              if ((i=Temp->LineIndex(Buda2[Arguments+2]))==M1)
                return(0);
              if ((j=Temp->LineIndex(Buda2[Arguments+2]+1))==M1)
                j=Temp->GetTextLength()+1;
              Buda2[Buda2[Arguments+1]]=(i+Buda2[Arguments+3]<j)?i+Buda2[Arguments+3]:j-1;
              WILL_CLEAN(Buda2[Arguments+1]);
            }
          }
          else if (Buda1[Arguments+2]==TT_LINK && Buda1[Arguments+3]==TT_LINK)
          {
            if (Buda1[Arguments+1]==TT_INT)
            {
              Buda1[Buda2[Arguments+2]]=Buda1[Buda2[Arguments+3]]=TT_INT;
              Buda2[Buda2[Arguments+2]]=Temp->LineFromChar(Buda2[Arguments+1]);
              if ((i=Temp->GetTextLength())<Buda2[Arguments+1])
                Buda2[Buda2[Arguments+3]]=i-Temp->LineIndex(Buda2[Buda2[Arguments+2]]);
              else
                Buda2[Buda2[Arguments+3]]=Buda2[Arguments+1]-Temp->LineIndex(Buda2[Buda2[Arguments+2]]);
              WILL_CLEAN(Buda2[Arguments+2]);
              WILL_CLEAN(Buda2[Arguments+3]);
            }
            else
            {
              MitiText("The Position and Line arguments of position_to_line_number\r\ncannot be both variables.\r\n");
              return(error_Runtime(0));
            }
          }
          else
          {
            MitiText("The Line and Column arguments of position_to_line_number\r\nhave to be both integers or both variables.\r\n");
            return(error_Runtime(0));
          }
          return(1);
        }
      }
     case 191:        // cut_in_edit
      if (Buda1[Arguments]!=TT_OBJ)
        ((CRichEditCtrl*)pMainWindow)->Cut();
      else
        ((CRichEditCtrl*)ObjectStore[Buda2[Arguments]+2])->Cut();
      return(1);
     case 192:        // copy_in_edit
      if (Buda1[Arguments]!=TT_OBJ)
        ((CRichEditCtrl*)pMainWindow)->Copy();
      else
        ((CRichEditCtrl*)ObjectStore[Buda2[Arguments]+2])->Copy();
      return(1);
     case 193:        // paste_in_edit
      if (Buda1[Arguments]!=TT_OBJ)
        ((CRichEditCtrl*)pMainWindow)->PasteSpecial(CF_TEXT);
      else
        ((CRichEditCtrl*)ObjectStore[Buda2[Arguments]+2])->PasteSpecial(CF_TEXT);
      return(1);
     case 226:        // insert_tree_item
      {
      CTreeCtrl *Temp;
      HTREEITEM Parent, InsertAfter;

      if (Buda1[Arguments]!=TT_OBJ)
        Temp=(CTreeCtrl*)pMainWindow;
      else
        Temp=(CTreeCtrl*)ObjectStore[Buda2[Arguments]+2];
      i=TVIF_TEXT | TVIF_PARAM;
      if (Buda1[Arguments+5]==TT_INT)
        i|=TVIF_IMAGE;
      if (Buda1[Arguments+6]==TT_INT)
        i|=TVIF_SELECTEDIMAGE;
      Parent=(Buda1[Arguments+2]==TT_INT)?(HTREEITEM)Buda2[Arguments+2]:TVI_ROOT;
      if (Buda1[Arguments+3]==TT_INT)
        InsertAfter=(HTREEITEM)Buda2[Arguments+3];
      else if (Buda1[Arguments+3]==Definition[DF_FIRST])
        InsertAfter=TVI_FIRST;
      else if (Buda1[Arguments+3]==Definition[DF_LAST])
        InsertAfter=TVI_LAST;
      else
        InsertAfter=TVI_SORT;
      j=(DWORD)Temp->InsertItem(
         i, make_long(StringStore+Buda2[Arguments+4]), Buda2[Arguments+5], Buda2[Arguments+6], 
            0,0,Buda2[Arguments+4], Parent, InsertAfter);
      if (j==0)
        return(0);
      Buda1[Buda2[Arguments+1]]=TT_INT;
      Buda2[Buda2[Arguments+1]]=j;
      WILL_CLEAN(Buda2[Arguments+1]);
      }
      return(1);
     case 227:        // set_tree_icons
      {
        HICON hIcon;
        CImageList *pImgList=new CImageList;

        pImgList->Create(16,16,ILC_COLOR4 | ILC_MASK,3,0);
        for(i=0;i<3;i++)
        {
          hIcon=(HICON)LoadImage(NULL, 
              make_long(StringStore+Buda2[Arguments+i+1]), IMAGE_ICON, 0, 0, LR_LOADFROMFILE);
          pImgList->Add(hIcon);
        }
        if (Buda1[Arguments]!=TT_OBJ)
          ((CTreeCtrl*)pMainWindow)->SetImageList(pImgList, TVSIL_NORMAL);
        else
          ((CTreeCtrl*)ObjectStore[Buda2[Arguments]+2])->SetImageList(pImgList, TVSIL_NORMAL);
      }
      return(1);
     case 228:        // get_tree_length
      if (Buda1[Arguments]!=TT_OBJ)
        i=((CTreeCtrl*)pMainWindow)->GetCount();
      else
        i=((CTreeCtrl*)ObjectStore[Buda2[Arguments]+2])->GetCount();
      Buda1[Return]=TT_INT;
      Buda2[Return]=i;
      return(1);
     case 231:        // get_tree_item
      {
      CTreeCtrl *Temp;
      TV_ITEM Item;

      if (Buda1[Arguments]!=TT_OBJ)
        Temp=(CTreeCtrl*)pMainWindow;
      else
        Temp=(CTreeCtrl*)ObjectStore[Buda2[Arguments]+2];
      Item.mask=TVIF_HANDLE | TVIF_PARAM | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
      Item.hItem=(HTREEITEM)Buda2[Arguments+1];
      if (!(Temp->GetItem(&Item)))
        return(0);
      Buda1[Buda2[Arguments+2]]=TT_STR;
      Buda2[Buda2[Arguments+2]]=Item.lParam;
      WILL_CLEAN(Buda2[Arguments+2]);
      Buda1[Buda2[Arguments+3]]=TT_INT;
      Buda2[Buda2[Arguments+3]]=Item.iImage;
      WILL_CLEAN(Buda2[Arguments+3]);
      Buda1[Buda2[Arguments+4]]=TT_INT;
      Buda2[Buda2[Arguments+4]]=Item.iSelectedImage;
      WILL_CLEAN(Buda2[Arguments+4]);
      return(1);
      }
     case 232:        // set_tree_item
      {
      CTreeCtrl *Temp;

      if (Buda1[Arguments]!=TT_OBJ)
        Temp=(CTreeCtrl*)pMainWindow;
      else
        Temp=(CTreeCtrl*)ObjectStore[Buda2[Arguments]+2];
      i=0;
      if (Buda1[Arguments+2]==TT_STR)
        i|=TVIF_TEXT | TVIF_PARAM;
      if (Buda1[Arguments+3]==TT_INT)
        i|=TVIF_IMAGE;
      if (Buda1[Arguments+4]==TT_INT)
        i|=TVIF_SELECTEDIMAGE;
      if (Temp->SetItem( (HTREEITEM)Buda2[Arguments+1], i,
          make_long(StringStore+Buda2[Arguments+2]), Buda2[Arguments+3], Buda2[Arguments+4], 
            0,0,Buda2[Arguments+2]))
        return(1);
      return(0);
      }
     case 233:        // get_tree_selected
      if (Buda1[Arguments]!=TT_OBJ)
        Buda2[Return]=(DWORD)((CTreeCtrl*)pMainWindow)->GetSelectedItem();
      else
        Buda2[Return]=(DWORD)((CTreeCtrl*)ObjectStore[Buda2[Arguments]+2])->GetSelectedItem();
      if (Buda2[Return]==0)
        return(0);
      Buda1[Return]=TT_INT;
      return(1);
     case 234:        // delete_tree_item
      if (Buda1[Arguments]!=TT_OBJ)
        ((CTreeCtrl*)pMainWindow)->DeleteItem((HTREEITEM)Buda2[Arguments+1]);
      else
        ((CTreeCtrl*)ObjectStore[Buda2[Arguments]+2])->DeleteItem((HTREEITEM)Buda2[Arguments+1]);
      return(1);
     case 235:        // clean_the_tree
      if (Buda1[Arguments]!=TT_OBJ)
        ((CTreeCtrl*)pMainWindow)->DeleteAllItems();
      else
        ((CTreeCtrl*)ObjectStore[Buda2[Arguments]+2])->DeleteAllItems();
      return(1);
     case 236:        // tree_parent
      {
      CTreeCtrl *Temp;

      if (Buda1[Arguments]!=TT_OBJ)
        Temp=(CTreeCtrl*)pMainWindow;
      else
        Temp=(CTreeCtrl*)ObjectStore[Buda2[Arguments]+2];
      Buda2[Return]=(DWORD)Temp->GetParentItem((HTREEITEM)Buda2[Arguments+1]);
      if (Buda2[Return]==0)
        Buda1[Return]=Definition[DF_ROOT];
      else
        Buda1[Return]=TT_INT;
      }
      return(1);
     case 237:        // tree_child
      {
      CTreeCtrl *Temp;

      if (Buda1[Arguments]!=TT_OBJ)
        Temp=(CTreeCtrl*)pMainWindow;
      else
        Temp=(CTreeCtrl*)ObjectStore[Buda2[Arguments]+2];
      if (Buda1[Arguments+1]==TT_INT)
        Buda2[Return]=(DWORD)Temp->GetChildItem((HTREEITEM)Buda2[Arguments+1]);
      else
        Buda2[Return]=(DWORD)Temp->GetRootItem();
      if (Buda2[Return]==0)
        return(0);
      Buda1[Return]=TT_INT;
      }
      return(1);
     case 238:        // tree_next_brother
      {
      CTreeCtrl *Temp;

      if (Buda1[Arguments]!=TT_OBJ)
        Temp=(CTreeCtrl*)pMainWindow;
      else
        Temp=(CTreeCtrl*)ObjectStore[Buda2[Arguments]+2];
      Buda2[Return]=(DWORD)Temp->GetNextSiblingItem((HTREEITEM)Buda2[Arguments+1]);
      if (Buda2[Return]==0)
        return(0);
      Buda1[Return]=TT_INT;
      }
      return(1);
     case 145:        // insert_list_item
      {
      CListCtrl *Temp;

      if (Buda1[Arguments]!=TT_OBJ)
        Temp=(CListCtrl*)pMainWindow;
      else
        Temp=(CListCtrl*)ObjectStore[Buda2[Arguments]+2];
      i=(Buda1[Arguments+1]!=TT_INT)?Temp->GetItemCount():Buda2[Arguments+1]; //Definition[DF_END]
      if (Buda1[Arguments+3]==TT_INT)
        Temp->InsertItem( i, make_long(StringStore+Buda2[Arguments+2]), Buda2[Arguments+3]);
      else
        Temp->InsertItem( i, make_long(StringStore+Buda2[Arguments+2]));
      Temp->SetItemData( i, Buda2[Arguments+2]);
      }
      return(1);
     case 146:        // get_list_text
      if (Buda1[Arguments]!=TT_OBJ)
        i=((CListCtrl*)pMainWindow)->GetItemData(Buda2[Arguments+1]);
      else
        i=((CListCtrl*)ObjectStore[Buda2[Arguments]+2])->GetItemData(Buda2[Arguments+1]);
      Buda1[Return]=TT_STR;
      Buda2[Return]=i;
      return(1);
     case 224:        // get_list_length
      if (Buda1[Arguments]!=TT_OBJ)
        i=((CListCtrl*)pMainWindow)->GetItemCount();
      else
        i=((CListCtrl*)ObjectStore[Buda2[Arguments]+2])->GetItemCount();
      Buda1[Return]=TT_INT;
      Buda2[Return]=i;
      return(1);
     case 147:        // get_list_selected
      if (Buda1[Arguments]!=TT_OBJ)
        Buda2[Return]=((CListCtrl*)pMainWindow)->GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
      else
        Buda2[Return]=((CListCtrl*)ObjectStore[Buda2[Arguments]+2])->GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
      Link[sv_subv++]= Buda2[Return];
      if (Buda2[Return]==M1)
        return(0);
      Buda1[Return]=TT_INT;
      return(1);
     case 437:        // get_list_selected
      if (Link[sv_subv-1]==M1)
      {
        sv_subv--;
        return(0);
      }
      if (Buda1[Arguments]!=TT_OBJ)
        Buda2[Return]=((CListCtrl*)pMainWindow)->GetNextItem(Link[sv_subv-1], LVNI_ALL | LVNI_SELECTED);
      else
        Buda2[Return]=((CListCtrl*)ObjectStore[Buda2[Arguments]+2])->GetNextItem(Link[sv_subv-1], LVNI_ALL | LVNI_SELECTED);
      if (Buda2[Return]==M1)
      {
        sv_subv--;
        return(0);
      }
      Link[sv_subv-1]= Buda2[Return];
      Buda1[Return]=TT_INT;
      return(1);
     case 208:        // delete_list_item
      if (Buda1[Arguments]!=TT_OBJ)
        ((CListCtrl*)pMainWindow)->DeleteItem(Buda2[Arguments+1]);
      else
        ((CListCtrl*)ObjectStore[Buda2[Arguments]+2])->DeleteItem(Buda2[Arguments+1]);
      return(1);
     case 150:        // clean_the_list
      if (Buda1[Arguments]!=TT_OBJ)
        ((CListCtrl*)pMainWindow)->DeleteAllItems();
      else
        ((CListCtrl*)ObjectStore[Buda2[Arguments]+2])->DeleteAllItems();
      return(1);
     case 210:        // set_list_icons
      {
        HICON hIcon;
        CImageList *pImgList=new CImageList;

        if (Buda1[Arguments+1]==TT_C_S) // s - small icons
        {
          pImgList->Create(16,16,ILC_COLOR4 | ILC_MASK,3,0);
          k=LVSIL_SMALL;
        }
        else
        {
          pImgList->Create(32,32,ILC_COLOR4 | ILC_MASK,3,0);
          k=LVSIL_NORMAL;
        }
        for(i=0;i<3;i++)
        {
          hIcon=(HICON)LoadImage(NULL, 
              make_long(StringStore+Buda2[Arguments+i+2]), IMAGE_ICON, 0, 0, LR_LOADFROMFILE);
          pImgList->Add(hIcon);
        }
        if (Buda1[Arguments]!=TT_OBJ)
          ((CListCtrl*)pMainWindow)->SetImageList( pImgList, k);
        else
          ((CListCtrl*)ObjectStore[Buda2[Arguments]+2])->SetImageList( pImgList, k);
      }
      return(1);
     case 211:        // add_list_column
      {
      CListCtrl *Temp;

      if (Buda1[Arguments]!=TT_OBJ)
        Temp=(CListCtrl*)pMainWindow;
      else
        Temp=(CListCtrl*)ObjectStore[Buda2[Arguments]+2];
      i=(Buda1[Arguments+1]!=TT_INT)?Temp->GetItemCount():Buda2[Arguments+1]; //Definition[DF_END]
      
      Temp->InsertColumn( i, make_long(StringStore+Buda2[Arguments+2]), LVCFMT_LEFT, Buda2[Arguments+3], -1 );
      }
      return(1);
     case 271:        // set_list_label
      {
      CListCtrl *Temp;

      if (Buda1[Arguments]!=TT_OBJ)
        Temp=(CListCtrl*)pMainWindow;
      else
        Temp=(CListCtrl*)ObjectStore[Buda2[Arguments]+2];
      Temp->SetItemText( Buda2[Arguments+1], Buda2[Arguments+2], make_long(StringStore+Buda2[Arguments+3]) );
      if (Buda2[Arguments+2]==0) // main
        Temp->SetItemData( Buda2[Arguments+1], Buda2[Arguments+3]);
      }
      return(1);
     case 209:        // change_style
      if (Buda1[Arguments]!=TT_OBJ)
      {
        i=GetWindowLong(((CWnd*)pMainWindow)->m_hWnd, GWL_STYLE);
        SetWindowLong(((CWnd*)pMainWindow)->m_hWnd, GWL_STYLE,
          ((i^Buda2[Arguments+1])&(Buda2[Arguments+2]^M1))|Buda2[Arguments+3]);
      }
      else
      {
        i=GetWindowLong(((CWnd*)ObjectStore[Buda2[Arguments]+2])->m_hWnd, GWL_STYLE);
        SetWindowLong(((CWnd*)ObjectStore[Buda2[Arguments]+2])->m_hWnd, GWL_STYLE,
          ((i^Buda2[Arguments+1])&(Buda2[Arguments+2]^M1))|Buda2[Arguments+3]);
      }
      return(1);
     case 152:        // modify_menu
     {
      HMENU hTempMenu=NULL;
      MENUITEMINFO MenuItemInfo;
      
      if (Buda1[Arguments]==TT_OBJ)
      {
        if (SUBTYPE(ObjectStore[Buda2[Arguments]],CLASS_SYSTEM_MENU))
          hTempMenu=(HMENU)ObjectStore[Buda2[Arguments]+2];
        else if (SUBTYPE(ObjectStore[Buda2[Arguments]],C_S_WIN_Main))
          hTempMenu=((C_FrameWnd *)ObjectStore[Buda2[Arguments]+2])->GetMenu()->m_hMenu;
        else
          return(error_func3(Arguments,p_line,0,CLASS_SYSTEM_MENU,C_S_WIN_Main));
      }
      else if (MainMenu)
        hTempMenu=MainMenu;
      else if (pMain_Frame)
        hTempMenu=((C_FrameWnd *)ObjectStore[(pMain_Frame->m_Number)+2])->GetMenu()->m_hMenu;
      
      if (hTempMenu==NULL)
        return(0);
      i=MF_BYPOSITION;
      MenuItemInfo.cbSize=sizeof(MENUITEMINFO); // ?
      MenuItemInfo.fMask=0;
      if (Buda1[Arguments+3]==TT_STR)
      {
        MenuItemInfo.fMask|=MIIM_TYPE;
        MenuItemInfo.fType=MFT_STRING;
        MenuItemInfo.dwTypeData=make_long(StringStore+Buda2[Arguments+3]);
        MenuItemInfo.cch=my_strlen(make_long(StringStore+Buda2[Arguments+3]));
      }
      if (Buda1[Arguments+2]!=TT_LINK)
      {
        if (Buda1[Arguments+2]==Definition[DF_RIGHT])   // rightjustify
          MenuItemInfo.fType|=MFT_RIGHTJUSTIFY;
        else
        {
          MenuItemInfo.fMask|=MIIM_STATE;
          if (Buda1[Arguments+2]==Definition[DF_NORMAL])       // normal
            MenuItemInfo.fState=MFS_ENABLED; 
          else if (Buda1[Arguments+2]==Definition[DF_CHECKED]) // checked
            MenuItemInfo.fState=MFS_ENABLED | MF_CHECKED; 
          else if (Buda1[Arguments+2]==Definition[DF_GRAYED])  // grayed
            MenuItemInfo.fState=MF_GRAYED;
          else   
            return(0);
        }
      }
      SetMenuItemInfo( hTempMenu, Buda2[Arguments+1]-1, TRUE, &MenuItemInfo);
      return(1);
     }
     case 190:        // draw_menu_bar
      if (Buda1[Arguments]==TT_OBJ)
      {
        CHECK_TYPE(0,C_S_WIN_Main)
        DrawMenuBar( ((CWnd*)ObjectStore[Buda2[Arguments]+2])->m_hWnd);
      }
      else
        DrawMenuBar( ((pMainWindow==NULL)?pMain_Frame:pMainWindow)->m_hWnd);
      return(1);
     case 177:        // first_child
      {
      CWnd *pWindow;
      Buda1[Return]=TT_OBJ;
      if (Buda1[Arguments]==TT_OBJ)
        pWindow=((CWnd*)ObjectStore[Buda2[Arguments]+2])->GetWindow(GW_CHILD);
      else
        pWindow=((pMainWindow==NULL)?pMain_Frame:pMainWindow)->GetWindow(GW_CHILD);
      if (pWindow==NULL)
      {
        Buda1[Return]=TT_INT;
        Buda2[Return]=0;
        return(1);
      }
      if (pWindow->IsKindOf(RUNTIME_CLASS(C_FrameWnd)))
        Buda2[Return]=((C_FrameWnd*)pWindow)->m_Number;
      else
        Buda2[Return]=pWindow->GetDlgCtrlID();
      return(1);
      }//for def
     case 178:        // last_child
      {
      CWnd *pWindow;
      Buda1[Return]=TT_OBJ;
      if (Buda1[Arguments]==TT_OBJ)
        pWindow=((CWnd*)ObjectStore[Buda2[Arguments]+2])->GetWindow(GW_CHILD)->GetWindow(GW_HWNDLAST);
      else
        pWindow=((pMainWindow==NULL)?pMain_Frame:pMainWindow)->GetWindow(GW_CHILD)->GetWindow(GW_HWNDLAST);
      if (pWindow==NULL)
      {
        Buda1[Return]=TT_INT;
        Buda2[Return]=0;
        return(1);
      }
      if (pWindow->IsKindOf(RUNTIME_CLASS(C_FrameWnd)))
        Buda2[Return]=(DWORD)((C_FrameWnd*)pWindow)->m_Number;
      else
        Buda2[Return]=(DWORD)pWindow->GetDlgCtrlID();
      return(1);
      }//for def
     case 179:        // next_child
      {
      CWnd *pWindow;
      Buda1[Return]=TT_OBJ;
      if (Buda1[Arguments]==TT_OBJ)
        pWindow=((CWnd*)ObjectStore[Buda2[Arguments]+2])->GetWindow(GW_HWNDNEXT);
      else
        pWindow=((pMainWindow==NULL)?pMain_Frame:pMainWindow)->GetWindow(GW_HWNDNEXT);
      if (pWindow==NULL)
      {
        Buda1[Return]=TT_INT;
        Buda2[Return]=0;
        return(1);
      }
      if (pWindow->IsKindOf(RUNTIME_CLASS(C_FrameWnd)))
        Buda2[Return]=(DWORD)((C_FrameWnd*)pWindow)->m_Number;
      else
        Buda2[Return]=(DWORD)pWindow->GetDlgCtrlID();
      return(1);
      }//for def
     case 180:        // previous_child
      {
      CWnd *pWindow;
      Buda1[Return]=TT_OBJ;
      if (Buda1[Arguments]==TT_OBJ)
        pWindow=((CWnd*)ObjectStore[Buda2[Arguments]+2])->GetWindow(GW_HWNDPREV);
      else
        pWindow=((pMainWindow==NULL)?pMain_Frame:pMainWindow)->GetWindow(GW_HWNDPREV);
      if (pWindow==NULL)
      {
        Buda1[Return]=TT_INT;
        Buda2[Return]=0;
        return(1);
      }
      if (pWindow->IsKindOf(RUNTIME_CLASS(C_FrameWnd)))
        Buda2[Return]=(DWORD)((C_FrameWnd*)pWindow)->m_Number;
      else
        Buda2[Return]=(DWORD)pWindow->GetDlgCtrlID();
      return(1);
      }//for def
     case 181:        // active_child
      {
      CWnd *pWindow;
      Buda1[Return]=TT_OBJ;
      if (Buda1[Arguments]==TT_OBJ)
        pWindow=((CWnd*)ObjectStore[Buda2[Arguments]+2])->GetFocus();
      else
        pWindow=((pMainWindow==NULL)?pMain_Frame:pMainWindow)->GetFocus();
      if (pWindow==NULL)
      {
        Buda1[Return]=TT_INT;
        Buda2[Return]=0;
        return(1);
      }
      if (pWindow->IsKindOf(RUNTIME_CLASS(C_FrameWnd)))
        Buda2[Return]=(DWORD)((C_FrameWnd*)pWindow)->m_Number;
      else
        Buda2[Return]=(DWORD)pWindow->GetDlgCtrlID();
      return(1);
      }//for def
     case 205:        // set_focus
      if (Buda1[Arguments]==TT_OBJ)
        ((CWnd*)ObjectStore[Buda2[Arguments]+2])->SetFocus();
      else
        ((pMainWindow==NULL)?pMain_Frame:pMainWindow)->SetFocus();
      return(1);
     case 194:        // child_from_point
      {
      CWnd *pWindow;
      POINT Point;

      Buda1[Return]=TT_OBJ;
      Point.x=Buda2[Arguments+1];
      Point.y=Buda2[Arguments+2];
      if (Buda1[Arguments]==TT_OBJ)
        pWindow=((CWnd*)ObjectStore[Buda2[Arguments]+2])->ChildWindowFromPoint(Point);
      else
        pWindow=((pMainWindow==NULL)?pMain_Frame:pMainWindow)->ChildWindowFromPoint(Point);
      if (pWindow==NULL)
      {
        Buda1[Return]=TT_INT;
        Buda2[Return]=0;
        return(1);
      }
      if (pWindow->IsKindOf(RUNTIME_CLASS(C_FrameWnd)))
        Buda2[Return]=(DWORD)((C_FrameWnd*)pWindow)->m_Number;
      else
        Buda2[Return]=(DWORD)pWindow->GetDlgCtrlID();
      return(1);
      }//for def
     case 37:        // parent window
      {
      CWnd *pWindow;
      Buda1[Return]=TT_OBJ;
      if (Buda1[Arguments]==TT_OBJ)
        pWindow=((CWnd*)ObjectStore[Buda2[Arguments]+2])->GetParent();
      else
        pWindow=((pMainWindow==NULL)?pMain_Frame:pMainWindow)->GetParent();
      if (pWindow==NULL)
      {
        Buda1[Return]=TT_INT;
        Buda2[Return]=0;
        return(1);
      }
      if (pWindow->IsKindOf(RUNTIME_CLASS(C_FrameWnd)))
        Buda2[Return]=(DWORD)((C_FrameWnd*)pWindow)->m_Number;
      else
        Buda2[Return]=(DWORD)pWindow->GetDlgCtrlID();
      return(1);
      }//for def
     case 39:         // Update window
      if (Buda1[Arguments]==TT_OBJ)
        i=Buda2[Arguments];
      else if (pMain_Frame) 
        i=pMain_Frame->m_Number;
      else
        return(0);
      if (Buda1[Arguments+1]==TT_INT && Buda1[Arguments+2]==TT_INT && Buda1[Arguments+3]==TT_INT && Buda1[Arguments+4]==TT_INT)
	    {
          CRect UpdateRect(Buda2[Arguments+1],Buda2[Arguments+2],Buda2[Arguments+3],Buda2[Arguments+4]);
          ((CWnd*)ObjectStore[i+2])->InvalidateRect(UpdateRect, (ObjectStore[i+4]&24)==8); // clean_before_paint
	    }
	    else
        ((CWnd*)ObjectStore[i+2])->InvalidateRect(NULL, (ObjectStore[i+4]&24)==8); // clean_before_paint
      status_fl |= 1024;   // from_update_window
      return(1);
     case 408:        // from_update_window
      return((status_fl&1024)!=0);
     case 423:        // set_flags // za remont!
     case 424:        // get_flag  // za remont!
      if (Buda1[Arguments]==TT_OBJ)
      {
        i=Buda2[Arguments];
      }
      else if (pMain_Frame) 
        i=pMain_Frame->m_Number;
      if (p_line==423)  // set_flags
      {
        set_the_flag(8,Buda2[Arguments+1],ObjectStore[i+4])
        set_the_flag(16,Buda2[Arguments+1],ObjectStore[i+4])
        return(1);
      }
      if (Buda2[Arguments+1]&(8<<16))
        return(((Buda2[Arguments+1]&8)^(ObjectStore[i+4]&8))==0);
      if (Buda2[Arguments+1]&(16<<16))
        return(((Buda2[Arguments+1]&16)^(ObjectStore[i+4]&16))==0);
      return(0);
     case 396:        // Scroll window
      {
      CWnd *pWindow;
      if (Buda1[Arguments]==TT_OBJ)
        pWindow=((CWnd*)ObjectStore[Buda2[Arguments]+2]);
      else
        pWindow=((pMainWindow==NULL)?pMain_Frame:pMainWindow);
      if (pWindow==NULL)
      {
        Buda2[Return]=0;
        return(1);
      }
      pWindow->ScrollWindow(Buda2[Arguments+1], Buda2[Arguments+2]);
      if (Buda1[Arguments+3]!=TT_INT || Buda2[Arguments+3])
        pWindow->UpdateWindow();
      return(1);
      }
     case 422:        // is_rect_in_paint
     case 397:        // get_paint_rect
      {
        if(G_rectPaint.IsRectEmpty())
          return(0);
        for (k=2; k<4; k++)
        {
          if (Buda1[Arguments+k]!=TT_LINK && Buda1[Arguments+k]!=TT_INT && Buda1[Arguments+k]!=Definition[DF_MAX])
            return(error_why(p_line, k, " is a term which is different from \"max\".\r\n"));
        }
        if (Buda1[Arguments+2]==Definition[DF_MAX] || Buda1[Arguments+3]==Definition[DF_MAX])
        {
          WINDOWINFO wi;
          
          if (pMainWindow->GetWindowInfo(&wi)==0) // pMainWindow is it OK?
            return(0);
          i=wi.rcClient.right-wi.rcClient.left;
          j=wi.rcClient.bottom-wi.rcClient.top;
          if (p_line==397)    // get_paint_rect
          {
            if (Buda1[Arguments+2]==Definition[DF_MAX] && i!=G_rectPaint.right)
              return(0);
            if (Buda1[Arguments+3]==Definition[DF_MAX] && j!=G_rectPaint.bottom)
              return(0);
          }
          else
          {
            if (Buda1[Arguments+2]!=Definition[DF_MAX])
              i=Buda2[Arguments+2];
            if (Buda1[Arguments+3]!=Definition[DF_MAX])
              j=Buda2[Arguments+3];
          }
        }
        else if (p_line==422)  // is_rect_in_paint
        {
          i=Buda2[Arguments+2];
          j=Buda2[Arguments+3];
        }
        if (p_line==422)  // is_rect_in_paint
        {
          if (G_rgnPaint.RectInRegion(&CRect((int)Buda2[Arguments], (int)Buda2[Arguments+1], (int)i, (int)j)))
            return(1);
          else
            return(0);
        }
        else
          return( return_and_check_value_4(Arguments, G_rectPaint.left, Arguments+1, G_rectPaint.top,
                                        Arguments+2, G_rectPaint.right, Arguments+3, G_rectPaint.bottom) );
      }
     case 398:        // message_flags
      Buda1[Return]=TT_INT;
      Buda2[Return]=G_FlagsMes;
      return(1);
     case 399:        // message_flags
      j=Buda1[Arguments];
      if (j==Definition[DF_LEFT])
        i=G_FlagsMes&1; // MK_LBUTTON
      else if (j==Definition[DF_RIGHT])
        i=G_FlagsMes&2; // MK_RBUTTON
      else if (j==Definition[DF_SHIFT])
        i=G_FlagsMes&4; // MK_SHIFT
      else if (j==Definition[DF_CTRL])
        i=G_FlagsMes&8; // MK_CONTROL
      else if (j==Definition[DF_MIDDLE])
        i=G_FlagsMes&0x10; // MK_MBUTTON
      else if (j==Definition[DF_ALT])
        i=G_FlagsMes&0x2000; // Alt  // not working
      else if (j==Definition[DF_FUNCTION])
        i=G_FlagsMes&0x100; // function key 
      else if (j==Definition[DF_BEFORE])
        i=G_FlagsMes&0x4000; // Previous key state 
      else if (j==Definition[DF_STATE])
        i= ~(G_FlagsMes&0x8000); // Transition state
      else
      {
        MitiText("Error: You specified a wrong flag in \"message_flags\" predicate.\r\n", &cf_red);
        return(0);
      } 
      if (i)
        return(1);
      else
        return(0);
     case 40:        // Press button
      {
        POINT Point;
        CWnd*  pWindowMain;
        CWnd*  pWindow;

        if (Buda1[Arguments]==TT_OBJ)
        {
          if (ObjectStore[Buda2[Arguments]+2])
            pWindowMain=((CWnd*)ObjectStore[Buda2[Arguments]+2]);
          else
            return 0;
        }
        else if (pMain_Frame)
          pWindowMain=pMain_Frame;
        else
          return 0;
        Point.x=Buda2[Arguments+1];
        Point.y=Buda2[Arguments+2];
        pWindow=pWindowMain->ChildWindowFromPoint(Point);
        if (pWindow)
        {
          if (pWindow->IsKindOf(RUNTIME_CLASS(CButton)))
          {
            //status_fl|=4; // maybe we do not need this
            pWindowMain->SendMessage(WM_COMMAND,
                               (WPARAM)pWindow->GetDlgCtrlID(), (LPARAM)pWindow->m_hWnd);
            //status_fl&=M1^4;
          }
        }
        return(1);
      }
     case 195:        // get_clipboard_data
      {
      DWORD ch_set2=Buda2[Arguments];
      k=0;
      
      if (ch_set2>CHAR_SETS)
      {
        MitiText("Error: No such charset.\r\n", &cf_red);
        return(0);
      }
      if (ch_set2==0)
        ch_set2=(ch_set?ch_set:2);
      if (OpenClipboard(NULL)==0)
      {
        // handle the error
E8:     MitiText("Cannot read from the clipboard.\r\n");
E14:    CloseClipboard(); 
E13:    DWORD theerr = GetLastError();
        FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL,theerr,0,string3,L_BUFER,NULL);
        MitiText(make_utf8(string3));
        return(error_Runtime(0));
      }
      MY_HANDLE hTemp=GetClipboardData(CF_UNICODETEXT);
      j=sv_StStore;
      if (hTemp!=NULL)
      {
        BYTE *Str=(BYTE *)GlobalLock(hTemp);
        DWORD str_len=wcslen((wchar_t *)Str);
        if (ch_set==0)
          str_len=6*str_len;
        if ((sv_StStore+=str_len)>=STRING_STORE && correct_STR_ST() )
          goto FULL;
        i=ChangeCharset(64, ch_set, Str, StringStore+j, &kk, default_char, str_len+1); // +1?
        sv_StStore=j+i+1;
        GlobalUnlock(hTemp);
      }
      if (hTemp==NULL || k>0)
      {
        hTemp=GetClipboardData(CF_TEXT);
        if (hTemp!=NULL)
        {
          BYTE *Str=(BYTE *)GlobalLock(hTemp);
          DWORD str_len=strlen((LPSTR)Str);
          if (ch_set==0)
            str_len=3*str_len;
          if ((sv_StStore+=str_len)>=STRING_STORE && correct_STR_ST() )
            goto FULL;
          i=ChangeCharset(ch_set2, ch_set, Str, StringStore+j, &kk, default_char, str_len+1);
          sv_StStore=j+i+1;
          GlobalUnlock(hTemp);
        }
        else if (k==0)
        {
          sv_StStore=j;
          goto E8;
        }
      }
      CloseClipboard();
      Buda1[Return]=TT_STR;
      if (i)
      {
        Buda2[Return]=j;
        sv_StStore=j+i+1;
      }
      else
      {
        sv_StStore=j;
        Buda2[Return]=0;
      }
      return(1);
      }//for def
     case 196:        // set_clipboard_data
      {
      DWORD ch_set2=Buda2[Arguments+1];
      DWORD str_len=strlen((LPSTR)(StringStore+Buda2[Arguments]));
      
      if (ch_set2>CHAR_SETS)
      {
        MitiText("Error: No such charset.\r\n", &cf_red);
        return(0);
      }
      if (ch_set2==0)
        ch_set2=(ch_set?ch_set:2);
      if (OpenClipboard(NULL)==0 || EmptyClipboard()==0)
      {
        // handle the error
E9:     MitiText("Cannot write in the clipboard.\r\n");
        goto E14;
      }
      MY_HANDLE hTemp=GlobalAlloc(GMEM_MOVEABLE, 2*str_len+2);
      ChangeCharset(ch_set, 64, StringStore+Buda2[Arguments], (BYTE *)GlobalLock(hTemp), &kk, default_char, 2*str_len);
      GlobalUnlock(hTemp);
      if (SetClipboardData(CF_UNICODETEXT, hTemp)==NULL)
        goto E9;
      MY_HANDLE hTemp2=GlobalAlloc(GMEM_MOVEABLE, str_len+1);
      ChangeCharset(ch_set, ch_set2, StringStore+Buda2[Arguments], (BYTE *)GlobalLock(hTemp2), &kk, default_char, str_len);
      GlobalUnlock(hTemp2);
      if (SetClipboardData(CF_TEXT, hTemp2)==NULL)
        goto E9;
      CloseClipboard();
      GlobalFree(hTemp);
      GlobalFree(hTemp2);
      return(1);
      }//for def
     case 41:        // Select file
      // don't calc immediately these predicates
      {
        OPENFILENAME of;

        memset(&of, '\0', sizeof(OPENFILENAME));
        of.lStructSize  = sizeof(OPENFILENAME);
        CWnd* pWinTemp=(pMain_Frame)?(CWnd*)pMain_Frame:(CWnd*)pMainFrame;
        of.hwndOwner    = pWinTemp->m_hWnd;       // NULL
#ifdef UNICODE
        _TCHAR string4[1024];
        _TCHAR string5[512];
        if (Buda1[Arguments+2]==TT_STR)
        {
          ChangeCharset(ch_set, 64, StringStore+Buda2[Arguments+2], (BYTE *)string3, &kk, default_char);
          for(i=p=0, n=my_strlen(string3); i<n; i++)
            if (string3[i]=='0' && i && string3[i-1]=='\\')
              string4[p-1]=0;
            else
              string4[p++]=string3[i];
          string4[p]=string4[p+1]=0;
          of.lpstrFilter  =string4;
#else
        if (Buda1[Arguments+2]==TT_STR)
        {
          strcpy(string2, (LPSTR)(StringStore+Buda2[Arguments+2]));
          for(i=p=0, n=strlen((LPSTR)string2); i<n; i++)
            if (string2[i]=='0' && i && string2[i-1]=='\\')
              string2[p-1]=0;
            else
              string2[p++]=string2[i];
          string2[p]=string2[p+1]=0;
          of.lpstrFilter  =string2;
#endif
        }
        else
          of.lpstrFilter  = _T("All Files (*.*)\0*.*\0");
        of.lpstrCustomFilter = NULL;
        of.nFilterIndex = 1;
        of.nMaxFile     = L_BUFER;
        of.lpstrInitialDir = NULL;
        if (Buda1[Arguments+1]==TT_STR)
        {
#ifdef UNICODE
          ChangeCharset(ch_set, 64, StringStore+Buda2[Arguments+1], (BYTE *)string5, &kk, default_char);
          of.lpstrTitle   = string5;
#else
          of.lpstrTitle   = make_long(StringStore+Buda2[Arguments+1]);
#endif
        }
        else
          of.lpstrTitle   = NULL;
        string3[0]=0;
        of.lpstrFile    = string3;
        of.lpstrDefExt  = NULL;

        if (Buda1[Arguments]==TT_C_O)           // o
        {
          of.Flags        = OFN_HIDEREADONLY|OFN_FILEMUSTEXIST;
          if(!GetOpenFileName(&of))
            return(0);
        }
        else if (Buda1[Arguments]==TT_C_S) // s
        {
          of.Flags        = OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
          if(!GetSaveFileName(&of))
            return(0);
        }
        else
          return(0);
        Buda1[Return]=TT_STR;
        i=ChangeCharset(M64_ch, ch_set, (BYTE *)string3, StringStore+sv_StStore, &kk, default_char);
        Buda2[Return]=sv_StStore;
        if (i)
        {
          if ((sv_StStore+=i+1)>=STRING_STORE && correct_STR_ST() )
            goto FULL;
        }
        else
          Buda2[Return]=0;
        return(1);  
      }
     case 53:        // Cursor
     {
     LPTSTR i;
     
      switch (Buda1[Arguments])
      {
       case TT_C_QUESTION:  // ? Standard arrow and small hourglass 
        i=IDC_APPSTARTING;
        break;
       case TT_C_C:  // c Crosshair
        i=IDC_CROSS;
        break;
       case TT_C_H:  // h Hand
        i=IDC_HAND;
        break;
       case TT_C_T:  // t Text I-beam
        i=IDC_IBEAM;
        break;
       case TT_C_O:  // o Slashed circle
        i=IDC_NO;
        break;
       case TT_C_X:  // x Four-pointed arrow
        i=IDC_SIZEALL;
        break;
       case TT_C_N:  // n Double-pointed arrow pointing northeast and southwest
        i=IDC_SIZENESW;
        break;
       case TT_C_D:  // d Double-pointed arrow pointing north and south
        i=IDC_SIZENS;
        break;
       case TT_C_U:  // u Double-pointed arrow pointing northwest and southeast
        i=IDC_SIZENWSE;
        break;
       case TT_C_CUT:  // ! Double-pointed arrow pointing west and east
        i=IDC_SIZEWE;
        break;
       case TT_C_V:  // v Vertical arrow
        i=IDC_UPARROW;
        break;
       case TT_C_W:  // w Hourglass
        i=IDC_WAIT;
        break;
       default:
        i=IDC_ARROW; // Standard arrow
      }
      SetCursor(LoadCursor(NULL, i));
      return(1);
     }
     case 60:        // system_color
      if (Buda1[Arguments]==Definition[DF_WINDOW])  // window
        Buda2[Return]=GetSysColor(COLOR_WINDOW);
      else if (Buda1[Arguments]==Definition[DF_MENU])  // menu
        Buda2[Return]=GetSysColor(COLOR_MENU);
      else if (Buda1[Arguments]==Definition[DF_DIALOG])  // dialog
        Buda2[Return]=GetSysColor(COLOR_3DFACE);
      else
        return(0);
      Buda1[Return]=TT_INT;
      return(1);
	   case 386:         // embed_server
   //case 174:         // bitmap_button
     case 138:         // check box
     case 173:         // radio button
     case 175:         // group_box
   //case 176:         // tool_tip
     case 143:         // List Box
     case 225:         // Tree Box
     case 242:         // window
   //case 243:         // dialog
     case 244:         // button
     case 245:         // static
     case 246:         // edit
     case 438:         // slider
     case 247:         // bitmap
     case 248:         // icon
     case 249:         // animate
     case 250:         // menu
     {
      CWnd* OldWindow;
      C_FrameWnd* OldWindow_Frame;
      HMENU OldMenu;
      DWORD def_flags;
      DWORD flag;

      if (Buda1[Arguments+2]>=MEMORY_c256
                               || (Buda1[Arguments+2]<TT_START && Buda1[Arguments+2]>TT_LINK))
      {
        MitiText("The name of message function is bad.\r\n");        
        return(error_Runtime(1));
      }
      OldMenu=MainMenu;
      if (Buda1[Arguments+1]==TT_OBJ)
      {
        if (SUBTYPE(ObjectStore[Buda2[Arguments+1]],C_S_WIN_Main))
          OldWindow_Frame=pMain_Frame=(C_FrameWnd*)ObjectStore[Buda2[Arguments+1]+2];
        else
        {
          MitiText("The parent should be window.\r\n");        
          return(error_Runtime(1));
        }
      }
      else
        OldWindow_Frame=NULL;
      t=(Buda1[Arguments+4]==TT_INT)?Buda2[Arguments+4]:30;
      m=(Buda1[Arguments+5]==TT_INT)?Buda2[Arguments+5]:30;
      n=(Buda1[Arguments+6]==TT_INT)?Buda2[Arguments+6]:200;
      k=(Buda1[Arguments+7]==TT_INT)?Buda2[Arguments+7]:100;
      ObjectStore[ObjectStore_br+1]=M1;  // object name
      if (Buda1[Arguments+2]==TT_LINK)
        ObjectStore[ObjectStore_br+3]=Definition[DF_FALSE];
      else
        ObjectStore[ObjectStore_br+3]=Buda1[Arguments+2];// ms_function;
      ObjectStore[ObjectStore_br+4]=0;              // flags
      ObjectStore[ObjectStore_br+5]=0;              // father win
      ObjectStore[ObjectStore_br+6]=ObjectStore[ObjectStore_br+9]= (DWORD)((p_line==242 && Buda1[Arguments+11]==TT_INT)?
         CreateSolidBrush(Buda2[Arguments+11]):hbrGreen);      // window brush
      ObjectStore[ObjectStore_br+7]=RGB(0, 0, 0);              // text color
      ObjectStore[ObjectStore_br+8]=GetSysColor(COLOR_WINDOW); // backgraund text color
      flag=0; // not window and not animate
      switch (p_line)
      {
       case 242:  // window
       // don't calc immediately these predicates

      // flags HALF   
       //       0x8000 the overlaping brus is bitmap
       
       //    *   8     clean_before_paint
       //      0x10    paint_indirectly
       //      0x20    h_scroll
       //      0x40    v_scroll
       //    * 0x80    title
       //    * 0x100   sys_menu
       //      0x200   border
       //    * 0x400   thick_frame
       //      0x800   double_clicks
        {
        HICON hIcon;
        HCURSOR hCursor;
        DWORD cs_Styles= 0;
        DWORD Styles= WS_POPUP | WS_OVERLAPPED;
        def_flags=0x588;
        i=0;
        if (if_the_flag(8, def_flags, Buda2[Arguments+8]))
          i|=8;
        if (if_the_flag(0x10, def_flags, Buda2[Arguments+8]))
          i|=0x10;
        if (if_the_flag(0x20, def_flags, Buda2[Arguments+8]))
          Styles|=WS_HSCROLL;
        if (if_the_flag(0x40, def_flags, Buda2[Arguments+8]))
          Styles|=WS_VSCROLL;
        if (if_the_flag(0x80, def_flags, Buda2[Arguments+8]))
          Styles|=WS_CAPTION;
        if (if_the_flag(0x100, def_flags, Buda2[Arguments+8]))
          Styles|=WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX;
        if (if_the_flag(0x200, def_flags, Buda2[Arguments+8]))
          Styles|=WS_BORDER;
        if (if_the_flag(0x400, def_flags, Buda2[Arguments+8]))
          Styles|=WS_THICKFRAME;
        if (if_the_flag(0x800, def_flags, Buda2[Arguments+8]))
          cs_Styles|=CS_DBLCLKS;
        ObjectStore[ObjectStore_br+4]=i;              // flags
        if (Buda1[Arguments+9]==TT_STR)
          hIcon=((HICON)LoadImage(NULL, 
              make_long(StringStore+Buda2[Arguments+9]), IMAGE_ICON, 0, 0, LR_LOADFROMFILE));
        else
          switch(Buda1[Arguments+9])
          {
           case TT_C_QUESTION:  // ? SystemQuestion 
            hIcon=theApp.LoadStandardIcon(IDI_QUESTION);
            break;
           case TT_C_A:  // a AplicationDefault
            hIcon=theApp.LoadStandardIcon(IDI_APPLICATION);
            break;
           case TT_C_N:  // n no icon
            hIcon=NULL;
            break;
           case TT_C_CUT:  // ! SystemExclamation
            hIcon=theApp.LoadStandardIcon(IDI_EXCLAMATION);
            break;
           case TT_C_I:  // i SystemAsterisk
            hIcon=theApp.LoadStandardIcon(IDI_ASTERISK);
            break;
           case TT_C_S:  // s SystemHand
            hIcon=theApp.LoadStandardIcon(IDI_HAND);
            break;
           default: // Standard Prolog Icon
            if (Buda1[Arguments+1]==TT_OBJ)
              hIcon=theApp.LoadIcon(IDI_DIALOG);
            else
              hIcon=theApp.LoadIcon(IDR_ProjectTYPE);
          }
        if (Buda1[Arguments+10]==TT_STR)
          hCursor=((HCURSOR)LoadImage(NULL, 
              make_long(StringStore+Buda2[Arguments+10]), IMAGE_CURSOR, 0, 0, LR_LOADFROMFILE));
        else
          switch(Buda1[Arguments+10])
          {
           case TT_C_QUESTION:  // ? Standard arrow and small hourglass 
            hCursor=theApp.LoadStandardCursor(IDC_APPSTARTING);
            break;
           case TT_C_C:  // c Crosshair
            hCursor=theApp.LoadStandardCursor(IDC_CROSS);
            break;
           case TT_C_H:  // h Hand
            hCursor=theApp.LoadStandardCursor(IDC_HAND);
            break;
           case TT_C_T:  // t Text I-beam
            hCursor=theApp.LoadStandardCursor(IDC_IBEAM);
            break;
           case TT_C_O:  // o Slashed circle
            hCursor=theApp.LoadStandardCursor(IDC_NO);
            break;
           case TT_C_X:  // x Four-pointed arrow
            hCursor=theApp.LoadStandardCursor(IDC_SIZEALL);
            break;
           case TT_C_N:  // n Double-pointed arrow pointing northeast and southwest
            hCursor=theApp.LoadStandardCursor(IDC_SIZENESW);
            break;
           case TT_C_D:  // d Double-pointed arrow pointing north and south
            hCursor=theApp.LoadStandardCursor(IDC_SIZENS);
            break;
           case TT_C_U:  // u Double-pointed arrow pointing northwest and southeast
            hCursor=theApp.LoadStandardCursor(IDC_SIZENWSE);
            break;
           case TT_C_CUT:  // ! Double-pointed arrow pointing west and east
            hCursor=theApp.LoadStandardCursor(IDC_SIZEWE);
            break;
           case TT_C_V:  // v Vertical arrow
            hCursor=theApp.LoadStandardCursor(IDC_UPARROW);
            break;
           case TT_C_W:  // w Hourglass
            hCursor=theApp.LoadStandardCursor(IDC_WAIT);
            break;
           default:
            hCursor=theApp.LoadStandardCursor(IDC_ARROW); // Standard arrow
          }
        flag=1;
        Wait++;
        ObjectStore[ObjectStore_br]=C_S_WIN_Main;
        pMainWindow=pMain_Frame=new C_FrameWnd;
        ObjectStore[ObjectStore_br+2]=(MY_WORD)pMain_Frame;
        pMain_Frame->m_Number=ObjectStore_br;
        CRect rect(t, m, t+n, m+k);
        CString WinName;
        if (Buda1[Arguments+3]==TT_STR)
          WinName=make_long(StringStore+Buda2[Arguments+3]);
        else
          WinName="Program";
#if PLUG_IN
        if ()
          pMain_Frame->Attach();
        else
#endif // PLUG_IN

        for (j=Arguments; Buda1[j]==TT_LINK; j=Buda2[j]); // for message size
        Buda1[j]=TT_OBJ;
        Buda2[j]=ObjectStore_br;
        if ((ObjectStore_br+=ObjectStore[ObjectStore[ObjectStore_br]+2])>=OBJ_STORE && correct_OBJ_ST() )
          goto FULL2;
        
        pMain_Frame->Create( AfxRegisterWndClass( cs_Styles,   // CS_DBLCLKS
          hCursor, (HBRUSH)ObjectStore[Buda2[j]+6], hIcon ),
          WinName, Styles, rect, OldWindow_Frame, NULL, 0, NULL );
        }
        break;
//Plamen test
	     case 386:  // embed_server
	      {
				  if (Buda1[Arguments+9]==TT_OBJ) 
					{
						CHECK_TYPE(9,CLASS_SYSTEM_ActiveX)
						p=Buda2[Arguments+9];
						ObjectStore[p+6]=ObjectStore[p+9]=(DWORD)hbrGreen;      // window brush
						ObjectStore[p+7]=RGB(0, 0, 0);              // text color
						ObjectStore[p+8]=GetSysColor(COLOR_WINDOW); // backgraund text color
					}
					else if (Buda1[Arguments+9]==TT_STR)
					{
            p=ObjectStore_br;
            if (open_server(Arguments+9)==0)
              return(0);
            ObjectStore[p+3]=Definition[DF_FALSE];
          }
          else
			    {
				    MitiText("no COM server.\r\n"); 
				    break;
			    }
          if (Buda1[Arguments+2]!=TT_LINK)
          {
	          if (ObjectStore[p+3]==Definition[DF_FALSE])
	            oComEvtClient.AttachEvents(p,((COleDispatchDriver*)ObjectStore[p+10])->m_lpDispatch); // attach events
            ObjectStore[p+3]=Buda1[Arguments+2];// ms_function;
          }
          if (Buda1[Arguments+10]==TT_STR)
            ObjectStore[p+11]=Buda2[Arguments+10];// Connection Point

			    COleDispatchDriver* Disp = (COleDispatchDriver*)ObjectStore[p+10]; 
			    CRect rect(t, m, t+n, m+k);
			    ObjectStore[p]=C_S_WIN_Embedded;
			    pMainWindow = new CWnd;
			    ObjectStore[p+2]=(MY_WORD)pMainWindow;

			    CAxWindow2* pAxWnd = new CAxWindow2();
			    pAxWnd->Create(pMain_Frame->m_hWnd, rect, NULL, WS_CHILD | WS_VISIBLE | WS_BORDER, 0, p);
			    pAxWnd->AttachControl(Disp->m_lpDispatch, NULL);

			    if (pMainWindow->Attach(pAxWnd->m_hWnd) == 0)
			      MitiText("Failed to attach ActiveX.\r\n", &cf_red);
		    }
		    break;
//end plam test
       case 244:  // button
        {
        ObjectStore[ObjectStore_br]=C_S_WIN_Button;
        pMainWindow=new CButton;
        ObjectStore[ObjectStore_br+2]=(MY_WORD)pMainWindow;
        CRect rect(t, m, t+n, m+k);
        CString WinName;
        if (Buda1[Arguments+3]==TT_STR)
          WinName=make_long(StringStore+Buda2[Arguments+3]);
        else
          WinName="Button";
        ((CButton*)pMainWindow)->Create( WinName, WS_CHILD | WS_VISIBLE | WS_TABSTOP,
          rect, pMain_Frame, ObjectStore_br);
        }
        if (Buda1[Arguments+8]==TT_INT)
        {
          if (if_the_flag(2, 0, Buda2[Arguments+8]))
            pMainWindow->EnableWindow(0);
        }
        break;
       case 174:  // bitmap_button
        {
        ObjectStore[ObjectStore_br]=C_S_WIN_Button;
        pMainWindow=new CBitmapButton;
        ObjectStore[ObjectStore_br+2]=(MY_WORD)pMainWindow;
        CRect rect(t, m, t+n, m+k);
        ((CBitmapButton*)pMainWindow)->Create( _T(""), WS_CHILD | WS_VISIBLE | WS_TABSTOP
          | BS_OWNERDRAW, rect, pMain_Frame, ObjectStore_br);
        if (Buda1[Arguments+3]==TT_STR)
          ((CBitmapButton*)pMainWindow)->LoadBitmaps(make_long(StringStore+Buda2[Arguments+3])); 
        else
          ((CBitmapButton*)pMainWindow)->LoadBitmaps(MAKEINTRESOURCE(IDB_BITMAP)); 
        }
        break;
       case 138:         // check box
        {
        ObjectStore[ObjectStore_br]=C_S_WIN_CheckBox;
        pMainWindow=new CButton;
        ObjectStore[ObjectStore_br+2]=(MY_WORD)pMainWindow;
        CRect rect(t, m, t+n, m+k);
        CString WinName;
        if (Buda1[Arguments+3]==TT_STR)
          WinName=make_long(StringStore+Buda2[Arguments+3]);
        else
          WinName="Check Box";
        ((CButton*)pMainWindow)->Create( WinName, WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_3STATE, //BS_CHECKBOX
          rect, pMain_Frame, ObjectStore_br);
        }
        if (Buda1[Arguments+8]==TT_INT)
        {
          if (if_the_flag(1, 0, Buda2[Arguments+8]))
            ((CButton*)pMainWindow)->SetCheck(1);
          if (if_the_flag(2, 0, Buda2[Arguments+8]))
            pMainWindow->EnableWindow(0);
        }
        break;
       case 173:         // radio button
        {
        ObjectStore[ObjectStore_br]=C_S_WIN_CheckBox;
        pMainWindow=new CButton;
        ObjectStore[ObjectStore_br+2]=(MY_WORD)pMainWindow;
        CRect rect(t, m, t+n, m+k);
        CString WinName;
        if (Buda1[Arguments+3]==TT_STR)
          WinName=make_long(StringStore+Buda2[Arguments+3]);
        else
          WinName="Radio Button";
        ((CButton*)pMainWindow)->Create( WinName, WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_RADIOBUTTON,
          rect, pMain_Frame, ObjectStore_br);
        }
        if (Buda1[Arguments+8]==TT_INT)
        {
          if (if_the_flag(1, 0, Buda2[Arguments+8]))
            ((CButton*)pMainWindow)->SetCheck(1);
          if (if_the_flag(2, 0, Buda2[Arguments+8]))
            pMainWindow->EnableWindow(0);
        }
        break;
       case 175:         // group_box
        {
        ObjectStore[ObjectStore_br]=C_S_WIN_Static;
        pMainWindow=new CButton;
        ObjectStore[ObjectStore_br+2]=(MY_WORD)pMainWindow;
        CRect rect(t, m, t+n, m+k);
        CString WinName;
        if (Buda1[Arguments+3]==TT_STR)
          WinName=make_long(StringStore+Buda2[Arguments+3]);
        else
          WinName="";
        ((CButton*)pMainWindow)->Create( WinName, WS_CHILD | WS_VISIBLE | WS_TABSTOP
         | BS_GROUPBOX, rect, pMain_Frame, ObjectStore_br);
        }
        if (Buda1[Arguments+8]==TT_INT)
        {
          if (if_the_flag(2, 0, Buda2[Arguments+8]))
            pMainWindow->EnableWindow(0);
        }
        break;
       case 176:         // tool_tip
        {
        ObjectStore[ObjectStore_br]=C_S_WIN_CheckBox;
        pMainWindow=new CToolTipCtrl ;
        ObjectStore[ObjectStore_br+2]=(MY_WORD)pMainWindow;
        CRect rect(t, m, t+n, m+k);
        CString WinName;
        if (Buda1[Arguments+3]==TT_STR)
          WinName=make_long(StringStore+Buda2[Arguments+3]);
        else
          WinName="Tool Tip";
        ((CToolTipCtrl *)pMainWindow)->Create(pMain_Frame, TTS_ALWAYSTIP | WS_POPUP | WS_EX_TOOLWINDOW);
        if (n==M1 || k==M1)
          ((CToolTipCtrl *)pMainWindow)->AddTool(pMain_Frame, WinName);
        else
          ((CToolTipCtrl *)pMainWindow)->AddTool(pMain_Frame, WinName, &rect, ObjectStore_br);
        pMain_Frame->EnableToolTips(TRUE);
        ((CToolTipCtrl *)pMainWindow)->Activate(TRUE);
        }
        break;
       case 245:  // static
        {
        ObjectStore[ObjectStore_br]=C_S_WIN_Static;
        pMainWindow=new CStatic;
        ObjectStore[ObjectStore_br+2]=(MY_WORD)pMainWindow;
        CRect rect(t, m, t+n, m+k);
        CString WinName;
        if (Buda1[Arguments+3]==TT_STR)
          WinName=make_long(StringStore+Buda2[Arguments+3]);
        else
          WinName="Static";
        ((CStatic*)pMainWindow)->Create( WinName, WS_CHILD | WS_VISIBLE | SS_CENTER,
          rect, pMain_Frame, ObjectStore_br);
        }
        if (Buda1[Arguments+8]==TT_INT)
        {
          if (if_the_flag(2, 0, Buda2[Arguments+8]))
            pMainWindow->EnableWindow(0);
        }
        break;
       case 246:  // edit
        {
          ObjectStore[ObjectStore_br]=C_S_WIN_Edit;
          pMainWindow=new CRichEditCtrl;
          ObjectStore[ObjectStore_br+2]=(MY_WORD)pMainWindow;
          ObjectStore[ObjectStore_br+4]=M1;
          CRect rect(t, m, t+n, m+k);
          DWORD def_flags=1;
          if (Buda1[Arguments+8]==TT_INT)
          {
            i=(if_the_flag(1, def_flags, Buda2[Arguments+8]))?WS_BORDER:0;
            if (if_the_flag(2, def_flags, Buda2[Arguments+8]))
              i|=ES_MULTILINE | WS_VSCROLL;
            if (if_the_flag(4, def_flags, Buda2[Arguments+8]))
              i|=ES_READONLY;
          }
          else
            i=WS_BORDER;
          ((CRichEditCtrl*)pMainWindow)->Create(i | WS_CHILD | WS_VISIBLE | WS_TABSTOP,
            rect, pMain_Frame, ObjectStore_br);
          if (Buda1[Arguments+3]==TT_STR)
            pMainWindow->SetWindowText(make_long(StringStore+Buda2[Arguments+3]));
        }
        break;
       case 438:  // slider
        {
          ObjectStore[ObjectStore_br]=C_S_WIN_Slider;
          pMainWindow=new CSliderCtrl;
          ObjectStore[ObjectStore_br+2]=(MY_WORD)pMainWindow;
          ObjectStore[ObjectStore_br+4]=M1;
          CRect rect(t, m, t+n, m+k);
          DWORD def_flags=0;
          if (Buda1[Arguments+8]==TT_INT)
          {
            i=(if_the_flag(2, def_flags, Buda2[Arguments+8]))?TBS_VERT:TBS_HORZ;
            if (if_the_flag(4, def_flags, Buda2[Arguments+8]))
              i|=TBS_BOTH; // |TBS_AUTOTICKS
          }
          else
            i=TBS_HORZ;
          ((CSliderCtrl*)pMainWindow)->Create(i | WS_CHILD | WS_VISIBLE | WS_TABSTOP,
            rect, pMain_Frame, ObjectStore_br);
          ((CSliderCtrl*)pMainWindow)->SetPos(Buda2[Arguments+9]);
        }
        break;
       case 143:         // List Box
        {
        ObjectStore[ObjectStore_br]=C_S_WIN_ListBox;
        pMainWindow=new CListCtrl;
        ObjectStore[ObjectStore_br+2]=(MY_WORD)pMainWindow;
        CRect rect(t, m, t+n, m+k);
        CString WinName;
        if (Buda1[Arguments+3]==TT_STR)
          WinName=make_long(StringStore+Buda2[Arguments+3]);
        else
          WinName="Column 0";
        ((CListCtrl*)pMainWindow)->Create(WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_BORDER
          | LVS_REPORT | LVS_SINGLESEL | LVS_NOCOLUMNHEADER | WS_VSCROLL, rect, pMain_Frame, ObjectStore_br);
        ((CListCtrl*)pMainWindow)->InsertColumn( 0, WinName, LVCFMT_LEFT, n-20, -1 );
        /*if (Buda1[Arguments+12]==TT_OBJ)
        {
          DWORD *Temp=(LPDWORD)ObjectStore[Buda2[Arguments+12]+4];
          for (i=0; i<ObjectStore[Buda2[Arguments+12]+2]; i++)
            ((CListCtrl*)pMainWindow)->InsertItem( -1, (LPSTR)(StringStore+Temp[i]));
          if (ObjectStore[Buda2[Arguments+12]+1]==M2) // free the list
            FreeArray(Buda2[Arguments+12]);
        } */
        }
        break;
       case 225:         // Tree Box
        {
        ObjectStore[ObjectStore_br]=C_S_WIN_TreeBox;
        pMainWindow=new CTreeCtrl;
        ObjectStore[ObjectStore_br+2]=(MY_WORD)pMainWindow;
        CRect rect(t, m, t+n, m+k);
        ((CTreeCtrl*)pMainWindow)->Create(WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_BORDER
          | TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS| WS_VSCROLL,
            rect, pMain_Frame, ObjectStore_br);
        }
        break;
       case 247:  // bitmap
        {
        ObjectStore[ObjectStore_br]=C_S_WIN_Bitmap;
        pMainWindow=new CStatic;
        ObjectStore[ObjectStore_br+2]=(MY_WORD)pMainWindow;
        CRect rect(t, m, t+n, m+k);
        ((CStatic*)pMainWindow)->Create(_T(""), WS_CHILD | WS_VISIBLE | SS_BITMAP,
          rect, pMain_Frame, ObjectStore_br);
        if (Buda1[Arguments+3]==TT_STR)
          ((CStatic*)pMainWindow)->SetBitmap((HBITMAP)LoadImage(NULL, 
              make_long(StringStore+Buda2[Arguments+3]), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE));
        else
          ((CStatic*)pMainWindow)->SetBitmap((HBITMAP)LoadImage(theApp.m_hInstance, 
              MAKEINTRESOURCE(IDB_BITMAP), IMAGE_BITMAP, 0, 0, LR_LOADTRANSPARENT));
        }
        break;
       case 248:  // icon
        {
        ObjectStore[ObjectStore_br]=C_S_WIN_Icon;
        pMainWindow=new CStatic;
        ObjectStore[ObjectStore_br+2]=(MY_WORD)pMainWindow;
        CRect rect(t, m, t+n, m+k);
        ((CStatic*)pMainWindow)->Create(_T(""), WS_CHILD | WS_VISIBLE | SS_ICON,
          rect, pMain_Frame, ObjectStore_br);
        if (Buda1[Arguments+3]==TT_STR)
          ((CStatic*)pMainWindow)->SetIcon((HICON)LoadImage(NULL, 
              make_long(StringStore+Buda2[Arguments+3]), IMAGE_ICON, 0, 0, LR_LOADFROMFILE));
        else
          ((CStatic*)pMainWindow)->SetIcon((HICON)LoadImage(theApp.m_hInstance, 
              MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 0, 0, NULL));

        }
        break;
       case 249:  // animate
        {
        flag=3;
        ObjectStore[ObjectStore_br]=C_S_WIN_Animate;
        pMainWindow=new CAnimateCtrl;
        ObjectStore[ObjectStore_br+2]=(MY_WORD)pMainWindow;
        CRect rect(t, m, t+n, m+k);
        ((CAnimateCtrl*)pMainWindow)->Create(WS_CHILD | WS_VISIBLE | ACS_AUTOPLAY | ACS_TRANSPARENT, 
          rect, pMain_Frame, ObjectStore_br); //111
        if (Buda1[Arguments+3]==TT_STR)
          ((CAnimateCtrl*)pMainWindow)->Open(make_long(StringStore+Buda2[Arguments+3]));
        else
          ((CAnimateCtrl*)pMainWindow)->Open((UINT)NULL);
        //((CAnimateCtrl*)pMainWindow)->Play(0, M1, M1);
        }
        break;
       case 250:  // menu
       //    *   1     normal
       //        2     pop_up
       //        4     separator
       //        8     checked
       //      0x10    grayed
       //      0x20    rightjustify
        {
          DWORD def_flags=1;
          DWORD Styles= MF_STRING;
          if (if_the_flag(8, def_flags, Buda2[Arguments+8]))
            Styles|=MF_CHECKED;
          if (if_the_flag(0x10, def_flags, Buda2[Arguments+8]))
            Styles|=MF_GRAYED;
          else
            Styles|=MF_ENABLED;
          if (if_the_flag(2, def_flags, Buda2[Arguments+8]))
            Styles|=MF_POPUP;
          if (if_the_flag(0x20, def_flags, Buda2[Arguments+8]))
            Styles|=MF_RIGHTJUSTIFY;
          ObjectStore[ObjectStore_br]=CLASS_SYSTEM_MENU;
          ObjectStore[ObjectStore_br+2]=NULL;

          if ((Buda1[Arguments+3]!=TT_STR && !(if_the_flag(4, def_flags, Buda2[Arguments+8])))// separator 
               || pMain_Frame==NULL)
            return(0);
          if (MainMenu==NULL && pMain_Frame->GetMenu()==NULL)
          {
            CMenu TempMenu;
            TempMenu.CreateMenu();
            if (if_the_flag(4, def_flags, Buda2[Arguments+8]))    // separator
              TempMenu.AppendMenu(MF_SEPARATOR);
            else if (if_the_flag(2, def_flags, Buda2[Arguments+8]))     // pop_up
            {
              TempMenu.AppendMenu(Styles,
                      (UINT)(MainMenu=CreateMenu()), make_long(StringStore+Buda2[Arguments+3]));
              ObjectStore[ObjectStore_br+2]=(MY_WORD)MainMenu;
            }
            else
            {
              TempMenu.AppendMenu(Styles, ObjectStore_br, make_long(StringStore+Buda2[Arguments+3]));
            }
            pMain_Frame->SetMenu(&TempMenu);
            TempMenu.Detach();
          }
          else
          {
            HMENU hTempMenu=(MainMenu==NULL)?pMain_Frame->GetMenu()->m_hMenu:MainMenu;
            if (if_the_flag(4, def_flags, Buda2[Arguments+8]))    // separator
              AppendMenu(hTempMenu, MF_SEPARATOR, 0, 0);
            else if (if_the_flag(2, def_flags, Buda2[Arguments+8]))     // pop_up
            {
              AppendMenu(hTempMenu, Styles,
                        (UINT)(MainMenu=CreateMenu()), make_long(StringStore+Buda2[Arguments+3]));
              ObjectStore[ObjectStore_br+2]=(MY_WORD)MainMenu;
            }
            else
            {
              AppendMenu(hTempMenu, Styles, ObjectStore_br, make_long(StringStore+Buda2[Arguments+3]));
            }
          }
          pMain_Frame->DrawMenuBar();
        }
      }
      for (j=Arguments; Buda1[j]==TT_LINK; j=Buda2[j]);
      Buda1[j]=TT_OBJ;
      if (p_line==386 && Buda1[Arguments+9]==TT_OBJ)
        Buda2[j]=Buda2[Arguments+9];
      else if (flag!=1)
      {
        Buda2[j]=ObjectStore_br;
        if ((ObjectStore_br+=ObjectStore[ObjectStore[ObjectStore_br]+2])>=OBJ_STORE && correct_OBJ_ST() )
          goto FULL2;
      }
      OldWindow=pMainWindow;
      OldWindow_Frame=pMain_Frame;
      make_call(0, ObjectStore[Buda2[j]+3], DF_INIT, 0, 0, 0, 0, 0, 0);

      pMainWindow=OldWindow;
      pMain_Frame=OldWindow_Frame;
      if (flag)
      {
        if (flag<3)
          pMain_Frame->SetForegroundWindow();
        if (flag==1 && if_the_flag(1, def_flags, Buda2[Arguments+8]))
          pMainWindow->ShowWindow(SW_SHOWMINIMIZED); 
        else if (flag==1 && if_the_flag(2, def_flags, Buda2[Arguments+8]))
          pMainWindow->ShowWindow(SW_SHOWMAXIMIZED); 
        else
          pMainWindow->ShowWindow(SW_SHOWNORMAL);
        pMainWindow->UpdateWindow();
      }
      MainMenu=OldMenu;

      my_gl=0;
      WILL_CLEAN(j);
      return(1); // 7
     }
     case 72:  // text_out
      {
        HDC hDC;
        
        if (pMain_DC==NULL)
        {
          if (pMain_Frame==NULL)
            return(0);
          hDC=GetDC(pMain_Frame->m_hWnd);
          SetTextColor(hDC, ObjectStore[pMain_Frame->m_Number+7]);
          SetBkColor(hDC, ObjectStore[pMain_Frame->m_Number+8]);
          SetTextAlign(hDC, TA_UPDATECP);
        }
        else
          hDC=pMain_DC->m_hDC;
        if (hFont)
          SelectObject(hDC, hFont);
        if (Buda1[Arguments+1]==TT_INT && Buda1[Arguments+2]==TT_INT)
          MoveToEx(hDC, Buda2[Arguments+1], Buda2[Arguments+2], NULL);
        TextOut(hDC, 0, 0, make_long(StringStore+Buda2[Arguments]), 
                                my_strlen(make_long(StringStore+Buda2[Arguments])));
      }
      return(1);
     case 78:  // text_out_size
      {
        HDC hDC;
        
        if (pMain_DC==NULL)
          return(0);
        hDC=pMain_DC->m_hDC;
        if (hFont)
          SelectObject(hDC, hFont);
        Buda2[Return] = pMain_DC->GetTextExtent(make_long(StringStore+Buda2[Arguments]), my_strlen(make_long(StringStore+Buda2[Arguments]))).cx;
        Buda1[Return]=TT_INT;
        return(1);
      }
     case 73:  // wait(T)
      if (Buda1[Arguments]==TT_INT)
        k=1000*Buda2[Arguments];
      else if (Buda1[Arguments]==TT_FLOAT)
        k=(MY_INT)(1000 * (*(MY_FLOAT*)&(Buda2[Arguments])) );
      {
      CEvent eventNever;
      ::WaitForSingleObject(eventNever.m_hObject, k);
      }
      return(1);    
     case 77:  // select_color(W, S)
      // don't calc immediately these predicates
      {
      CWnd *pWindow;
      if (Buda1[Arguments+1]==TT_OBJ)
      {
        CHECK_TYPE(1,C_S_WIN_Main)
        pWindow=((CWnd*)ObjectStore[Buda2[Arguments+1]+2]);
      }
      else
        pWindow=(pMain_Frame)?pMain_Frame:(CWnd*)pMainFrame;
      CColorDialog dialog(0, 0, pWindow);
      dialog.m_cc.Flags = CC_FULLOPEN | CC_RGBINIT | CC_SHOWHELP | CC_ENABLEHOOK;//?hook
      if (Buda1[Arguments+2]==TT_INT)
        dialog.m_cc.rgbResult= Buda2[Arguments+2];
      else
        dialog.m_cc.rgbResult= RGB(255, 0, 0);
      if (dialog.DoModal()==IDOK)
      {
        Buda1[Buda2[Arguments]]=TT_INT;
        Buda2[Buda2[Arguments]]=dialog.m_cc.rgbResult;
        WILL_CLEAN(Buda2[Arguments]);
        return(1);    
      }
      return(0);    
      }//for
     case 170:  // select_font(W, S)
      // don't calc immediately these predicates
      {
      CWnd *pWindow;
      CFont font;
      if (Buda1[Arguments]==TT_OBJ)
      {
        CHECK_TYPE(0,C_S_WIN_Main)
        pWindow=((CWnd*)ObjectStore[Buda2[Arguments]+2]);
      }
      else
        pWindow=(pMain_Frame)?pMain_Frame:(CWnd*)pMainFrame;
      CFontDialog dialog(NULL, CF_EFFECTS | CF_SCREENFONTS, NULL, pWindow);
      if (Buda1[Buda2[Arguments+2]]==TT_INT)
        dialog.m_cf.rgbColors=Buda2[Buda2[Arguments+2]];
      if (Buda1[Buda2[Arguments+1]]==TT_OBJ)
      {
        if (!(SUBTYPE(ObjectStore[Buda2[Buda2[Arguments+1]]],CLASS_SYSTEM_FONT)))
          return(error_func3(Arguments,p_line,1,CLASS_SYSTEM_FONT,0));
        font.FromHandle((HFONT)(ObjectStore[Buda2[Buda2[Arguments+1]]+2]))->GetLogFont(dialog.m_cf.lpLogFont);
        dialog.m_cf.Flags|=CF_INITTOLOGFONTSTRUCT;
      }
      if (dialog.DoModal()==IDOK)
      {
        LOGFONT lf;
        dialog.GetCurrentFont(&lf);
        hFont=CreateFontIndirect(&lf);
        Buda1[Buda2[Arguments+2]]=TT_INT;
        Buda2[Buda2[Arguments+2]]=dialog.GetColor(); // no reconstruct after backtracking
        Buda1[Buda2[Arguments+1]]=TT_OBJ;
        Buda2[Buda2[Arguments+1]]=ObjectStore_br;
        ObjectStore[ObjectStore_br+2]=(DWORD)hFont;
        ObjectStore[ObjectStore_br+1]=M1;  // object name
        ObjectStore[ObjectStore_br]=CLASS_SYSTEM_FONT;
        if ((ObjectStore_br+=3)>=OBJ_STORE && correct_OBJ_ST() )
          goto FULL2;
        Buda1[Buda2[Arguments+3]]=TT_STR;
        Buda2[Buda2[Arguments+3]]=sv_StStore;
        i=ChangeCharset(M64_ch, ch_set, (BYTE *)(LPCTSTR)lf.lfFaceName, StringStore+sv_StStore, &kk, default_char);
        if ((sv_StStore+=i+1)>=STRING_STORE && correct_STR_ST() )
          goto FULL;
        Buda1[Buda2[Arguments+4]]=TT_INT;
        Buda2[Buda2[Arguments+4]]=abs(lf.lfHeight);
        return(1);    
      }
      return(0);    
      }//for
     case 172: //shell_execute
       {
       _TCHAR *OpStr;
       if (Buda1[Arguments+1]==TT_STR) // str
         OpStr=make_long(StringStore+Buda2[Arguments+1]);
       else                         // var
         OpStr=NULL;
       if (32>=(int)(ShellExecute(NULL, OpStr, make_long(StringStore+Buda2[Arguments]), NULL, NULL, SW_SHOWNORMAL)))
         return(0);
       return(1);
       }
     case 82: //execute.file
       if (32>WinExec( (LPSTR)(StringStore+Buda2[Arguments]), SW_SHOW) )
         return(0);
       return(1);
