//#include "Unix.h"
#include "stdafx.h"   //MS Windows
#include "Strawberry.h"

#if !CONSOLE
#include "StrawberryDoc.h"
#endif  // !CONSOLE

BYTE key_map[256]={
        130,128,128,128,128,128,128,128,128,129,129,128,128,130,128,128,
        128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,
        129, 80,138, 66, 68,140, 70,137,131,132, 71, 72, 82, 73, 67, 74,// 134
          0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 75, 81, 77, 78, 79, 65,
         76, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24,
         25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35,135, 63,136, 64, 36,
        139, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51,
         52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62,133, 83,134, 69,128,
         36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36,
         36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36,
         36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36,
         36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36,
         10, 84, 11, 85, 86, 14, 87, 88, 89, 90, 20, 91, 22, 17, 24, 92,
         25, 12, 29, 34, 93, 33, 94, 95, 96, 97, 98, 98, 98, 99,100,101,
         37,102,103,104,105, 41,106,107, 57,108, 47,109,110,111, 51, 50,
         52, 39, 49, 61,112, 60,113,114,115,116,117,118,119,120,121,122};

BYTE key_oposit[126];
MY_WORD  proof_tree_atom[TROOF_TREE_ATOMS];

                  /* temporal */
MY_WORD  gl_read;            
                  /* others */
// MEMORY_C=4096 up now because bug
MY_WORD  MEMORY_C=8192, MEMORY_c256=8192+TT_START, MEMORY_V=3072, MEMORY_S=4096, MEMORY_STemp=2048;
MY_WORD  MEMORY_tr=8192, BLOCKS=2048, PROGRAM_L=1016, PROGRAM_F=6144-8;
MY_WORD  DEF_F=1024-NUMB_FLAGS, FUNC_F=2048, READY_LISTS=16;
MY_WORD  FUNCTOR_L=256, NEW_OBJ=2048-8, SALAM=256, EKLER=2040, OBJ_STORE=512, STRING_STORE=8192;

MY_WORD  STACK2, BUDA3, BUDA_S2; // limits are saved in registry
MY_INT   BUDA3_UP=4096;

// MEMORY_C     /* close terms */
// MEMORY_c256  /* close terms + TT_START */
// MEMORY_V     /* open terms */
// MEMORY_S     /* substitutions */
// MEMORY_St    /* substitutions - temporal*/
// MEMORY_tr    /* tree elements on the main tree */
// BLOCKS       /* Blocks */
// PROGRAM_L    /* number of clauses */
// PROGRAM_F    
// NEW_OBJ      
// SALAM        /* back tr. in the unification */
// EKLER        /* pointers to back tr. branches */

// WIN_STORE    /* 6*windows */
// STRING_STORE 

MY_WORD  ch_set=2;
BYTE default_char='?';
MY_WORD c_black, c_red, c_green, c_blue, c_violet, c_output;
char string[L_BUFER+REZ_4], string2[L_BUFER+REZ_4], string_proof[L_BUFER+REZ_4], last_char[2]={'\0', '\0'};    // string2 must be big
BYTE MyCallback1[2*BUFFERS]; // because of multythreading
MY_WORD  status_fl=0, f_end, len, Trace=0, main_h1;
MY_WORD  Definition[DEFINITIONS], ret_fl, ret_temp, Wait=0, ObjectStore_br=0;

// Trace: 0 - go, 1 - trace, 2 - stop execution, 4 - step over

// m_Settings  * Prolongated Stack,
//               Active Break Point,
//               Stack is Full as Fail
//               Fix first random number
//16           * Use Default Font,
//             * Use Default Memory
//               Add the source code,
//             * Terminate after runtime error
//256            Don't recompile on run
//               Not working with the Light edition
//               Don't edit this project
//               Execute the EXE file on run
//0x1000          system use llike flag in do you like to change question
//               Add the Standard.add file

//0x10000        Use # instead of ?
//0x7e0000       Car Set
//0x7f800000     Font of the Project
//********* HALF impossible byte
 
// Environment * Filter==1 (Open File) 
//               Next is Always Active,
//16             One Step is Always Active,
//                                        // 32 now is free, it was "Execute Only Projects"
//             * Toolbar,
//             * Statusbar,
//256            Automatic Word Selection
//             * Splash on Start
//               Big Tool Bar
//                used in the past - Sizable Bitmaps 
//0x1000         Proof Tree Always at the Top
//            i* Automatic scroll in Proof Tree,
//             * Remember the last file when exit
//             * Flat Toolbar
//0x10000      * Syntax Coloring 
//               Syntax Coloring on Every Text Change
//               Syntax Coloring only when Enter (change with EveryTxtChenge if PROF)
//               Save Mode
//0x7f800000     InfoFont
//********* HALF impossible byte
 
// status_fl   - Can do Next,
//                 Runing,
//               Waiting,
//                 Trace wait
//16             Painting in Proof Tree
//               Making a retract
//               Run Directly
//               Registered
//256            Called from EXE file (Temp)
//               Called from EXE file
//               from_update_window

#if DUMP
MY_WORD  dump_br=0, next_dump, all_dumps[ALL_DUMPS]={0}; // 1200,1280,1289

void make_dump(int fn)
{
  MY_WORD i;

  sprintf(string2, "\r\nDump. step=%lld.\r\n", (MY_LONG)(0x10000*lSteps_br+Steps_br-Correction));
  MitiText(string2);
#if UNIX
  sprintf(string2, "/home/dimiterdobrev/strawberry__3/dump/u%d.dump", (int)(dump_br+fn));
  MitiText(string2);
  FILE *dump = fopen(string2, "w");
#else
  strcpy((LPSTR)string2, make_short(namef));
  for (i=strlen((LPSTR)string2); string2[--i]!='\\' && i!=0; );
  string2[i]=0;

  sprintf((LPSTR)string2+i, "/dump/w%d.dump", (int)(dump_br+fn));
  MitiText((LPSTR)string2);
  FILE *dump = fopen((LPSTR)string2, "wb");
#endif
  if (dump==NUL)
  {
    MitiText("Cannot open this file.\r\n");
    return;
  }
  i=0x1234123412341234;

  fwrite(&BUDA3_UP, v4_8, 1, dump);
  fwrite(&BUDA3, v4_8, 1, dump);
  SEPARATOR; fwrite(Functors, v4_8, FUNCTOR_L, dump);
  SEPARATOR; fwrite(Program, v4_8, (PROGRAM_L+8), dump); 
    SEPARATOR; fwrite(Program2, v4_8, (PROGRAM_L+8), dump); // it can be different
  SEPARATOR; fwrite(ProgTail, v4_8, (PROGRAM_L+8), dump);
  SEPARATOR; fwrite(Pointers, v4_8, (MEMORY_c256+MEMORY_V), dump); 
  SEPARATOR; fwrite(Prog_Obj, v4_8, (PROGRAM_L+8), dump);
  SEPARATOR; fwrite(Atoms, v4_8, (PROGRAM_L+8), dump);
  SEPARATOR; fwrite(Prog_fild, v4_8, (PROGRAM_F+8), dump); 
  SEPARATOR; fwrite(D_field, v4_8, (DEF_F+NUMB_FLAGS), dump); 
  SEPARATOR; fwrite(F_field, v4_8, (FUNC_F+MAX_ARGUMENTS), dump); // 10
  SEPARATOR; fwrite(ReadyLists, v4_8, READY_LISTS, dump);
  SEPARATOR; fwrite(StringStore, 1, STRING_STORE+L_BUFER+REZ_4, dump);
  SEPARATOR; fwrite(NewObj, v4_8, (NEW_OBJ+8), dump);
  SEPARATOR; fwrite(NewObj1, 1, (NEW_OBJ+8), dump);
  SEPARATOR; fwrite(NewObj2, 2, (NEW_OBJ+8), dump);
  SEPARATOR; fwrite(Stack, v4_8, (STACK2+8), dump);
  SEPARATOR; fwrite(Durty, v4_8, MAX_VARS, dump);
  SEPARATOR; fwrite(Buda1-BUDA3_UP, v4_8, (BUDA3_UP+BUDA3+MAX_VARS), dump);
  SEPARATOR; fwrite(Buda2-BUDA3_UP, v4_8, (BUDA3_UP+BUDA3+MAX_VARS), dump);
  SEPARATOR; fwrite(Link-BUDA3_UP, v4_8, (BUDA3_UP+BUDA_S2+MAX_VARS), dump); // 20
  SEPARATOR; fwrite(Ufil_c1, v4_8, (MEMORY_C+MEMORY_V), dump);
  SEPARATOR; fwrite(Ufil_c2, v4_8, (MEMORY_C+MEMORY_V), dump);
  SEPARATOR; fwrite(Ufil_vs, v4_8, MEMORY_V, dump);
  SEPARATOR; fwrite(Salam, v4_8, (SALAM+2*BUFFERS), dump);  
  SEPARATOR; fwrite(Ekler, v4_8, (EKLER+8), dump); 
  SEPARATOR; fwrite(Blocks, v4_8, (BLOCKS+TT_START+MAX_VARS), dump); 
  SEPARATOR; fwrite(Blocks_val, 2, (BLOCKS+TT_START+MAX_VARS), dump);
  SEPARATOR; fwrite(Blocks_next, 2, (BLOCKS+TT_START+MAX_VARS), dump);
  SEPARATOR; fwrite(Chfil_v, 2, MEMORY_V, dump);
  SEPARATOR; fwrite(Substi, 2, (MEMORY_S+MAX_VARS), dump); // 30
  SEPARATOR; fwrite(SubstiT, 2, (MEMORY_STemp+1024), dump);
  SEPARATOR; fwrite(Ch_tree, 2, MEMORY_tr, dump);
  SEPARATOR; fwrite(ObjectStore, v4_8, (OBJ_STORE+512), dump);
  SEPARATOR; fwrite(Mtree, v4_8, 4*MEMORY_tr, dump); // 4*4
  SEPARATOR; fwrite(Chfil_c, 1, MEMORY_C+MEMORY_V, dump);
  SEPARATOR; fwrite(Oper, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(OpPr, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(OpType, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(OpMin, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(buf_sub, v4_8, BUFFERS, dump); // 40
  SEPARATOR; fwrite(Array, v4_8, 2*BUFFERS, dump);
  SEPARATOR; fwrite(ArType, v4_8, 2*BUFFERS, dump);
    SEPARATOR; fwrite(ArPos, v4_8, 2*BUFFERS, dump); // it can be different
    SEPARATOR; fwrite(AddInfo, v4_8, BUFFERS, dump); // it can be different
  SEPARATOR; fwrite(atom_buf, 1, L_BUFER+REZ_4, dump);
  SEPARATOR; fwrite(var_field, 1, L_BUFER+REZ_4, dump);
  SEPARATOR; fwrite(ReadStack, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(Left, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(Right, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(buf1, v4_8, BUFFERS, dump); // 50
  SEPARATOR; fwrite(buf2, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(bufu1, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(bufu2, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(bufu3, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(bufu4, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(bufu5, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(bufu6, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(bufu7, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(st_buf, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(buf_3, v4_8, BUFFERS, dump); // 60 
  SEPARATOR; fwrite(buf_4, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(buf_5, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(buf_6, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(buf_7, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(buf_8, v4_8, 4*BUFFERS, dump);
  SEPARATOR; fwrite(list, v4_8, BUFFERS, dump);
  SEPARATOR; fwrite(global, v4_8, GLOBAL_max, dump);
  SEPARATOR; fwrite(global2, v4_8, GLOBAL_max, dump);
  SEPARATOR; fwrite(st_buf_num, v4_8, BUFFERS, dump);

  fclose(dump);
}
#endif

#if CHECK_ARRAYS_RANGE
MY_INT array_size[ARRAYS_NUM], array_shift[ARRAYS_NUM], array_c2[ARRAYS_NUM], errors_num=10;

MY_INT c(int num, MY_INT row)
{
  if ((row+array_shift[num]>=array_size[num] || row+array_shift[num]<0) && errors_num-- >0)
  {
    sprintf(string2, "Out of range in %d, val=0x%llx, size=%lld, step=%lld.\r\n", num, (MY_LONG_INT)row, (MY_LONG_INT)array_size[num], (MY_LONG)(0x10000*lSteps_br+Steps_br-Correction));
    MitiText(string2);
    return(0);
  }
  else
    return(row);
}
MY_INT c2(int num, MY_INT row)
{
  if ((row>=array_c2[num] || row<0) && errors_num-- >0)
  {
    printf(string2, "Out of range in second argument in %d, step=%lld.\r\n", num, (MY_LONG)(0x10000*lSteps_br+Steps_br-Correction));
    MitiText(string2);
    return(0);
  }
  else
    return(row);
}
#endif

#if 1
MY_HANDLE hOper, hOpPr, hOpType, hOpMin, Hbuf_sub, hArray, hArType, hArPos, hAddInfo; 
MY_HANDLE Hatom_buf, Hvar_field, hReadStack, hLeft, hRight, Hbuf1, Hbuf2;
MY_HANDLE Hbufu1, Hbufu2, Hbufu3, Hbufu4, Hbufu5, Hbufu6, Hbufu7, Hst_buf;
MY_HANDLE Hbuf_3, Hbuf_4, Hbuf_5, Hbuf_6, Hbuf_7, Hbuf_8, Hlist, Hglobal, Hglobal2, Hst_buf_num;
#endif
                  /* Operators */
MY_WORD  oper_br=0, *Oper, *OpPr, *OpType, *OpMin; 

                  /* buffers - CREATE */
MY_WORD  br_buf2=0, *bufu1, *bufu2, *bufu3, *bufu4; 
MY_WORD  *bufu5, *bufu6, *bufu7, *st_buf;    // bufu6 is in WRITE

                  /* buffers - READ */
MY_WORD  i_poin, *buf_sub, *Array, *ArType, *ArPos, *AddInfo;
MY_WORD  read_br, newline_br, error=1, warn_br=0, put_nl=0;
BYTE   *atom_buf, *var_field;
MY_WORD  *ReadStack, *Left, *Right, *buf1, *buf2;

                  /* buffers - CALL */
MY_WORD  term_1, term_2, buda_br, a1=0, br_buf1=0, RedLine=0;
MY_WORD  *buf_3, *buf_4, *buf_5, *buf_6, *buf_7, *buf_8;
MY_INT   buda_br_up=0; 
                  /* CREATE */
MY_WORD  sv_c=0, sv_v=1, sv_tr=1, sv_sub=0, sv_subv=0;
MY_WORD  sv_c_old, sv_v_old, sv_sub_old;
MY_WORD  sv_subT=0, sv_StStore=512, sv_NewObj=0, sv_blocks=1024, sv_blocks2=0;
MY_WORD  *list, list_br, *global, *global2, global_br=0, global_br2=0, GLOBAL_max=128;
MY_WORD  p1, StepOver, tt, tt_sub, *st_buf_num;

                  /* MAIN ARRAYS */
#if 1
MY_HANDLE  hTemp, hFunctors, hProgram, hProg_Obj, hAtoms, hProg_fild, hD_field, hF_field, hReadyLists;
MY_HANDLE  hDurty, hStack, hBuda1, hNewObj, hProgram2, hProgram3, hProgTail, hPointers;
MY_HANDLE  hBuda2, hLink, hUfil_c1, hUfil_c2, hUfil_vs, hBlocks, hBlocks_val, hBlocks_next;
MY_HANDLE  hChfil_c, hChfil_v, hSubsti, hSubstiT, hCh_tree;
MY_HANDLE  hStringStore, hNewObj1, hNewObj2, hObjectStore, hMtree, hSalam, hEkler;
#endif
MY_WORD *Functors, *Program, *Program2, *Program3, *ProgTail, *Pointers;
MY_WORD *Prog_Obj, *Atoms, *Prog_fild, *D_field, *F_field, *ReadyLists;
MY_WORD *Ufil_c1, *Ufil_c2, *Ufil_vs;
MY_WORD *Buda1, *Buda2, *NewObj, *Stack, *Link; 
MY_WORD *Blocks, *Salam, *Ekler, *Durty, *ObjectStore;
WORD *Blocks_val, *Blocks_next, *Ch_tree, *Chfil_v, *Substi, *SubstiT, *NewObj2; 
BYTE *Chfil_c, *NewObj1, *StringStore;
unsigned4 *Mtree;

MY_WORD p_fild_br, df_min_p, df_pointer, ff_pointer, program_br1, program_br2, program_br;
MY_WORD ekler_br, stack_br=0, lSteps_br, Correction, my_gl, my_gl2, func_br, func_in_ADD;
WORD  Steps_br;

/* global variables used in this module or among more than one module */
#if !CONSOLE
HMENU MainMenu=NULL;
HPEN hPen, hSavePen, hMyRedPen, hMyBluePen;
HBRUSH hbrGreen, hbrGrey, hBrush, hSaveBrush;
HFONT hFont, hSaveFont;
CFont InfoFont, InfoFontUnderline;
CHARFORMAT cf_blue, cf_red, cf_black, cf_green, *pFontMask;
DWORD  synt_color[LAST_COLOR+1];
SIZE Screen;
CString ProgramPath; 
CString TempStr, TempStr2;
CString RegName, RegFrom, RegProdID, RegPassword;

__int64 TheFirstMoment64, PerFrequency64, PerCounter64_old, ChronometerSteps;
// Proof Tree
DWORD open_br=0, open_start, j_start, k_old, selected_line=M1, selected_atom, selected_distance=0, MaxPrint=28;

#else

long TheFirstMoment64, PerCounter64_old, ChronometerSteps;
#endif

//system lists and containers
MY_WORD the_free_list, the_free_container;
// system / window / button or icon or ...

// system / file / text or bynary or ...

// system / list / int or str or ...
// Type, Name, Current Size, Pointer, Real Size, Handel

DWORD AddedFiles[64], AddedFiles_br, AddedFiles_temp; // temp will be keeked out with m_FilesList, temp will be == 2 

void compile(MY_INT flag) // &4 compile only the Def and Add files
{
  MY_WORD i, j, t, k;

#if TR
  if (status_fl&2)
    MitiText("Conflict! p1\r\n", &cf_red);
#endif
  while(status_fl&2);
  if (flag!=4)
  {
#if TR
    if (status_fl&16)
      MitiText("Conflict! p2\r\n", &cf_red);
#endif
    while(status_fl&16);
  }
#if DUMP
  dump_br=0;
  next_dump=all_dumps[0];
  Correction=Steps_br=(WORD)(0x10000-(next_dump&0xffff));
#endif
  // close_all_objects
  for (j=i=k=0; k<ObjectStore_br; j=k, i++)
  {
    k+=ObjectStore[ObjectStore[k]+2]?ObjectStore[ObjectStore[k]+2]:
      (ObjectStore[k]?ObjectStore[k+2]:ObjectStore[k+1]);
    if (ObjectStore[k]!=0 && k<ObjectStore_br)
      close_object(k);
  }
  for (i=global_br; i<global_br2; j=global2[i++], Link[j]=j); // repair the negative Link
  
  Link[0]=Stack[3]=Stack[4]=0;  // corekting a error
#if TR
  if ((i=check_memory())>0)
  {
    sprintf(string2, "Error %d at %d! The memory is smeary!\r\n", (int)(i%10), (int)(i/10));
    MitiText(string2, &cf_red);
  }
#endif
  init_memory();
  func_br=error=warn_br=put_nl=p_fild_br=ff_pointer=0;
  Program2[0]=0; Ufil_vs[0]=M1; Ufil_c1[MEMORY_C]=0;                                               
  pInfo2->m_Settings&=M1^4;
  Definition[DF_LIKE_ATOM]=Definition[DF_LIKE_FUNCTOR]=Definition[DF_LIKE_SET_CONST]=HALF;
#if !CONSOLE
  open_br=0;
  G_rectPaint.SetRect(0, 0, 0, 0);
  G_FlagsMes=0;
  if (gl_open&4)
  {
    ch_set=(gl_open&0x7e0000)/0x20000;
    default_char=(gl_open&0x10000)?'#':'?';
  }
  else
  {
    ch_set=(pInfo2->m_Settings&0x7e0000)/0x20000;
    default_char=(pInfo2->m_Settings&0x10000)?'#':'?';
  }
#endif
  df_min_p=df_pointer=NUMB_FLAGS-1;
  for (i=DEF_F+NUMB_FLAGS; i; D_field[--i]=M1);
  for (i=MEMORY_c256+MEMORY_V; i; Pointers[--i]=0);
  if (flag&2)
  {
    //MessageBoxA(NULL, "Version 1.6 cannot execute EXE files.", "Error", MB_OK | MB_ICONSTOP);
    //error=1;;
    for (i=0; i<oper_br; i++)
    {
      if (i==0 || Oper[i]!=Oper[i-1])
        put_in_f(i, Oper[i], 7, OBSEG6);
    }
    for (ReadyLists[0]=TT_LIST, i=1; i<READY_LISTS; ReadyLists[i]=creat_p(2, TT_VAR, ReadyLists[i-1], M1 ,1), i++); // twice
    for(i=0; i<program_br1; i++)
      assert(i, 1);
    for(i=program_br2; i<program_br; i++)
      assert(i, 1);
    goto P2;
  }
  // Mtree[0][0] is used as a black hole
  Mtree[0][1]=Mtree[0][2]=Mtree[0][3]=MASKA; // make agein
  br_buf1=sv_blocks2=0; sv_blocks=1024;
  for (i=BLOCKS+TT_START+MAX_VARS; i; Blocks_val[--i]=SM1); // clean blocks
  sv_tr=1;

  sv_StStore=512;   // loaded from exe
  sv_v=1;
  sv_c=sv_sub=sv_NewObj=global_br=global_br2=0;
  oper_br=program_br=program_br1=program_br2=0;
  for (ReadyLists[0]=TT_LIST, i=1; i<READY_LISTS; ReadyLists[i]=creat_p(2, TT_VAR, ReadyLists[i-1], M1 ,1), i++);

#if CONSOLE
  strcpy(string2, ProgramPath);
  strcat(string2, "Standard.def");
  if ((file=open(string2, O_RDONLY | O_TEXT))==-1)  // Standard Terms
  {
    MitiText("\r\nUnable to open Standard.def!\r\n");
    error++;
    goto e1;  
  }
  lseek(file,0,SEEK_SET);
  f_end=read(file, string, L_BUFER);
#else
  if (!(flag&4))
  {
    MitiText("\r\nCompiling the file:\r\n");
    my_sprintf(string3, _T("%s\r\n"), namef);
    MitiText(make_utf8(string3), &cf_black);
  }
  { // definition of str
  CString str;
  if (pInfo2->m_DefFile=="Standard.def" || pInfo2->m_DefFile=="")
    str=ProgramPath + _T("Standard.def");
  else
    str=pInfo2->m_DefFile;
  if (file.Open(str, CFile::modeRead)==0)  // Standard Terms
  {
    if (!(flag&4))
    {
      Warning( 99, 0, 0, 0);
      MitiText("Unable to open the DEF file:\r\n");
      MitiText(make_utf8(str), &cf_black);
      MitiText("\r\n");
    }
    else
      error++;
    goto e1;  
  }
  } // definition of str
  file.SeekToBegin();
  f_end=file.Read(string, L_BUFER);
#endif
  i_poin=read_br=newline_br=0;
  string[f_end]=0;
  i=0;
  while(i<DEFINITIONS && f_end && f_end!=M1)
  {
    if (read_n(&t, 9))
      Definition[i++]=t;
  }
#if CONSOLE
  close(file);
  AddedFiles_temp=AddedFiles_br=2;
#else
  file.Close();
  AddedFiles_temp=AddedFiles_br=pInfo2->m_FilesList.GetSize()+2;
#endif
  if (i<DEFINITIONS)
  {
    Warning( 99, 0, 0, 0);
    MitiText("The Standard.def is corrupt!\r\n");
    goto e1;  
  }

  sv_NewObj=0;
  for (j=0; j<AddedFiles_br; j++)
  {
    if(include_f(j, flag)==0)
      goto e1;  
  }
  
#if !CONSOLE
  if (flag&1)
  {
    pCompiled=NULL;
    return;
  }
#endif
P2:
  the_free_list=the_free_container=M1;
  for(ObjectStore_br=i=0; ObjectStore_br<=C_S_WIN_Embedded; ObjectStore_br+=10, i++)
  {
    ObjectStore[ObjectStore_br]=CLASS_S_CLASS; // class
    if (i)
    {
      ObjectStore[ObjectStore_br+1]=Definition[DF_CLASSES-1+i]; // name
      if (Pointers[Definition[DF_CLASSES-1+i]]&OBSEG5) // object name
      {
        Warning( 99, 0, 0, 0);
        len=0; 
        write_p(Definition[DF_CLASSES-1+i], 4, 0);
        MitiText("The name \"");
        MitiText(string2);
        MitiText("\"is already used.\r\n");
      }
      else
        put_in_f(ObjectStore_br, Definition[DF_CLASSES-1+i], 6, OBSEG5);
    }
    else
      ObjectStore[ObjectStore_br+1]=M1; // no name
    ObjectStore[ObjectStore_br+6]=M1;      // chield
    ObjectStore[ObjectStore_br+7]=ObjectStore_br+10;      // brother
    if (ObjectStore_br>C_S_WIN) // father
    {
      ObjectStore[ObjectStore_br+3]=C_S_WIN;   // father
      ObjectStore[ObjectStore_br+4]=83+64*(ObjectStore_br-C_S_WIN)/5; // 1+2+4*20+128*N/10
      ObjectStore[ObjectStore_br+5]=2047;   // maska
    }
    else if (ObjectStore_br>CLASS_SYSTEM)
    {
      ObjectStore[ObjectStore_br+3]=CLASS_SYSTEM;
      ObjectStore[ObjectStore_br+4]=3+2*(ObjectStore_br-CLASS_SYSTEM)/5; // 4*N/10
      ObjectStore[ObjectStore_br+5]=127;
    }
    else if (ObjectStore_br==CLASS_SYSTEM)
    {
      ObjectStore[ObjectStore_br+3]=CLASS_OBJECT;
      ObjectStore[ObjectStore_br+4]=3;
      ObjectStore[ObjectStore_br+5]=3;
    }
    else if (ObjectStore_br==CLASS_OBJECT)
    {
      ObjectStore[ObjectStore_br+3]=M1;
      ObjectStore[ObjectStore_br+4]=1;
      ObjectStore[ObjectStore_br+5]=1;
    }
    else // ObjectStore_br==0)
    {
      ObjectStore[ObjectStore_br+3]=M1;
      ObjectStore[ObjectStore_br+4]=0;
      ObjectStore[ObjectStore_br+5]=0;
    }
  }
  ObjectStore[2]=0;
  ObjectStore[7]=M1;
  ObjectStore[CLASS_OBJECT+6]=CLASS_SYSTEM;
  ObjectStore[CLASS_OBJECT+7]=M1;
  ObjectStore[CLASS_SYSTEM+6]=CLASS_S_CLASS;
  ObjectStore[CLASS_SYSTEM+7]=M1;
  ObjectStore[C_S_WIN+6]=C_S_WIN_Main;
  ObjectStore[C_S_WIN+7]=M1;
  ObjectStore[C_S_WIN_Embedded+7]=M1;
   // size
  ObjectStore[CLASS_OBJECT+2]=2;
  ObjectStore[CLASS_SYSTEM+2]=2;
  ObjectStore[CLASS_S_CLASS+2]=10;
  ObjectStore[CLASS_SYSTEM_FILE+2]=3;
  ObjectStore[CLASS_SYSTEM_LIST+2]=7;
  ObjectStore[CLASS_SYSTEM_ActiveX+2]=12;
  ObjectStore[CLASS_SYSTEM_PEN+2]=3;
  ObjectStore[CLASS_SYSTEM_BRUSH+2]=3;
  ObjectStore[CLASS_SYSTEM_FONT+2]=3;
  ObjectStore[CLASS_SYSTEM_FONTMASK+2]=2+96/v4_8; // 96>=sizeof(CHARFORMAT), 96 mod 8 = 0
#if TR
  if (sizeof(CHARFORMAT)!=92)
    MitiText("The size of CHARFORMAT is changed!\r\n", &cf_red);
#endif
  ObjectStore[CLASS_SYSTEM_BITMAP+2]=6;
  ObjectStore[CLASS_SYSTEM_TIMER+2]=4;
  ObjectStore[CLASS_SYSTEM_DLL+2]=3;
  ObjectStore[CLASS_SYSTEM_SOCKET+2]=8; // why 8, it looks like that 3 is enough

  ObjectStore[CLASS_SYSTEM_MYSQL+2]    =3; // MY_SQL, RadoSQL
  ObjectStore[CLASS_SYSTEM_MYSQL_RES+2]=3; //
  ObjectStore[CLASS_SYSTEM_MYSQL_ROW+2]=3; //

  ObjectStore[CLASS_SYSTEM_CONTAINER+2]=8;
  ObjectStore[CLASS_SYSTEM_MENU+2]=10;
  ObjectStore[C_S_WIN+2]=10;
  ObjectStore[C_S_WIN_Main+2]=10;
  ObjectStore[C_S_WIN_Dialog+2]=10;
  ObjectStore[C_S_WIN_Static+2]=10;
  ObjectStore[C_S_WIN_Edit+2]=10;
  ObjectStore[C_S_WIN_Slider+2]=10;
  ObjectStore[C_S_WIN_ScrollBar+2]=10;
  ObjectStore[C_S_WIN_Animate+2]=10;
  ObjectStore[C_S_WIN_ListBox+2]=10;
  ObjectStore[C_S_WIN_TreeBox+2]=10;
  ObjectStore[C_S_WIN_Bitmap+2]=10;
  ObjectStore[C_S_WIN_Icon+2]=10;
  ObjectStore[C_S_WIN_Button+2]=10;
  ObjectStore[C_S_WIN_CheckBox+2]=10;
  ObjectStore[C_S_WIN_Embedded+2]=12;
  if (!error)
  {
    i=FIRST_ROWS;
    k=program_br1; 
    MY_WORD mem;
Re1:for( ; i<k; i++)
    {
      if ((Program[i]&HALF) || (Prog_fild[Program[i]+1]&QUARTER))
        continue;
      j=Prog_fild[Program[i]];
      if (j>=TT_START && Chfil_c[j-TT_START]==1)
      {
        mem=Ufil_c1[j-TT_START];
        if (Pointers[mem]&OBSEG1)
          Warning(306, 0x40+0x80, mem, 4*i+(k==program_br2)); // redefine the built-in predicate:
      }
      else
      {
        mem=QUARTER | j;
        if (Pointers[j]&OBSEG2)
          Warning(406, 0x40+0x80, j, 4*i+(k==program_br2)); // redefine the built-in atom:
      }
      for (t=func_br; t-->0 && (Functors[t]&HALFM)!=mem; );
      if (t==M1) // new
      {
        if (func_br>=FUNCTOR_L && correct_FUNCTOR())
        {
          Warning( 99, 0, 0, 0);
          MitiText("Too many functors! No space!\r\n");
          goto e1;
        }
        Functors[func_br++]=mem;
        if ((mem&MASKA2)>=MEMORY_c256 || (mem&MASKA2)==TT_VAR)
          Warning(9, 0x40+0x80, mem, 4*i+(k==program_br)); // Strange predicate
      }
      else if (k==program_br && (t<func_br-1 || i==program_br2) && !(Functors[t]&HALF) && (mem&MASKA2)!=Definition[DF_DEFINE_SYS_VAR])
      {   // redefine
        Warning(6, 0x40+0x80, mem, 4*i+(t<func_in_ADD)); // (defined in the ADD file) or (has an interrupted definition)
        Functors[t]|=HALF;
      }
    }
    if (i==program_br1)
    {
      i=program_br2;
      k=program_br;
      func_in_ADD=func_br;
      goto Re1;
    }
    Program[FIRST_ROWS-1]=HALF;
    for (i=1; i<FIRST_ROWS-2; Prog_fild[Program[i++]+1]=HALF);// as if we have sp_types in the head
    if (Pointers[TT_VAR] & HALF)
    {
      main_h1=1;
      Warning(10, 0x40, 0, 0); // You have a clause with a variable for head.
    }
    else
      main_h1=0;
    if (!(Mtree[0][1] & HALF))
    {
      Warning( 99, 0, 0, 0);
      MitiText("You need at least one head with arguments.\r\n");
    }
    if ((Pointers[TT_VAR]&OBSEG1)==0)   // for easy check M1->?
      put_in_f(M1, TT_VAR, 2, OBSEG1);  // bult-in predicte
    if ((Pointers[TT_VAR]&OBSEG2)==0)   // built-in acsiom
      put_in_f(M1, TT_VAR, 3, OBSEG2);
    if ((Pointers[TT_VAR]&OBSEG3)==0)   // function
      put_in_f(M1, TT_VAR, 4, OBSEG3);
    if ((Pointers[TT_VAR]&OBSEG4)==0)   // constant
      put_in_f(M1, TT_VAR, 5, OBSEG4);
    if ((Pointers[TT_VAR]&OBSEG5)==0)   // object name ? do we need this
      put_in_f(M1, TT_VAR, 6, OBSEG5);
    //if ((Pointers[TT_VAR]&OBSEG6)==0)   // op // this will make problems in check_op
    //  put_in_f(M1, TT_VAR, 7, OBSEG6);
    for (a1=global_br=global_br2, j=0; j<global_br; j++)
    {
      if (global2[j]==1 && j>=RedLine && !(flag&6))
        Warning(5, 64, j, 0);
      global2[j]=j;
    }
  }
e1:
  global_br=global_br2; // bug correction
#if !CONSOLE
  if (!(flag&4))
  {
    status_fl&=M1^1;       // Can't do next
    if (put_nl==1)
    {
      put_nl = 0;
      MitiText("\r\n");
    }
    sprintf(string2, "%d error%s, %d warning%s.\r\n",
            (int)error, (error==1)?"":"s", (int)warn_br, (warn_br==1)?"":"s");
    MitiText(string2);
  }
  pCompiled=pActive;
  MitiRedraw();
#endif
  return;
}

MY_WORD include_f(MY_WORD file_n, MY_WORD flag)
{
  MY_WORD i, j, t;
  DWORD k;
  
#if CONSOLE
    if (file_n==0)
    {
      strcpy(string2, ProgramPath);
      strcat(string2, "Standard.add");
      if ((file=open(string2, O_RDONLY | O_TEXT))==-1)  // Addition to the File
      {
        MitiText("\r\nUnable to open Standard.add!\r\n");
        error++;
        return(0);
      }
    }
    else if (file_n==1)
    {
      if (flag&4)
      {
        error++;
        pCompiled=pActive;
        return(0);
      }
      program_br1=program_br;
      program_br2=program_br=program_br1+300;
      Program2[program_br2]=0;
      if ((file=open(namef, O_RDONLY | O_TEXT))==-1)  // Addition to the File
      {
        MitiText("\r\nUnable to open the main file!\r\n");
        error++;
        return(0);
      }
    }
    else
    {
      if ((file=open((LPSTR)(StringStore+AddedFiles[file_n-AddedFiles_temp]), O_RDONLY | O_TEXT))==-1)  // Definitions
      {
        MitiText("\r\nUnable to open the include file:\r\n");
        MitiText((LPSTR)(StringStore+AddedFiles[file_n-AddedFiles_temp]));
        MitiText("\r\n");
        error++;
        return(0);
      }
    }
    lseek(file,0,SEEK_SET);
    f_end=read(file, string, L_BUFER);
#else
    if (file_n==0)
    {
      CString str;
      if (pInfo2->m_AddFile=="Standard.add" || pInfo2->m_AddFile=="")
        str=ProgramPath + _T("Standard.add");
      else
        str=pInfo2->m_AddFile;
      if (file.Open(str, CFile::modeRead)==0)  // Addition to the File
      {
        if (!(flag&4))
        {
          Warning( 99, 0, 0, 0);
          MitiText("\r\nUnable to open the ADD file:\r\n", &cf_red);
          MitiText(make_utf8(str));
          MitiText("\r\n");
        }
        else
          error++;
        return(0);
      }
      file.SeekToBegin();
    }
    else if (file_n==1)
    {
      sv_c_old=sv_c; sv_v_old=sv_v; sv_sub_old=sv_sub;
      if (flag&4)
      {
        pCompiled=pActive;
        return(0);
      }
      RedLine=global_br2;
      program_br1=program_br;
      program_br2=program_br=program_br1+300;
      Program2[program_br2]=0;
      if (file.Open(namef, CFile::modeRead)==0)   // Main Program
      {
        Warning( 99, 0, 0, 0);
        sprintf((LPSTR)string2, "\r\nUnable to open the main file:\r\n%s\r\n", namef);
        MitiText((LPSTR)string2, &cf_red);
        return(0);
      }
      if (pInfo2!=&DefaultProject)
      {
        if (status_fl&64) // Run Directly
        {
          BYTE ch_warn, ch_ver, num_int, num_str;
          MY_WORD Head;
          CArchive ar(&file, CArchive::load);

          ar>>ch_warn;
          ar>>ch_ver;
          if (ch_ver==1)
          {
            num_int=14;
            num_str=1;
          }
          else if (ch_ver==2)
          {
            if (ch_warn>1)
              MessageBoxA(NUL,
                "Warning: This project file is made on a newer version of Strawberry Prolog.\r\n",
                   "Strawberry Prolog 6.0", MB_OK | MB_ICONEXCLAMATION);
            ar>>num_int;
            ar>>num_str;
          }
          else if (ch_ver>2)
          {
            MessageBoxA(NUL,
               "Error: This project file cannot be open. It is made on a newer version of Strawberry Prolog.\r\n\r\n",
                   "Strawberry Prolog 6.0", MB_OK | MB_ICONSTOP);
            ar.Close();
            file.Close();
            error++;
            return(0);
          }
          ar>>pInfo2->m_Settings;
          pInfo2->m_Settings&=M1^6; // Active Break Point and St. is full as fail
          ar>>pInfo2->m_Break_point;
          ar>>pInfo2->m_Colors;
          ar>>pInfo2->STACK_start;
          ar>>pInfo2->BUDA_start;
          ar>>pInfo2->BUDA_S_start;
          ar>>pInfo2->STACK_max;
          ar>>pInfo2->BUDA_max;
          ar>>pInfo2->BUDA_S_max;
          ar>>pInfo2->m_lf.lfHeight;
          ar>>pInfo2->m_lf.lfWidth;
          ar>>pInfo2->m_lf.lfEscapement;
          ar>>pInfo2->m_lf.lfOrientation;
          ar>>pInfo2->m_lf.lfWeight;
          for (MY_INT t_num; num_int>14; ar>>t_num, num_int--);
          { // for st
           CString st;
           ar>>st;
           my_strcpy(pInfo2->m_lf.lfFaceName, st);
          }
          if (ch_ver==2)
          {
            ar>>pInfo2->m_AddFile;
            ar>>pInfo2->m_DefFile;
            ar>>pInfo2->m_ExeFileName;
            ar>>pInfo2->m_Comments;
            if (num_str>5)
            {
              ar>>pInfo2->m_GetMethod;
              ar>>pInfo2->m_PostMethod;
              ar>>pInfo2->m_ProgArg;
            }
            else
            {
              pInfo2->m_GetMethod="new";
              pInfo2->m_PostMethod="new";
              pInfo2->m_ProgArg="";
            }
            CString st;
            for ( ; num_str-->8; ar>>st);
            for (ar>>i; i-->0; ar>>st, pInfo2->m_FilesList.Add(st) );
            for (i=0; i<744; ar>>pInfo2->m_Icon[i++]);
          }
          { // for fp
           ar.Flush();
           CFile* fp = ar.GetFile();
           Head=(MY_WORD)fp->GetPosition();
          }
          ar.Close();
          if (pInfo2->STACK_start<8)
            pInfo2->STACK_start=8;
          if (pInfo2->BUDA_start<MAX_VARS+2048)
            pInfo2->BUDA_start=MAX_VARS+2048;
          if (pInfo2->BUDA_S_start<MAX_VARS)
            pInfo2->BUDA_S_start=MAX_VARS;
          file.Seek(Head, CFile::begin);
        }
        else
          file.Seek(pActive->m_Head, CFile::begin);
      }
      else
        file.SeekToBegin();
    }
    else if (file_n<AddedFiles_temp)
    {
      if (file.Open(pInfo2->m_FilesList[file_n-2], CFile::modeRead)==0)  // Definitions
      {
        MitiText("\r\n"); // ?
        Warning( 99, 0, 0, 0);
        MitiText("Unable to open the project file:\r\n");
        MitiText(make_utf8(pInfo2->m_FilesList[file_n-2]), &cf_black);
        MitiText("\r\n");
        return(0);
      }
      else
      {
        put_nl=1;
        MitiText(" + ", &cf_red);
      }
      MitiText(make_utf8(pInfo2->m_FilesList[file_n-2]), &cf_black);
      file.SeekToBegin();
    }
    else
    {
      if (file.Open(make_long(StringStore+AddedFiles[file_n-AddedFiles_temp]), CFile::modeRead)==0)  // Definitions
      {
        Warning( 99, 0, 0, 0);
        MitiText("\r\nUnable to open the include file:\r\n");
        ChangeCharset(ch_set, 0, StringStore+AddedFiles[file_n-AddedFiles_temp], (BYTE *)string2, &k, default_char);
        MitiText(string2, &cf_black);
        MitiText("\r\n");
        return(0);
      }
      else
      {
        put_nl = 1;
        MitiText(" + ", &cf_red);
        ChangeCharset(ch_set, 0, StringStore+AddedFiles[file_n-AddedFiles_temp], (BYTE *)string2, &k, default_char);
        MitiText(string2, &cf_black);
      }
      file.SeekToBegin();
    }
    f_end=file.Read(string, L_BUFER);
#endif
  i_poin=read_br=newline_br=0;
  string[f_end]=0;
  if (string[0]=='#' && string[1]=='!')
  {
    while(string[i_poin++]!='\n' && string[i_poin]);
    newline_br=1;
  }
  while(f_end && f_end!=M1)
  {
    if (read_n(&t, 9))
    {
      if (program_br>=PROGRAM_L && correct_PROG_L() ) // Program is too long!
      {
        Warning( 99, 0, 0, 0);
        MitiText("\r\nProgram is too long!\r\n");
        goto e_end;
      }
      Program[program_br]=t;
      if (t>=TT_START && Chfil_c[t-=TT_START]==1)
      {
        if (Ufil_c1[t]==Definition[DF_INCLUDE])  // include
        {
          if (AddedFiles_br-AddedFiles_temp >= ADDED_FILES)
          {
            Warning( 99, 0, 0, 0);
            MitiText("Too many files are included.\r\n");
            goto e_end;
          }
          AddedFiles[AddedFiles_br++ -AddedFiles_temp]=NewObj[sv_NewObj-1];
          continue;
        }
        else if (Ufil_c1[t]==Definition[DF_OP] || Ufil_c1[t]==Definition[DF_UNDEF_OP])   // op
        {
          MY_WORD temp;
          if ((temp=Ufil_c2[t])>=TT_START && (i=Ufil_c2[temp-=TT_START])>=TT_START && (k=Ufil_c2[i-=TT_START])>=TT_START)
          {
            k-=TT_START;
            if (Ufil_c1[t]==Definition[DF_OP])
            {
              if (Ufil_c2[k]==TT_LIST)
                Add_op(NewObj[sv_NewObj-1], Ufil_c1[i], Ufil_c1[k], Ufil_c1[k]);
            }
            else
            {
              if (Ufil_c2[k]==TT_LIST) // problems for undef_op( _, x, x) must exist at least one new obj
                Delete_op(NewObj1[sv_NewObj-1], NewObj[sv_NewObj-1], Ufil_c1[i], Ufil_c1[k], Ufil_c1[k]);
            }
            continue;
          }
          else  // Bad definition of operator.
          {
            Warning( 99, 0, 0, 0);
            MitiText("Bad definition of operator. (The \"op\" predicate.)\r\n");
            goto e_end;
          }
        }
      }
      assert(program_br, 1);
      if (program_br<FIRST_ROWS || (Program[program_br]&HALF))
        goto e11;
 #if TR
      for(t=1; t<=Atoms[program_br]; t++)
      {
        j=Prog_fild[Program[program_br]+2*t];
        if (!(Pointers[j] & QUARTER))
        {
          if (registrate(j, QUARTER) != j)
            MitiText("It can't be. Diferent3\r\n");
          put_in_f(program_br, j, 1, QUARTER);  // 0->?
        }
      }
#endif
     if (Prog_fild[Program[program_br]+1]&QUARTER)
        goto e11;
      j=Prog_fild[Program[program_br]];
      if (Pointers[j] & HALF)
      {
        for (t=D_field[Pointers[j] & MASKA3]; ProgTail[t]!=M1 && ProgTail[t]!=t; t=ProgTail[t]);
        if (ProgTail[t]==t)
        {
          Warning( 99, 0, 0, 0);
          sprintf(string2, "The clause %d is unreachable (after :--).\r\n", (int)(program_br-program_br2));
          MitiText(string2);
        }
        else
          ProgTail[t]=program_br;
      }
      else 
      {
        if (registrate(j, HALF) != j)
          MitiText("It can't be. Diferent2a\r\n");
        put_in_f(program_br, j, 0, HALF);
      }

e11:  for(i=0; i<list_br; Buda1[buda_br+i++]=TT_VAR); //temp
      
      Program3[program_br]=newline_br+1;
      ++program_br;
      if (file_n==0)
        Program2[program_br]=0;
      else if (file_n==1)
        Program2[program_br]=i_poin+read_br-newline_br+1; //-newline_br
      else
        Program2[program_br]=Program2[program_br-1];
        
    }
  }
e_end:

#if CONSOLE
  close(file);
#else
  file.Close();
#endif
  return(1);
}

void Add_op(MY_WORD Priority, MY_WORD Assoc, MY_WORD Atom, MY_WORD Minning)
{
  unsigned i, min, max, Assoc2; 

  if (Priority==1000) // place for the comma
  {
    Warning( 99, 0, 0, 0);
    MitiText("The priority in the operator definition cannot be 1000 because this value is reserved for comma and for |..\r\n");
    return;
  }
  if (Definition[DF_TERM]==Assoc)
    Assoc2=0;
  else
  {
    for (Assoc2=0; Assoc2<20 && Definition[Assoc2+DF_FX]!=Assoc; Assoc2++);
    if (Assoc2==20)
    {
      Warning( 99, 0, 0, 0);
      MitiText("The type in the operator definition is wrong.\r\n");
      return;
    }
    if (Assoc2>15)
      Assoc2=8*(Assoc2-16)+34;  // 2+32
    else
    {
      if (Assoc2%4==3)        // Assoc .. 012 . x-xx . Left x-y . Right x-y . 2x-2xx
                              // 0 prefics, 1 sufics, 2 infics
        Assoc2=18+(Assoc2&12);// 2+16 4+8
      else if (Assoc2%4==1 && (Assoc2&8))     // prefics fy
        Assoc2+=8;          // -8+16
    }
    Assoc2++;
  }
  if ((Assoc2&36) && Priority<1000)
  {
    Warning( 99, 0, 0, 0);
    MitiText("Types with xx or with yy can be used only for operators with priority bigger than 1000.\r\n");
    return;
  }
  min=0;
  max=oper_br;
  while(min+1<max)
  {
    if (Atom<Oper[(min+max)/2])
      max=(min+max)/2;
    else if (Atom==Oper[(min+max)/2])
    {
      for (min=(min+max)/2; min && Oper[min-1]==Atom; min--);
et:   for ( max=min; Oper[max]==Atom; max++)
      {
        if (OpPr[max]==Priority && OpType[max]==Assoc2 && OpMin[max]==Minning)
          return;
        else if ((OpType[max]&2)==(Assoc2&2))
        {
          // Warning(11, 0, max, Assoc2); // if you define one operator twice
          MitiText("Warning: ", &cf_green);
          MitiText("In this version of Strawberry Prolog ");
          if ((OpType[max]&3)==(Assoc2&3))
            MitiText("if you define one operator twice then it should be defined with different types.\r\n");
          else if ((Assoc2&2)==0)
            MitiText("you cannot define one operator both as a prefix and as a type term.\r\n");
          else
            MitiText("you cannot define one operator both as an infix and as a suffix.\r\n");
          return;
        }
      }
      if (oper_br==BUFFERS-1)
        goto et2;
      goto et1;
    }
    else
      min=(min+max)/2;
  }
  if (Atom<=Oper[min])
  {
    if (Atom==Oper[min] && oper_br) // only for '0'
      goto et;
    else
      max=0;
  }
  if (oper_br==BUFFERS-1)
  {
  et2:Warning( 99, 0, 0, 0);
    MitiText("Too many definitions of operators.\r\n");// error of space
    return;
  }
  put_in_f(max, Atom, 7, OBSEG6);
et1:
  for (i=oper_br; i>max; i--)
  {
    if (i==1 || Oper[i-1]!=Oper[i-2])
      D_field[(Pointers[Oper[i-1]]&MASKA3)+7]++;
    OpPr[i]=OpPr[i-1];
    OpType[i]=OpType[i-1];
    Oper[i]=Oper[i-1];
    OpMin[i]=OpMin[i-1];
  }
  oper_br++;
  Oper[oper_br]=M1; // for easy chck Oper[i]!=Oper[i+1]
  OpPr[max]=Priority;
  OpType[max]=Assoc2;
  Oper[max]=Atom;
  OpMin[max]=Minning;
  /*
  if (Pointers[Atom]&OBSEG6)
  {
    for ( i=D_field[(Pointers[Atom]&MASKA3)+7]; Oper[i]==Atom; i++)
      if (OpPr[i]==Priority && OpType[i]==Assoc2 && OpMin[i]==Minning)
        return;
    if (i==oper_br)
      goto et1;
    if (Oper[i]==M1) // free place
      goto et2;
    j=D_field[(Pointers[Atom]&MASKA3)+7];
    if (oper_br+i-j>=BUFFERS)  
      goto et3;
    for ( k=j; k<i; k++)
    {
      OpPr[oper_br+k-j]=OpPr[k];
      OpType[oper_br+k-j]=OpType[k];
      Oper[oper_br+k-j]=Oper[k];
      OpMin[oper_br+k-j]=OpMin[k];
      Oper[k]=M1; // free it
    }
    D_field[(Pointers[Atom]&MASKA3)+7]=oper_br;
    oper_br+=i-j+1;
    i=oper_br-1;  
    goto et2;
  }
  else
  {
    put_in_f(oper_br, Atom, 7, OBSEG6);
    i=oper_br;  
et1:
    if (oper_br==BUFFERS)
    {
et3:  Warning( 99, 0, 0, 0);
      MitiText("Too many definitions of operators.\r\n");// error of space
      return;
    }
    oper_br++;
et2:
    OpPr[i]=Priority;
    OpType[i]=Assoc2;
    Oper[i]=Atom;
    OpMin[i]=Minning;
  }
  */
}
void Delete_op(MY_WORD PriorityType, MY_WORD Priority, MY_WORD Assoc, MY_WORD Atom, MY_WORD Minning)
{
  unsigned i, k, Assoc2; 

  if (Assoc  ==TT_LINK) Assoc  =TT_VAR;
  if (Atom   ==TT_LINK) Atom   =TT_VAR;
  if (Minning==TT_LINK) Minning=TT_VAR;

  if (Assoc!=TT_VAR)
  {
    if (Definition[DF_TERM]==Assoc)
      Assoc2=0;
    else
    {
      for (Assoc2=0; Assoc2<20 && Definition[Assoc2+DF_FX]!=Assoc; Assoc2++);
      if (Assoc2==20)
      {
        Warning( 99, 0, 0, 0);
        MitiText("The type in the operator definition is wrong.\r\n");
        return;
      }
      if (Assoc2>15)
        Assoc2=8*(Assoc2-16)+34;  // 2+32
      else
      {
        if (Assoc2%4==3)        // Assoc .. 012 . x-xx . Left x-y . Right x-y . 2x-2xx
                                // 0 prefics, 1 sufics, 2 infics
          Assoc2=18+(Assoc2&12);// 2+16 4+8
        else if (Assoc2%4==1 && (Assoc2&8))     // prefics fy
          Assoc2+=8;          // -8+16
      }
      Assoc2++;
    }
  }
  if (Atom==TT_VAR)
    i=0;
  else if (Pointers[Atom]&OBSEG6)
    i=D_field[(Pointers[Atom]&MASKA3)+7];
  else
    return;
  for (k=0; i<oper_br; i++)
  {
    if ((PriorityType!=TT_INT || OpPr[i]==Priority) && (Assoc==TT_VAR || OpType[i]==Assoc2)
          && (Atom==TT_VAR || Oper[i]==Atom) && (Minning==TT_VAR || OpMin[i]==Minning))
    {
      if (Oper[i]!=Oper[i+1] && (i==k || Oper[i]!=Oper[i-k-1]))
      {
        D_field[(Pointers[Oper[i]]&MASKA3)+7]=M1;
        Pointers[Oper[i]]&=M1^OBSEG6;
      }
      k++;
    }
    else if (k>0)
    {
      if (i-k>0 && Oper[i]!=Oper[i-k-1])
        D_field[(Pointers[Oper[i]]&MASKA3)+7]=i-k;
      OpPr[i-k]=OpPr[i];
      OpType[i-k]=OpType[i];
      Oper[i-k]=Oper[i];
      OpMin[i-k]=OpMin[i];
    }
  }
  oper_br-=k;
  Oper[oper_br]=M1; // for easy chck Oper[i]!=Oper[i+1]
}
