// not UNIX
// New_Class.cpp : implementation file
//

#include "stdafx.h"
#include "Strawberry.h"

#include "MainFrm.h"
#include "New_Class.h"

#define WINDOW_SIZE 4000

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#if PROF
#define IN_LIGHT_IF_EXE
#else
#define IN_LIGHT_IF_EXE  if(status_fl&512)
#endif

/////////////////////////////////////////////////////////////////////////////
// C_FrameWnd

IMPLEMENT_DYNCREATE(C_FrameWnd, CFrameWnd)

C_FrameWnd::C_FrameWnd()
{
  m_bAutoMenuEnable=FALSE;
}

C_FrameWnd::~C_FrameWnd()
{
}


BEGIN_MESSAGE_MAP(C_FrameWnd, CFrameWnd)
	  ON_WM_HSCROLL()
	  ON_WM_VSCROLL()
    ON_WM_LBUTTONDBLCLK()
    ON_WM_PAINT()
    ON_WM_LBUTTONDOWN()
    ON_WM_LBUTTONUP()
    ON_WM_RBUTTONDOWN()
    ON_WM_RBUTTONUP()
    ON_WM_MOUSEMOVE()
    ON_WM_MOUSEWHEEL()
    ON_WM_DESTROY()
    ON_WM_CLOSE()
    ON_WM_TIMER()
    ON_WM_SIZE()
    ON_WM_KEYDOWN()
    ON_WM_KEYUP()
    ON_WM_CHAR()

    ON_MESSAGE(WM_CTLCOLORSTATIC, OnCtrlColor)
    ON_MESSAGE(WM_CTLCOLORBTN, OnCtrlColor)
    ON_MESSAGE(WM_CTLCOLOREDIT, OnCtrlColor)
    ON_MESSAGE(WM_CTLCOLORLISTBOX, OnCtrlColor)
    ON_MESSAGE(WM_CTLCOLORSCROLLBAR, OnCtrlColor)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// C_FrameWnd message handlers

void C_FrameWnd::OnPaint() 
{
  G_rgnPaint.CreateRectRgn(0,0,0,0); // we have to init and to call DeleteObject on the end!!! Maybe we have to init only onece
  GetUpdateRgn(&G_rgnPaint);
  GetUpdateRect(&G_rectPaint);  
  CPaintDC dc(this); // device context for painting
  if (ObjectStore[m_Number+4]&16)     // paint_indirectly
  {
    CDC dcMemory;
    dcMemory.CreateCompatibleDC(&dc);
    CBitmap bmp;
    bmp.CreateCompatibleBitmap(&dc, G_rectPaint.Width(), G_rectPaint.Height());
    dcMemory.SelectObject(&bmp);
    if (G_rectPaint.left!=0 || G_rectPaint.top!=0)
    {
      CRgn rgnTemp;
      rgnTemp.CreateRectRgn(0,0,0,0);
      rgnTemp.CopyRgn( &G_rgnPaint);
      rgnTemp.OffsetRgn( -G_rectPaint.left, -G_rectPaint.top);
      dcMemory.SelectClipRgn( &rgnTemp, RGN_COPY); // unfortunatly SetViewportOrg do not move Rgn
      rgnTemp.DeleteObject();
      dcMemory.SetViewportOrg( -G_rectPaint.left, -G_rectPaint.top);
    }
    else
      dcMemory.SelectClipRgn( &G_rgnPaint, RGN_COPY);
    pMain_DC=&dcMemory;
    if (0 && ObjectStore[m_Number+4]&0x8000) // the overlaping brus is bitmap
    {
      UnrealizeObject((HBRUSH)ObjectStore[m_Number+9]);
      pMain_DC->SetBrushOrg((-G_rectPaint.left)&7, (-G_rectPaint.top)&7);
    }
    FillRect(pMain_DC->m_hDC, CRect(G_rectPaint.left&(M1^7),G_rectPaint.top&(M1^7),G_rectPaint.right,G_rectPaint.bottom), (HBRUSH)ObjectStore[m_Number+9] );
    
    pMain_DC->SetTextColor(ObjectStore[m_Number+7]);
    pMain_DC->SetBkColor(ObjectStore[m_Number+8]);
    pMain_DC->SetTextAlign(TA_UPDATECP);
    make_call(0, ObjectStore[m_Number+3], DF_PAINT, 0, 0, 0, 0, 0, 0);
    
    dcMemory.SetViewportOrg(0, 0);
    dc.BitBlt(G_rectPaint.left, G_rectPaint.top, G_rectPaint.Width(), G_rectPaint.Height(), &dcMemory, 0, 0, SRCCOPY);
  }
  else
  {
    pMain_DC=&dc;
    if (ObjectStore[m_Number+6]!=ObjectStore[m_Number+9])
    {
      if (ObjectStore[m_Number+4]&0x8000) // the overlaping brus is bitmap
      {
        // this is not working!
        UnrealizeObject((HBRUSH)ObjectStore[m_Number+9]);
        pMain_DC->SetBrushOrg((G_rectPaint.left)&7, (G_rectPaint.top)&7);
        pMain_DC->SelectObject((HBRUSH)ObjectStore[m_Number+9]);
      }
      FillRect(pMain_DC->m_hDC, &G_rectPaint, (HBRUSH)ObjectStore[m_Number+9] );
    }  
    pMain_DC->SetTextColor(ObjectStore[m_Number+7]);
    pMain_DC->SetBkColor(ObjectStore[m_Number+8]);
    pMain_DC->SetTextAlign(TA_UPDATECP);
    make_call(0, ObjectStore[m_Number+3], DF_PAINT, 0, 0, 0, 0, 0, 0);
  }
  status_fl &= M1^1024;   // from_update_window (not anymore)
  pMain_DC=NULL;
  G_rgnPaint.DeleteObject();
  G_rectPaint.SetRect(0, 0, 0, 0);
  // Do not call CFrameWnd::OnPaint() for painting messages
}

void C_FrameWnd::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) // scroll
{
  UINT nPos2=0, Type=0;

  switch(nSBCode)
  {
   case SB_THUMBPOSITION:    // Moved to
    Type=Definition[DF_THUMB_MOVED_TO];
    nPos2=nPos;
    break;
   case SB_THUMBTRACK:    // Drag to
    Type=Definition[DF_THUMB_TRACK];
    nPos2=nPos;
    break;
   case SB_PAGEDOWN:    // Page Down
    Type=Definition[DF_PAGE];
    nPos2=1;
    break;   
   case SB_LINEDOWN:    //  Down
    Type=Definition[DF_LINE];
    nPos2=1;
    break;
   case SB_PAGEUP:    // Page Up
    Type=Definition[DF_PAGE];
    nPos2= -1;
    break;   
   case SB_LINEUP:    //  Up
    Type=Definition[DF_LINE];
    nPos2= -1;
    break;   
  }
  if (pScrollBar==NULL)
  {
    pMainWindow=pMain_Frame=this;
    make_call(3, ObjectStore[m_Number+3], DF_SCROLL, Definition[DF_HORIZONTAL], 0, Type, 0, TT_INT, (MY_INT)(int)nPos2);
  }
  else
  {
    int i=pScrollBar->GetDlgCtrlID();
    int p=((CSliderCtrl*)pScrollBar)->GetPos();
    pMain_Frame=this;
    pMainWindow=pScrollBar; // !!! pointer may be temporary and should not be stored for later use
    make_call(3, ObjectStore[i+3], DF_SCROLL, Type, 0, TT_INT, (MY_INT)(int)nPos2, TT_INT, (MY_INT)(int)p);
  }
  CFrameWnd::OnHScroll(nSBCode, nPos, pScrollBar);
}
void C_FrameWnd::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) // scroll
{
  UINT nPos2=0, Type=0;

  switch(nSBCode)
  {
   case SB_THUMBPOSITION:    // Moved to
    Type=Definition[DF_THUMB_MOVED_TO];
    nPos2=nPos;
    break;
   case SB_THUMBTRACK:    // Drag to
    Type=Definition[DF_THUMB_TRACK];
    nPos2=nPos;
    break;
   case SB_PAGEDOWN:    // Page Down
    Type=Definition[DF_PAGE];
    nPos2=1;
    break;   
   case SB_LINEDOWN:    //  Down
    Type=Definition[DF_LINE];
    nPos2=1;
    break;
   case SB_PAGEUP:    // Page Up
    Type=Definition[DF_PAGE];
    nPos2= -1;
    break;   
   case SB_LINEUP:    //  Up
    Type=Definition[DF_LINE];
    nPos2= -1;
    break;   
  }
  if (pScrollBar==NULL)
  {
    pMainWindow=pMain_Frame=this;
    make_call(3, ObjectStore[m_Number+3], DF_SCROLL, Definition[DF_VERTICAL], 0, Type, 0, TT_INT, (MY_INT)(int)nPos2);
  }
  else
  {
    int i=pScrollBar->GetDlgCtrlID();
    int p=((CSliderCtrl*)pScrollBar)->GetPos();
    pMain_Frame=this;
    pMainWindow=pScrollBar; // !!! pointer may be temporary and should not be stored for later use
    make_call(3, ObjectStore[i+3], DF_SCROLL, Type, 0, TT_INT, (MY_INT)(int)nPos2, TT_INT, (MY_INT)(int)p);
  }
  CFrameWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}
void C_FrameWnd::OnLButtonDblClk(UINT nFlags, CPoint point) // double_click
{
  G_FlagsMes=nFlags&0x7f;
  pMainWindow=pMain_Frame=this;
  make_call(2, ObjectStore[m_Number+3], DF_DOUBLE_CLICK, TT_INT, point.x, TT_INT, point.y, 0, 0);
  CFrameWnd::OnLButtonDblClk(nFlags, point);
}
void C_FrameWnd::OnLButtonDown(UINT nFlags, CPoint point) // mouse_click
{
  G_FlagsMes=nFlags&0x7f;
  pMainWindow=pMain_Frame=this;
  make_call(2, ObjectStore[m_Number+3], DF_MOUSE_CLICK, TT_INT, (MY_INT)(int)point.x, TT_INT, (MY_INT)(int)point.y, 0, 0);
  CFrameWnd::OnLButtonDown(nFlags, point);
}
void C_FrameWnd::OnLButtonUp(UINT nFlags, CPoint point) // mouse_click_up
{
  G_FlagsMes=nFlags&0x7f;
  pMainWindow=pMain_Frame=this;
  make_call(2, ObjectStore[m_Number+3], DF_MOUSE_CLICK_UP, TT_INT, (MY_INT)(int)point.x, TT_INT, (MY_INT)(int)point.y, 0, 0);
  CFrameWnd::OnLButtonUp(nFlags, point);
}

void C_FrameWnd::OnRButtonDown(UINT nFlags, CPoint point) // r_mouse_click
{
  G_FlagsMes=nFlags&0x7f;
  pMainWindow=pMain_Frame=this;
  make_call(2, ObjectStore[m_Number+3], DF_R_MOUSE_CLICK, TT_INT, (MY_INT)(int)point.x, TT_INT, (MY_INT)(int)point.y, 0, 0);
  CFrameWnd::OnRButtonDown(nFlags, point);
}
void C_FrameWnd::OnRButtonUp(UINT nFlags, CPoint point) // r_mouse_click_up
{
  G_FlagsMes=nFlags&0x7f;
  pMainWindow=pMain_Frame=this;
  make_call(2, ObjectStore[m_Number+3], DF_R_MOUSE_CLICK_UP, TT_INT, (MY_INT)(int)point.x, TT_INT, (MY_INT)(int)point.y, 0, 0);
  CFrameWnd::OnRButtonUp(nFlags, point);
}

void C_FrameWnd::OnMouseMove(UINT nFlags, CPoint point) // mouse_move
{
  G_FlagsMes=nFlags&0x7f;
  pMainWindow=pMain_Frame=this;
  make_call(2, ObjectStore[m_Number+3], DF_MOUSE_MOVE, TT_INT, (MY_INT)(int)point.x, TT_INT, (MY_INT)(int)point.y, 0, 0);
  CFrameWnd::OnMouseMove(nFlags, point);
}
BOOL C_FrameWnd::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) // mouse_wheel
{
  G_FlagsMes=nFlags&0x7f;
  int Delta=zDelta/WHEEL_DELTA;
  if (Delta!=0)
  {
    pMainWindow=pMain_Frame=this;
    make_call(3, ObjectStore[m_Number+3], DF_MOUSE_WHEEL, TT_INT, (MY_INT)(int)Delta, TT_INT, (MY_INT)(int)pt.x, TT_INT, (MY_INT)(int)pt.y);
  }
  return(CFrameWnd::OnMouseWheel(nFlags, zDelta, pt));
  // return(1);
}

void C_FrameWnd::OnSize(UINT nType, int cx, int cy) // size
{
  CFrameWnd::OnSize(nType, cx, cy);
  if (nType==SIZE_MAXHIDE || nType==SIZE_MAXSHOW) // Is it possible?
    return;
  pMainWindow=pMain_Frame=this;
  make_call(2, ObjectStore[m_Number+3], DF_SIZE, TT_INT, (MY_INT)(int)cx, TT_INT, (MY_INT)(int)cy, 0, 0);
}

void C_FrameWnd::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) // char
{
  //G_FlagsMes=(nFlags>>16)&0xe100;
  pMainWindow=pMain_Frame=this;
  make_call(2, ObjectStore[m_Number+3], DF_CHAR, TT_STR, 2*nChar, TT_INT, (MY_INT)(int)nRepCnt, 0, 0);
  CFrameWnd::OnChar(nChar, nRepCnt, nFlags);
}
void C_FrameWnd::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) // key_down
{
  G_FlagsMes=nFlags&0xe100;
  pMainWindow=pMain_Frame=this;
  make_call(2, ObjectStore[m_Number+3], DF_KEY_DOWN, TT_INT, (MY_INT)(int)nChar, TT_INT, (MY_INT)(int)nRepCnt, 0, 0);
  CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}
void C_FrameWnd::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) // key_up
{
  G_FlagsMes=nFlags&0xe100;
  pMainWindow=pMain_Frame=this;
  make_call(1, ObjectStore[m_Number+3], DF_KEY_UP, TT_INT, (MY_INT)(int)nChar, 0, 0, 0, 0);
  CFrameWnd::OnKeyUp(nChar, nRepCnt, nFlags);
}

BOOL C_FrameWnd::OnCommand(WPARAM wParam, LPARAM lParam) 
{
  int i=LOWORD(wParam);
  if (i==0)
    return 1;
  pMain_Frame=this;
  if (lParam)
    pMainWindow=FromHandle((HWND)lParam); //?
  else
    pMainWindow=this;
  make_call(0, ObjectStore[i+3], DF_PRESS, 0, 0, 0, 0, 0, 0);
  // return CFrameWnd::OnCommand(wParam, lParam);
  return 0;
}

BOOL C_FrameWnd::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
  DWORD Arg1, Arg2, Flag=0;

  if (wParam==0)
    return CFrameWnd::OnNotify(wParam, lParam, pResult);
  // (wParam==((NMHDR *)lParam)->idFrom)
  if (SUBTYPE(ObjectStore[wParam],C_S_WIN_ListBox))
  {
    if ( ((NMHDR *)lParam)->code==LVN_ITEMCHANGED)
    {
      int New=((NMLISTVIEW *)lParam)->uNewState;
      int Old=((NMLISTVIEW *)lParam)->uOldState; 
      Arg1=((NMLISTVIEW *)lParam)->iItem;
      if ((New&LVIS_SELECTED)!=(Old&LVIS_SELECTED))
        make_call(1, ObjectStore[wParam+3], ((New&LVIS_SELECTED)?DF_SELECTED:DF_UNSELECTED), TT_INT, (MY_INT)(int)Arg1, 0, 0, 0, 0);
      if ((New&LVIS_FOCUSED)!=(Old&LVIS_FOCUSED))
        make_call(1, ObjectStore[wParam+3], ((New&LVIS_FOCUSED)?DF_FOCUSED:DF_UNFOCUSED), TT_INT, (MY_INT)(int)Arg1, 0, 0, 0, 0);
      return 1;
    }
    else if ( ((NMHDR *)lParam)->code==LVN_ENDLABELEDIT
         && ((LV_DISPINFO *)lParam)->item.pszText
          && strcmp((LPSTR)(StringStore+((LV_DISPINFO *)lParam)->item.lParam),
           make_short(((LV_DISPINFO *)lParam)->item.pszText)) )
    {
      Arg1=((LV_DISPINFO *)lParam)->item.iItem;  // Number of item
      strcpy((LPSTR)(StringStore+sv_StStore), make_short(((LV_DISPINFO *)lParam)->item.pszText));
      Flag=1;
    }
  }
  else if (SUBTYPE(ObjectStore[wParam],C_S_WIN_TreeBox))
  {
    if ( ((NMHDR *)lParam)->code==TVN_ENDLABELEDIT
         && ((TV_DISPINFO *)lParam)->item.pszText
          && strcmp((LPSTR)(StringStore+((TV_DISPINFO *)lParam)->item.lParam),
           make_short(((TV_DISPINFO *)lParam)->item.pszText)) )
    {
      Arg1=(DWORD)((TV_DISPINFO *)lParam)->item.hItem;  // pointer of item
      strcpy((LPSTR)(StringStore+sv_StStore), make_short(((TV_DISPINFO *)lParam)->item.pszText));
      Flag=1;
    }
  }
  if (Flag==1)
  {
    pMain_Frame=this;
    pMainWindow=FromHandle(((NMHDR *)lParam)->hwndFrom);
    Arg2=sv_StStore;         // Text
    sv_StStore+=(strlen((LPSTR)(StringStore+sv_StStore))+1);
    if (sv_StStore>=STRING_STORE && correct_STR_ST() )
      return 0; // ?
    make_call(2, ObjectStore[wParam+3], DF_EDIT, TT_INT, (MY_INT)(int)Arg1, TT_STR, (MY_INT)(int)Arg2, 0, 0);
    return 1;
  }
  else
    return CFrameWnd::OnNotify(wParam, lParam, pResult);
}

void C_FrameWnd::OnTimer(UINT nIDEvent) 
{
  pMainWindow=pMain_Frame=this;
  make_call(0, ObjectStore[nIDEvent+3], DF_END, 0, 0, 0, 0, 0, 0);
  CFrameWnd::OnTimer(nIDEvent);
}

void C_FrameWnd::OnDestroy() 
{
  if (ObjectStore[m_Number]!=0)
  {
    ObjectStore[m_Number+1]= // size
      ObjectStore[ObjectStore[m_Number]+2]?ObjectStore[ObjectStore[m_Number]+2]:ObjectStore[m_Number+2];
    ObjectStore[m_Number]=0; // dead object
  }
  for (CWnd *win=GetWindow(GW_CHILD); win!=NULL; )
  {
    DWORD k;
    if (win->IsKindOf(RUNTIME_CLASS(C_FrameWnd))) // this never happen
      k=((C_FrameWnd*)win)->m_Number;
    else
      k=win->GetDlgCtrlID();
    win=win->GetNextWindow();
    if (k<ObjectStore_br && ObjectStore[k]!=0) // close_object(k)
    {
      if (SUBTYPE(ObjectStore[k],C_S_WIN_Main) && Wait>1)
        Wait--;
      ObjectStore[k+1]= // size
        ObjectStore[ObjectStore[k]+2]?ObjectStore[ObjectStore[k]+2]:ObjectStore[k+2];
      ObjectStore[k]=0; // dead object
    }
  }  
  //GetClassName(hwnd, (LPSTR)string2, 50);
  //if (strcmp((LPSTR)string2, "MitiProgram")==0)
  if( --Wait==0)
  {
    pMainFrame->PostMessage(WM_USER+1, ret_fl, 0);
    if (status_fl&64) // Run Directly
      AfxEndThread(0);
  }

  CFrameWnd::OnDestroy();
}
void C_FrameWnd::OnClose() 
{
  MY_WORD j=make_call(0, ObjectStore[m_Number+3], DF_CLOSE, 0, 0, 0, 0, 0, 0);
  if(j==1)
    return;
  if (pMain_Frame==this)
    pMainWindow=pMain_Frame=NULL;
  else if (pMainWindow==this)
    pMainWindow=NULL;

  if (j!=0)   // if j==0 terminate goes up
    ret_fl=j;
  
  CFrameWnd::OnClose();
}
LONG C_FrameWnd::OnCtrlColor(WPARAM wParam, LPARAM lParam)
{
  int i=(FromHandle((HWND)lParam))->GetDlgCtrlID();
  SetTextColor((HDC) wParam, ObjectStore[i+7] );
  SetBkColor((HDC) wParam, ObjectStore[i+8] );
  //    UnrealizeObject(hbrGreen);
  //    SetBrushOrg(wParam, 0, 0);
  return (LRESULT) ObjectStore[i+9];
}
/////////////////////////////////////////////////////////////////////////////
// CwProofTree

IMPLEMENT_DYNCREATE(CwProofTree, CFrameWnd)

CwProofTree::CwProofTree()
{
  short_print=0;
  tight=0;
  underline=0;
  highlight=0;
  prefix=0;
  show_vars=0;
  stack_numbers=0;

  m_flag=TRUE;
}

CwProofTree::~CwProofTree()
{
  pProofTree=NULL;
}


BEGIN_MESSAGE_MAP(CwProofTree, CFrameWnd)
    ON_WM_SIZE()
    ON_WM_CREATE()
    ON_WM_MOUSEWHEEL()
    ON_WM_KEYDOWN()
    ON_WM_LBUTTONDBLCLK()
    ON_WM_LBUTTONDOWN()
    ON_WM_PAINT()
    ON_WM_HSCROLL()
    ON_WM_VSCROLL()
END_MESSAGE_MAP()

// CwProofTree message handlers
void CwProofTree::Redraw(void)
{
    SCROLLINFO sc_infp;
    sc_infp.fMask=SIF_ALL;
    m_fild2.cx=max(max(m_fild.cx, -m_pos.x), max(m_pos.x+m_page.cx, m_page.cx/2+1));
    sc_infp.nMin=-m_fild2.cx;
    sc_infp.nMax=m_fild2.cx-1;
    sc_infp.nPage=m_page.cx;
    sc_infp.nPos=m_pos.x;
    SetScrollInfo(SB_HORZ, &sc_infp);
    
    m_fild2.cy=max(m_fild.cy+2, max(m_pos.y+m_page.cy, m_page.cy+2));
    sc_infp.nMin=0;
    sc_infp.nMax=m_fild2.cy-1;
    sc_infp.nPage=m_page.cy;
    sc_infp.nPos=m_pos.y;
    SetScrollInfo(SB_VERT, &sc_infp);
}
void CwProofTree::OnSize(UINT nType, int cx, int cy) 
{
    CFrameWnd::OnSize(nType, cx, cy);

    CRect r;
    GetClientRect(&r);
    m_page.cx=r.right-r.left;
    m_page.cy=(r.bottom-r.top)/m_char.cy;
    if (m_flag)
    {
      m_fild.cx = m_fild.cy = 0;
      m_pos.x=(-m_page.cx)/2;
      m_pos.y=0;
      m_flag=FALSE;
    }
    Redraw();
}
int CwProofTree::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
    if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
        return -1;
    TEXTMETRIC tm;
    CDC* pDC=GetDC();
    pDC->SelectObject((HFONT)InfoFont);
    pDC->GetTextMetrics(&tm);
    m_char.cx=tm.tmMaxCharWidth;
    m_char.cy=tm.tmHeight;
    ReleaseDC(pDC);
    return 0;
}

BOOL CwProofTree::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) // mouse_wheel
{
  CPoint OldPos=m_pos;
  int Delta=zDelta/WHEEL_DELTA;
  if (Delta<0)    //  Down
  {
    if (m_pos.y<m_fild2.cy-m_page.cy+Delta)
      m_pos.y-=Delta;
    else
      m_pos.y=m_fild2.cy-m_page.cy;
  }
  else    //  Up
  {
    if (m_pos.y > Delta)
      m_pos.y-=Delta;
    else
      m_pos.y=0;
  }
  ScrollWindow(0, m_char.cy*(OldPos.y-m_pos.y));
  return(CFrameWnd::OnMouseWheel(nFlags, zDelta, pt));
}
void CwProofTree::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
      //sprintf(string2,"char=%d, flags= 0x%x\r\n", nChar, nFlags);
      //MitiText(string2);
    CPoint OldPos=m_pos;
    switch(nChar)
    {
     case 17:    // Only Ctrl because Ctrl+C is not working
      if (make_action(0, NULL)==1)
      {
        strcat(string_proof, "\r\n"); // maybe we need this (it works without but let it stay)
        // MitiText(string_proof); // for test
        DWORD k, ch_set2=(ch_set?ch_set:2);
        DWORD str_len=strlen(string_proof);
        
        if (::OpenClipboard(NULL)==0 || EmptyClipboard()==0)
        {
          // handle the error
E9:       CloseClipboard();
          MitiText("Cannot write in the clipboard.\r\n");
          goto no_scroll;
        }
        MY_HANDLE hTemp=GlobalAlloc(GMEM_MOVEABLE, 2*str_len+2);
        ChangeCharset(ch_set, 64, (BYTE *)string_proof, (BYTE *)GlobalLock(hTemp), &k, default_char, 2*str_len);
        GlobalUnlock(hTemp);
        if (SetClipboardData(CF_UNICODETEXT, hTemp)==NULL)
          goto E9;
        MY_HANDLE hTemp2=GlobalAlloc(GMEM_MOVEABLE, str_len+1);
        ChangeCharset(ch_set, ch_set2, (BYTE *)string_proof, (BYTE *)GlobalLock(hTemp2), &k, default_char, str_len);
        GlobalUnlock(hTemp2);
        if (SetClipboardData(CF_TEXT, hTemp2)==NULL)
          goto E9;
        CloseClipboard();
        GlobalFree(hTemp);
        GlobalFree(hTemp2);
      }
      goto no_scroll;
     case 83:    // S short_print
     case 84:    // T tight
     case 85:    // U underline
     case 72:    // H highlight
     case 80:    // P prefix
     case 86:    // V show_vars
     case 78:    // N stack_numbers
      if (nChar==83)
        short_print=1-short_print;
      else if (nChar==84)
        tight=1-tight;
      else if (nChar==85)
        underline=1-underline;
      else if (nChar==72)
        highlight=1-highlight;
      else if (nChar==80)
        prefix=1-prefix;
      else if (nChar==86)
        show_vars=1-show_vars;
      else if (nChar==78)
        stack_numbers=1-stack_numbers;
      if (short_print+tight+underline+highlight+prefix+show_vars+stack_numbers==0)
        my_sprintf(string3,_T("Proof Tree - step %llu."), (MY_LONG)(0x10000*lSteps_br+Steps_br-Correction));
      else
        my_sprintf(string3,_T("Proof Tree - step %llu, (%s%s%s%s%s%s%s )."), (MY_LONG)(0x10000*lSteps_br+Steps_br-Correction),
               short_print?_T(" Short"):_T(""),
               tight?_T(" Tight"):_T(""),
               underline?_T(" Underline"):_T(""),
               highlight?_T(" Highlight"):_T(""),
               prefix?_T(" Prefix"):_T(""),
               show_vars?_T(" Vars"):_T(""),
               stack_numbers?_T(" Numbers"):_T("") );
      SetWindowText(string3);
      InvalidateRect(NULL, FALSE); // FALSE for paint indirectly
      goto no_scroll;
     case 35:    // End
      m_pos.x=m_fild2.cx-m_page.cx;
      break;
     case 36:    // Home
      m_pos.x=-m_fild2.cx;
      break;
     case 37:    // Left
      if (m_pos.x>m_char.cx-m_fild2.cx)
        m_pos.x-=m_char.cx;
      else
        m_pos.x=-m_fild2.cx;
      break;
     case 39:    // Right
      if (m_pos.x<m_fild2.cx-m_page.cx-m_char.cx)
        m_pos.x+=m_char.cx;
      else
        m_pos.x=m_fild2.cx-m_page.cx;
      break;
     case 45:    // Insert
      m_pos.x=(-m_page.cx)/2;
      break;
     case 34:    // Page Down
      m_pos.y=min(m_pos.y+m_page.cy-1,m_fild2.cy-m_page.cy);
      break;   
     case 40:    //  Down
      if (m_pos.y<m_fild2.cy-m_page.cy-1)
        m_pos.y+=1;
      else
        m_pos.y=m_fild2.cy-m_page.cy;
      break;
     case 33:    // Page Up
      m_pos.y=(m_pos.y>m_page.cy-1)?(m_pos.y-m_page.cy+1):0;
      break;
     case 38:    //  Up
      if (m_pos.y>0)
        m_pos.y--;
      break;
    }
    ScrollWindow(OldPos.x-m_pos.x, m_char.cy*(OldPos.y-m_pos.y));
no_scroll:
    CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CwProofTree::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    CPoint OldPos=m_pos;
    switch(nSBCode)
    {
     case SB_THUMBPOSITION:    // Moved to
     case SB_THUMBTRACK:    // Drag to
      m_pos.x=nPos;
      break;
     case SB_LINELEFT:    // Left
      if (m_pos.x>m_char.cx-m_fild2.cx)
        m_pos.x-=m_char.cx;
      else
        m_pos.x=-m_fild2.cx;
      break;
     case SB_LINERIGHT:    // Right
      if (m_pos.x<m_fild2.cx-m_page.cx-m_char.cx)
        m_pos.x+=m_char.cx;
      else
        m_pos.x=m_fild2.cx-m_page.cx;
      break;
     case SB_PAGELEFT:    // Page Left
      if (m_pos.x>m_page.cx-m_char.cx-m_fild2.cx)
        m_pos.x-=m_page.cx-m_char.cx;
      else
        m_pos.x=-m_fild2.cx;
      break;
     case SB_PAGERIGHT:    // Page Right
      if (m_pos.x<m_fild2.cx-2*m_page.cx+m_char.cx)
        m_pos.x+=m_page.cx-m_char.cx;
      else
        m_pos.x=m_fild2.cx-m_page.cx;
      break;
    }
    ScrollWindow(OldPos.x-m_pos.x, m_char.cy*(OldPos.y-m_pos.y));
    CFrameWnd::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CwProofTree::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    CPoint OldPos=m_pos;
    switch(nSBCode)
    {
     case SB_THUMBPOSITION:    // Moved to
     case SB_THUMBTRACK:    // Drag to
      m_pos.y=nPos;
      break;
     case SB_PAGEDOWN:    // Page Down
      m_pos.y=min(m_pos.y+m_page.cy-1,m_fild2.cy-m_page.cy);
      break;   
     case SB_LINEDOWN:    //  Down
      if (m_pos.y<m_fild2.cy-m_page.cy-1)
        m_pos.y+=1;
      else
        m_pos.y=m_fild2.cy-m_page.cy;
      break;
     case SB_PAGEUP:    // Page Up
      m_pos.y=(m_pos.y>m_page.cy-1)?(m_pos.y-m_page.cy+1):0;
      break;
     case SB_LINEUP:    //  Up
      if (m_pos.y>0)
        m_pos.y--;
      break;
    }
    ScrollWindow(OldPos.x-m_pos.x, m_char.cy*(OldPos.y-m_pos.y));
    CFrameWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CwProofTree::TextOut_Func(DWORD pp, DWORD t)
{
  DWORD pr_line, vars, args_num, j, jj, k;

  pr_line=Ekler[pp+4];
  if (show_vars)
    vars=Ekler[pp+3]-global_br;
  else
    vars=Ekler[pp+3];
  for ( k=0; k<=ff_pointer; k++)
    if (F_field[k]&TP_TEMP_FLAG)
    {
      if (pr_line==(F_field[k]& (M1^(HALF | TP_TEMP_FLAG | OBSEG1 | OBSEG2))))
      {
        k++;
        break;
      }
    }
  if (k==ff_pointer+1)
  {
    k=0; // green
    for (jj=sv_c+TT_START-1; jj && (!(Pointers[jj]&OBSEG4) || (D_field[(Pointers[jj]&MASKA3)+5]&HALFM)!=pr_line); jj--);
    if (jj)
      goto et_constant;
    //for (jj=sv_c+TT_START-1; jj && (!(Pointers[jj]&OBSEG2) || (D_field[(Pointers[jj]&MASKA3)+3]&HALFM)!=pr_line); jj--);
    //if (jj)
    //  goto et_atom_const;
    len2+=sprintf(string_proof+len2, "bad");
    return;
  }
  args_num=F_field[k-2];
  if (F_field[k-1]&OBSEG2)
  {
    for (jj=sv_c+TT_START-1; jj && (!(Pointers[jj]&OBSEG3) || D_field[(Pointers[jj]&MASKA3)+4]!=k); jj--);
et_constant:
    int OldLen=len2; // added
    if (show_vars)
      len2+=sprintf(string_proof+len2, "_%d", vars++);
    else if (prefix)
    {
      len=len2;
      write_p( TT_VAR, 4, vars++);
      strcpy(string_proof+len2, string2+len2);
      len2=len;
    }
    else
      prolog_write(TT_VAR, vars++, t, &len2, tight);

    if (tight)
      len2+=sprintf(string_proof+len2, ":=");
    else
      len2+=sprintf(string_proof+len2, " := ");
  }
  else
  {
    for (jj=sv_c+TT_START-1; jj && (!(Pointers[jj]&OBSEG1) || D_field[(Pointers[jj]&MASKA3)+2]!=k); jj--);
  }
  if (jj==0)
  {
    len2+=sprintf(string_proof+len2,"######"); // should be never
    return;
  }
  else if (prefix)
  {
    len=len2;
    write_p( jj, 4, 0);
    strcpy(string_proof+len2, string2+len2);
    len2=len;
  }
  else
    prolog_write( jj, 0, t, &len2, tight);
  if (k>0)
  {
    len2+=sprintf(string_proof+len2, "(");
    for (j=0; j<args_num; j++)
    {
      if (j>0)
      {
        if (tight)
          len2+=sprintf(string_proof+len2, ",");
        else
          len2+=sprintf(string_proof+len2, ", ");
      }
      if (show_vars)
        len2+=sprintf(string_proof+len2, "_%d", vars+j);
      else if (prefix)
      {
        len=len2;
        write_p( TT_VAR, 4, vars+j);
        strcpy(string_proof+len2, string2+len2);
        len2=len;
      }
      else
        prolog_write(TT_VAR, vars+j, t, &len2, tight);
    }
    len2+=sprintf(string_proof+len2, ")");
  }
}

int CwProofTree::make_action(DWORD Action, CPoint point)
{
  DWORD i, j, Old_j, k, s, m, t, p, q, to_p, n, n3p, line, i_counter;
  int distance, last;
  CDC* pDC;
  DWORD pt_x;
  
  status_fl|=16; // painting
  if (pCompiled==NULL || error || ((status_fl&2) && !(status_fl&8)))
	  goto end;
  if (Action==0)
  {
    if (selected_line==M1)
      goto end;
    pt_x=selected_distance;
    line=selected_line;
  }
  else
  {
    pt_x=m_pos.x+point.x;
    line=m_pos.y+point.y/m_char.cy;
  }
  pDC=GetDC();
  pDC->SelectObject((HFONT)InfoFont);
  n=pDC->GetTextExtent(_T(". "), 2).cx;
  n3p=pDC->GetTextExtent(_T("..."), 3).cx;
  if (open_br)
    j=m=j_start;
  else
    j=m=stack_br;
  for (i_counter=0; m!=0; m=(Stack[m]&MASKA2), i_counter++);
  if (i_counter<=line)
    goto end;
  for (i=i_counter; i>line+1; i--)
    j=(Stack[j]&MASKA2);
  t=a1;
  Old_j=j;
  if (Stack[j]&QUARTER) // Built-in
  {
    DWORD Current=Stack[j+1]-4;
    j=(Stack[j]&MASKA2);
    DWORD Start=(Stack[j-1]&MASKA2);
    DWORD End=(Stack[j+7]&MASKA2)-1;

    if ((distance=pt_x)<0) // if we are on the left
    {
	  DWORD pp;
	  for (pp=Current-4; pp>=Start && distance<0; pp-=4)
      {
        if ((distance+=n)>=0)
          goto O;
        len2=0;
        TextOut_Func(pp, t);

        if (short_print && len2>MaxPrint)
        {
          char last_symbol=string_proof[MaxPrint-3];
          string_proof[MaxPrint-3]=0;
          distance+=n3p+pDC->GetTextExtent(TempStr=string_proof).cx;
          string_proof[MaxPrint-3]=last_symbol;
        }
        else
          distance+=pDC->GetTextExtent(TempStr=string_proof).cx;
      }
      if (distance<0)
        goto O;
      if (Action!=2)
      {
        if (Action==0)
          selected_line=M1;
        else
        {
          selected_line=line;
          selected_atom=(pp-Start+4)/4;
          selected_distance=pt_x;
        }
        InvalidateRect(NULL, FALSE); // FALSE for paint indirectly
        goto ok;
      }
      for (i=Old_j-4; i>j && ((Stack[i]&MASKA2)!=j || pp+4<Stack[i+1]-4); i-=4);
      if ((Stack[i]&MASKA2)==j && pp+4==Stack[i+1]-4 && (Stack[i+4]&MASKA2)==i)
      {
        j_start=i+4;
        if (!open_br || open_start>line)
        {
          open_br=1;
          open_start=line;
          k_old=(Current-Start)/4;
        }
        else if (open_start==line)
          open_br=1;
        else
          open_br=line-open_start+1;
        if (!(Environment&0x2000)) // AutomaticScroll  // invert
        {
          selected_distance-=pt_x-distance;
          m_pos.x-=pt_x-distance;
          if (((int)line+2)>m_pos.y+m_page.cy)
            m_pos.y++;
        }
        InvalidateRect(NULL, FALSE); // FALSE for paint indirectly
      }  
      else
        MessageBeep(MB_OK);
      goto ok;
    }
    else
    {
      if (Action!=2)
        to_p=End;
      else
      {
        if (!open_br || open_start>line)
          goto O;
        to_p=(open_start==line)?(Start+4*(k_old+1)):End;
      }
      if (BUDA3<t && correct_BUDA() )
        goto O;
	    DWORD pp;
      for (pp=Current; pp<to_p; pp+=4) // no Current
      {
        len2=0;
        if (pp==Current && stack_numbers)
          len2+=sprintf(string_proof, "(%d) ", j/4);
        TextOut_Func(pp, t);
        if (short_print && len2>MaxPrint)
        {
          char last_symbol=string_proof[MaxPrint-3];
          string_proof[MaxPrint-3]=0;
          distance-=last=n3p+pDC->GetTextExtent(TempStr=string_proof).cx;
          string_proof[MaxPrint-3]=last_symbol;
        }
        else
          distance-=last=pDC->GetTextExtent(TempStr=string_proof).cx;
        if (distance<0)
          goto go_out2;
        if ((distance-=n)<0)
          goto O;
      }
      goto O;

go_out2:
      if (Action!=2)
      {
        if (Action==0)
          selected_line=M1;
        else
        {
          selected_line=line;
          selected_atom=(pp-Start)/4;
          selected_distance=pt_x;
        }
        InvalidateRect(NULL, FALSE); // FALSE for paint indirectly
        goto ok;
      }
      s=(pp-Start)/4;
      k=(Current-Start)/4;
      if (open_start==line && (s==k_old || s==k)) // to normal view
        open_br=0;
      else if (s==k && line<open_start+open_br)   // close the subtree
      {
        open_br=line-open_start;
        j_start=Old_j;
      }
      else
      {
        for (i=Old_j; i<stack_br && ((Stack[i]&MASKA2)!=j || pp>Stack[i+1]-4); i+=4);
        if ((Stack[i]&MASKA2)==j && pp==Stack[i+1]-4 && (Stack[i+4]&MASKA2)==i)
        {
          j_start=i+4;
          if (open_start==line)
            open_br=1;
          else
            open_br=line-open_start+1;
        }  
        else
        {
          MessageBeep(MB_OK);
          goto O;
        }
      }
      if (!(Environment&0x2000)) // AutomaticScroll  // invert
      {
        if (open_start==line && s==k) // click on green
        {
          selected_distance-=m_pos.x-(-m_page.cx)/2;
          m_pos.x=(-m_page.cx)/2;
        }
        else
        {
          selected_distance-=pt_x-distance-last;
          m_pos.x-=pt_x-distance-last;
        }
        if (((int)line+2)>m_pos.y+m_page.cy)
          m_pos.y++;
      }
      InvalidateRect(NULL, FALSE); // FALSE for paint indirectly
      goto ok;
    }
  }
  k=Stack[j+1];
  j=(Stack[j]&MASKA2);
  m=Link[Ekler[Stack[j+3]]];
  if ((distance=pt_x)<0) // if we are on the left
  {
    for (s=k+1; s<=Atoms[m] && distance<0; s++)
    {
      if ((distance+=n)>=0)
        goto O;
      if (prefix)
      {
        len=0;
        write_p(Prog_fild[Program[m]+2*s], 4, Link[Stack[j+2]-s]);
        strcpy(string_proof, string2);
        len2=len;
      }
      else
      {
        len2=0;
        prolog_write(Prog_fild[Program[m]+2*s], Link[Stack[j+2]-s], t, &len2, tight);
      }
      if (short_print && len2>MaxPrint)
      {
        char last_symbol=string_proof[MaxPrint-3];
        string_proof[MaxPrint-3]=0;
        distance+=n3p+pDC->GetTextExtent(TempStr=string_proof).cx;
        string_proof[MaxPrint-3]=last_symbol;
      }
      else
        distance+=pDC->GetTextExtent(TempStr=string_proof).cx;
    }
    if (distance<0)
      goto O;
    if (Action!=2)
    {
      if (Action==0)
        selected_line=M1;
      else
      {
        selected_line=line;
        selected_atom=Atoms[m]-s+1;
        selected_distance=pt_x;
      }
      InvalidateRect(NULL, FALSE); // FALSE for paint indirectly
      goto ok;
    }
    for (i=Old_j-4, s-=k+1; 1; i-=4)
      if ((Stack[i]&MASKA2)==j)
        if (s--==1)
          break;
    if ((Stack[i+4]&MASKA2)==i)
    {
      j_start=i+4;
      if (!open_br || open_start>line)
      {
        open_br=1;
        open_start=line;
        k_old=k;
      }
      else if (open_start==line)
        open_br=1;
      else
        open_br=line-open_start+1;
      if (!(Environment&0x2000)) // AutomaticScroll  // invert
      {
        selected_distance-=pt_x-distance;
        m_pos.x-=pt_x-distance;
        if (((int)line+2)>m_pos.y+m_page.cy)
          m_pos.y++;
      }
      InvalidateRect(NULL, FALSE); // FALSE for paint indirectly
    }  
    else
      MessageBeep(MB_OK);
  }
  else
  {
    if (Action!=2)
      to_p=0;
    else
    {
      if (!open_br || open_start>line)
        goto O;
      to_p=(open_start==line)?(k_old-1):0;
    }
    if (BUDA3<t && correct_BUDA() )
      goto O;
    for (s=k; s>to_p; s--)
    {
      if (s<k && (!open_br || i<open_start || (i==open_start && s<k_old)))
      {
        Link[Stack[j+2]-s]=t;
        if ((p=Prog_fild[Program[m]+2*s+1])&HALF)
        { // if we need to make substitution
          q=Prog_fild[p&=MASKA2];
          do
          {
            q+=t;
            if (Prog_fild[p+1]&HALF)
            {
              Buda1[q]=TT_LINK;
              Buda2[q]=Link[Stack[j+2]-(Prog_fild[p+1]&MASKA2)]+Prog_fild[p+2];
            }
            else
            {
              Buda1[q]=Prog_fild[p+1];
              Buda2[q]=Prog_fild[p+2];
            }
            q=Prog_fild[p+=3];
          }
          while (q!=M1);
          if ((q=Prog_fild[Program[m]+2*s])==TT_VAR)
            t++;
          else  
            t+=Chfil_v[q-MEMORY_c256];
        }
        else
          t+=p;
      }
      len2=0;
      if (s==k && stack_numbers)
        len2+=sprintf(string_proof, "(%d) ", Old_j/4);
      if (prefix)
      {
        len=len2;
        write_p(Prog_fild[Program[m]+2*s], 4, Link[Stack[j+2]-s]);
        strcpy(string_proof+len2, string2+len2);
        len2=len;
      }
      else
        prolog_write(Prog_fild[Program[m]+2*s], Link[Stack[j+2]-s], t, &len2, tight);
      if (short_print && len2>MaxPrint)
      {
        char last_symbol=string_proof[MaxPrint-3];
        string_proof[MaxPrint-3]=0;
        distance-=last=n3p+pDC->GetTextExtent(TempStr=string_proof).cx;
        string_proof[MaxPrint-3]=last_symbol;
      }
      else
        distance-=last=pDC->GetTextExtent(TempStr=string_proof).cx;
      if (distance<0)
        goto go_out;
      if ((distance-=n)<0)
        goto O;
    }
    goto O;

go_out:
    if (Action!=2)
    {
      if (Action==0)
        selected_line=M1;
      else
      {
        selected_line=line;
        selected_atom=Atoms[m]-s;
        selected_distance=pt_x;
      }
      InvalidateRect(NULL, FALSE); // FALSE for paint indirectly
      goto ok;
    }

    if (open_start==line && (s==k_old || s==k)) // to normal view
      open_br=0;
    else if (s==k && line<open_start+open_br)   // close the subtree
    {
      open_br=line-open_start;
      j_start=Old_j;
    }
    else
    {
      for (i=Old_j, s-=k; 1; i+=4)
        if ((Stack[i]&MASKA2)==j)
          if (s++==0)
            break;
      if ((Stack[i+4]&MASKA2)==i)
      {
        j_start=i+4;
        if (open_start==line)
          open_br=1;
        else
          open_br=line-open_start+1;
      }  
      else
      {
        MessageBeep(MB_OK);
        goto O;
      }
    }
    if (!(Environment&0x2000)) // AutomaticScroll  // invert
    {
        if (open_start==line && s==k) // click on green
        {
          selected_distance-=m_pos.x-(-m_page.cx)/2;
          m_pos.x=(-m_page.cx)/2;
        }
        else
        {
          selected_distance-=pt_x-distance-last;
          m_pos.x-=pt_x-distance-last;
        }
        if (((int)line+2)>m_pos.y+m_page.cy)
          m_pos.y++;
    }
    InvalidateRect(NULL, FALSE); // FALSE for paint indirectly
  }
ok:
  for (i=a1; i<t; Buda1[i++]=TT_VAR);
  status_fl&=M1^16;
  return(1);
O:
  for (i=a1; i<t; Buda1[i++]=TT_VAR);
end:
  status_fl&=M1^16;
  return(0);
}

void CwProofTree::OnLButtonDown(UINT nFlags, CPoint point) // mouse_click
{
  if (make_action(1, point)==0 && selected_line!=M1)
  {
    selected_line=M1;
    // InvalidateRect(NULL, FALSE); // FALSE for paint indirectly // moved in order to redraw everytime
  }
  InvalidateRect(NULL, FALSE); // FALSE for paint indirectly
  CFrameWnd::OnLButtonDown(nFlags, point);
}

void CwProofTree::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
  make_action(2, point);
  CFrameWnd::OnLButtonDblClk(nFlags, point);
}

void CwProofTree::OnPaint() 
{
  static MY_WORD i_counter=0;
  MY_WORD i, j, Old_j, k, s, m, t, p, q;
  MY_WORD yStart, yEnd, size, MaxSize=0, atoms_br;
  CRect r, r2, rectPaint;
  CDC *pDC, dcMemory;
  CRgn rgnPaint;

  status_fl|=16; // painting
  // Sleep(1000); // temp: delete this

  rgnPaint.CreateRectRgn(0,0,0,0); // we have to init and to call DeleteObject on the end!!! Maybe we have to init only onece
  GetUpdateRgn(&rgnPaint);
  GetUpdateRect(&rectPaint);  
  CPaintDC dc(this); // device context for painting
  if (1)     // paint indirectly
  {
    dcMemory.CreateCompatibleDC(&dc);
    CBitmap bmp;
    bmp.CreateCompatibleBitmap(&dc, rectPaint.Width(), rectPaint.Height());
    dcMemory.SelectObject(&bmp);
    if (rectPaint.left!=0 || rectPaint.top!=0)
    {
      CRgn rgnTemp;
      rgnTemp.CreateRectRgn(0,0,0,0);
      rgnTemp.CopyRgn( &rgnPaint);
      rgnTemp.OffsetRgn( -rectPaint.left, -rectPaint.top);
      dcMemory.SelectClipRgn( &rgnTemp, RGN_COPY); // unfortunatly SetViewportOrg do not move Rgn
      rgnTemp.DeleteObject();
      dcMemory.SetViewportOrg( -rectPaint.left, -rectPaint.top);
    }
    else
      dcMemory.SelectClipRgn( &rgnPaint, RGN_COPY);
    pDC=&dcMemory;

    FillRect(pDC->m_hDC, CRect(rectPaint.left&(M1^7),rectPaint.top&(M1^7),rectPaint.right,rectPaint.bottom), hbrGreen );
  }
  else
    pDC=&dc;

  pDC->GetClipBox(&r);
  pDC->SetTextAlign(TA_UPDATECP);
 
  if (pCompiled == NULL || error || ((status_fl & 2) && !(status_fl & 8)))
  {
	  pDC->MoveTo(-m_pos.x, 0);
	  if (status_fl & 2)
	  {
	    pDC->SetTextColor(c_red);
	    TextOutA(pDC->m_hDC, 0, 0, "The program is running.", 23);
	    pDC->MoveTo(-m_pos.x, m_char.cy);
	    TextOutA(pDC->m_hDC, 0, 0, "You can stop it with \"Break\" button.", 36);
	  }
	  else
	  {
	    pDC->SetTextColor(c_blue);
	    TextOutA(pDC->m_hDC, 0, 0, "Start tracing with Ctrl+F5 or compile.", 38);
	  }
    goto end2;
  }
  t=a1;
  pDC->SetBkColor(GetSysColor(COLOR_WINDOW));
  pDC->SelectObject((HFONT)InfoFont);
  yStart=m_pos.y+r.top/m_char.cy;
  if (open_br)
    j=m=j_start;
  else
    j=m=stack_br;
  for (i_counter=0; m!=0; m=(Stack[m]&MASKA2), i_counter++);
#if TR
  if (open_br && i_counter!=open_start+open_br+1)
    MitiText("Bug in Proof Tree.\r\n");
#endif
  yEnd=min((int)i_counter, m_pos.y+1+r.bottom/m_char.cy);
  m_fild.cy=i_counter;
  if (i_counter<yStart)
    goto end1;
  for (i=i_counter; i>yEnd; i--)
    j=(Stack[j]&MASKA2);
  for (i=yEnd; i-->yStart;)
  {
    pDC->SetTextColor(c_blue);
    Old_j=j;
    if (Stack[j]&QUARTER) // Built-in
    {
      DWORD Current=Stack[j+1]-4;
      j=(Stack[j]&MASKA2);
      DWORD Start=(Stack[j-1]&MASKA2);
      DWORD End=(Stack[j+7]&MASKA2)-1;

      //sprintf(string_proof, "Built-in(%d) ", (End-Current)/4);
      //TextOutA(pDC->m_hDC, 0, 0, (LPSTR)string_proof, strlen(string_proof));
      len2=atoms_br=size=0;
	    DWORD pp;
      for (pp=Start; pp<Current; pp+=4)
      {
        int OldLen=len2;
        TextOut_Func(pp, t);
        //len2+=sprintf(string_proof+len2, "%d(%d). ", (int)Ekler[pp+4], (int)Ekler[pp+3]);

        if (short_print && len2-OldLen>MaxPrint)
        {
          len2=OldLen+MaxPrint-3;
          if (atoms_br<TROOF_TREE_ATOMS)
            proof_tree_atom[atoms_br++]=len2;
          strcpy(string_proof+len2, ".... ");
          len2+=5;
        }
        else
        {
          if (atoms_br<TROOF_TREE_ATOMS)
            proof_tree_atom[atoms_br++]=len2;
          strcat(string_proof, ". ");
          len2+=2;
        }
        size+=pDC->GetTextExtent(TempStr=string_proof+OldLen).cx; //, len2-OldLen // This funtion is 16 bit, unfortunately. That is why we call it not one but many times
      }
      pDC->MoveTo(-m_pos.x-size, (i-m_pos.y)*m_char.cy);
	    DWORD atoms_old, n;
      for (atoms_old=0, n=0; n<atoms_br; n++)
      {
        if (underline) pDC->SelectObject((HFONT)InfoFontUnderline);
        if (selected_line==i && selected_atom==n) pDC->SetBkColor(RGB(200, 200, 255));
        TextOutA(pDC->m_hDC, 0, 0, string_proof+atoms_old, proof_tree_atom[n]-atoms_old);

        if (string_proof[proof_tree_atom[n]+1]!=32) // 32 is " "
        {
          pDC->SetTextColor(c_violet);
          TextOutA(pDC->m_hDC, 0, 0, "...", 3);
          pDC->SetTextColor(c_blue);
          atoms_old=proof_tree_atom[n]+5;
        }
        else
          atoms_old=proof_tree_atom[n]+2;

        if (underline) pDC->SelectObject((HFONT)InfoFont);
        if (selected_line==i && selected_atom==n) pDC->SetBkColor(GetSysColor(COLOR_WINDOW));
        if (highlight) pDC->SetBkColor(RGB(0, 255, 0));

        TextOutA(pDC->m_hDC, 0, 0, ". ", 2);
        if (highlight) pDC->SetBkColor(GetSysColor(COLOR_WINDOW));
      }
      if (atoms_br==TROOF_TREE_ATOMS)
        TextOutA(pDC->m_hDC, 0, 0, string_proof+atoms_old, len2-atoms_old);
      //size=pDC->GetTextExtent(TempStr=string_proof).cx+m_char.cx; //, len2
      size+=m_char.cx;
      if (size>MaxSize)
        MaxSize=size;

      size=0;
      pDC->MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
      for ( ; pp<End; pp+=4)
      {
        len2=0;
        if (size==0 && stack_numbers)
          len2+=sprintf(string_proof, "(%d) ", j/4);
        TextOut_Func(pp, t);

        s=(pp-Start)/4;
        k=(Current-Start)/4;
        if (open_br && i>=open_start)
        {
          if (s==k)
          {
            if (i<open_start+open_br)
              pDC->SetTextColor(c_green);
            else // i==... 
              pDC->SetTextColor(c_blue);
          }
          else if (i==open_start)
          {
            if (s==k_old)
              pDC->SetTextColor(c_red);
            else if (s>k_old)
              pDC->SetTextColor(c_black);
            else // (s>k)
              pDC->SetTextColor(c_blue);
          }
          else // (s>k)
            pDC->SetTextColor(c_blue);
        }
        else if (s==k)
        {
          if (!Trace)
            pDC->SetTextColor(c_green);
          else
            pDC->SetTextColor(c_red);
        }
        else // (s>k)
          pDC->SetTextColor(c_black);

        if (underline) pDC->SelectObject((HFONT)InfoFontUnderline);
        if (selected_line==i && selected_atom==(pp-Start)/4) pDC->SetBkColor(RGB(200, 200, 255));
        if (short_print && len2>MaxPrint)
        {
          len2=MaxPrint-3;
          TextOutA(pDC->m_hDC, 0, 0, string_proof, len2);
          strcpy(string_proof+len2, "...");
          pDC->SetTextColor(c_violet);
          TextOutA(pDC->m_hDC, 0, 0, "...", 3);
        }
        else
          TextOutA(pDC->m_hDC, 0, 0, string_proof, len2);
        if (underline) pDC->SelectObject((HFONT)InfoFont);
        if (selected_line==i && selected_atom==(pp-Start)/4) pDC->SetBkColor(GetSysColor(COLOR_WINDOW));

        if (highlight) pDC->SetBkColor(RGB(0, 255, 0));
        s=(pp-Start+4)/4;
        k=(Current-Start)/4;
        if (open_br?(i>open_start || (i==open_start && s>=k_old)):(s==k && !Trace))
        {
          TextOutA(pDC->m_hDC, 0, 0, ". ", 2);
          size+=pDC->GetTextExtent(TempStr=". ").cx;
        }
        else
        {
          TextOutA(pDC->m_hDC, 0, 0, ", ", 2);
          size+=pDC->GetTextExtent(TempStr=", ").cx;
        }
        if (highlight) pDC->SetBkColor(GetSysColor(COLOR_WINDOW));

        size+=pDC->GetTextExtent(TempStr=string_proof).cx;
      }
      size+=m_char.cx;
      if (size>MaxSize)
        MaxSize=size;
      continue;
    }
    k=Stack[j+1];
    j=(Stack[j]&MASKA2);
    m=Link[Ekler[Stack[j+3]]];
    len2=atoms_br=size=0;
    for (s=Atoms[m]; s>k; s--)
    {
      int OldLen=len2; // added
      if (prefix)
      {
        len=len2;
        write_p(Prog_fild[Program[m]+2*s], 4, Link[Stack[j+2]-s]);
        strcpy(string_proof+len2, string2+len2);
        len2=len;
      }
      else
        prolog_write(Prog_fild[Program[m]+2*s], Link[Stack[j+2]-s], t, &len2, tight);
      if (short_print && len2-OldLen>MaxPrint)
      {
        len2=OldLen+MaxPrint-3;
        if (atoms_br<TROOF_TREE_ATOMS)
          proof_tree_atom[atoms_br++]=len2;
        strcpy(string_proof+len2, ".... ");
        len2+=5;
      }
      else
      {
        if (atoms_br<TROOF_TREE_ATOMS)
          proof_tree_atom[atoms_br++]=len2;
        strcat(string_proof, ". ");
        len2+=2;
      }
      size+=pDC->GetTextExtent(TempStr=string_proof+OldLen).cx; //, len2-OldLen // This funtion is 16 bit, unfortunately. That is why we call it not one but many times
    }
    pDC->MoveTo(-m_pos.x-size, (i-m_pos.y)*m_char.cy);
	DWORD atoms_old, n;
    for (atoms_old=0, n=0; n<atoms_br; n++)
    {
      if (underline) pDC->SelectObject((HFONT)InfoFontUnderline);
      if (selected_line==i && selected_atom==n) pDC->SetBkColor(RGB(200, 200, 255));
      TextOutA(pDC->m_hDC, 0, 0, string_proof+atoms_old, proof_tree_atom[n]-atoms_old);

      if (string_proof[proof_tree_atom[n]+1]!=32) // 32 is " "
      {
        pDC->SetTextColor(c_violet);
        TextOutA(pDC->m_hDC, 0, 0, "...", 3);
        pDC->SetTextColor(c_blue);
        atoms_old=proof_tree_atom[n]+5;
      }
      else
        atoms_old=proof_tree_atom[n]+2;

      if (underline) pDC->SelectObject((HFONT)InfoFont);
      if (selected_line==i && selected_atom==n) pDC->SetBkColor(GetSysColor(COLOR_WINDOW));
      if (highlight) pDC->SetBkColor(RGB(0, 255, 0));

      TextOutA(pDC->m_hDC, 0, 0, ". ", 2);
      if (highlight) pDC->SetBkColor(GetSysColor(COLOR_WINDOW));
    }
    if (atoms_br==TROOF_TREE_ATOMS)
      TextOutA(pDC->m_hDC, 0, 0, string_proof+atoms_old, len2-atoms_old);
    //size=pDC->GetTextExtent(TempStr=string_proof).cx+m_char.cx; //, len2
    size+=m_char.cx;
    if (size>MaxSize)
      MaxSize=size;
    pDC->MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
    if (BUDA3<t && correct_BUDA() )
      goto end1;
    for (size=0; s>0; s--)
    {
      if (s<k && (!open_br || i<open_start || (i==open_start && s<k_old)))
      {
        Link[Stack[j+2]-s]=t;
        if ((p=Prog_fild[Program[m]+2*s+1])&HALF)
        { // if we need to make substitution
          q=Prog_fild[p&=MASKA2];
          do
          {
            q+=t;
            if (Prog_fild[p+1]&HALF)
            {
              Buda1[q]=TT_LINK;
              Buda2[q]=Link[Stack[j+2]-(Prog_fild[p+1]&MASKA2)]+Prog_fild[p+2];
            }
            else
            {
              Buda1[q]=Prog_fild[p+1];
              Buda2[q]=Prog_fild[p+2];
            }
            q=Prog_fild[p+=3];
          }
          while (q!=M1);
          if ((q=Prog_fild[Program[m]+2*s])==TT_VAR)
            t++;
          else  
            t+=Chfil_v[q-MEMORY_c256];
        }
        else
          t+=p;
      }
      len2=0;
      if (s==k && stack_numbers)
        len2+=sprintf(string_proof, "(%d) ", Old_j/4);
      if (prefix)
      {
        len=len2;
        write_p(Prog_fild[Program[m]+2*s], 4, Link[Stack[j+2]-s]);
        strcpy(string_proof+len2, string2+len2);
        len2=len;
      }
      else
        prolog_write(Prog_fild[Program[m]+2*s], Link[Stack[j+2]-s], t, &len2, tight);

      if (open_br && i>=open_start)
      {
        if (s==k)
        {
          if (i<open_start+open_br)
            pDC->SetTextColor(c_green);
          else // i==... 
            pDC->SetTextColor(c_blue);
        }
        else if (i==open_start)
        {
          if (s==k_old)
            pDC->SetTextColor(c_red);
          else if (s<k_old)
            pDC->SetTextColor(c_black);
          else // (s<k)
            pDC->SetTextColor(c_blue);
        }
        else // (s<k)
          pDC->SetTextColor(c_blue);
      }
      else if (s==k)
      {
        if (!Trace)
          pDC->SetTextColor(c_green);
        else
          pDC->SetTextColor(c_red);
      }
      else // (s<k)
        pDC->SetTextColor(c_black);

      if (underline) pDC->SelectObject((HFONT)InfoFontUnderline);
      if (selected_line==i && selected_atom==Atoms[m]-s) pDC->SetBkColor(RGB(200, 200, 255));
      if (short_print && len2>MaxPrint)
      {
        len2=MaxPrint-3;
        TextOutA(pDC->m_hDC, 0, 0, string_proof, len2);
        strcpy(string_proof+len2, "...");
        pDC->SetTextColor(c_violet);
        TextOutA(pDC->m_hDC, 0, 0, "...", 3);
      }
      else
        TextOutA(pDC->m_hDC, 0, 0, string_proof, len2);
      if (underline) pDC->SelectObject((HFONT)InfoFont);
      if (selected_line==i && selected_atom==Atoms[m]-s) pDC->SetBkColor(GetSysColor(COLOR_WINDOW));

      if (highlight) pDC->SetBkColor(RGB(0, 255, 0));
      if (open_br?(i>open_start || (i==open_start && s>=k_old)):(s==k && !Trace))
      {
        TextOutA(pDC->m_hDC, 0, 0, ". ", 2);
        size+=pDC->GetTextExtent(TempStr=". ").cx;
      }
      else
      {
        TextOutA(pDC->m_hDC, 0, 0, ", ", 2);
        size+=pDC->GetTextExtent(TempStr=", ").cx;
      }
      if (highlight) pDC->SetBkColor(GetSysColor(COLOR_WINDOW));

      size+=pDC->GetTextExtent(TempStr=string_proof).cx; //, len2
    }
    size+=m_char.cx;
    if (size>MaxSize)
      MaxSize=size;
  }
  GetClientRect(&r2);
  if (m_fild.cx<=(int)MaxSize || (r.top==0 && r.bottom==r2.bottom))
    m_fild.cx=MaxSize;

end1:
  for (i=a1; i<t; Buda1[i++]=TT_VAR);
end2:
  status_fl&=M1^16;
  Redraw(); // scrollbars
  if (1)     // paint indirectly
  {
    pDC->SetViewportOrg(0, 0);
    dc.BitBlt(rectPaint.left, rectPaint.top, rectPaint.Width(), rectPaint.Height(), pDC, 0, 0, SRCCOPY);
  }

    // Do not call CFrameWnd::OnPaint() for painting messages
}
/////////////////////////////////////////////////////////////////////////////
// CwInformation

IMPLEMENT_DYNCREATE(CwInformation, CFrameWnd)

CwInformation::CwInformation()
{
}
CwInformation::CwInformation(int Type)
{
  m_Type=Type;
  Corrector=1;
}

CwInformation::~CwInformation()
{
}


BEGIN_MESSAGE_MAP(CwInformation, CFrameWnd)
    ON_WM_SIZE()
    ON_WM_CLOSE()
    ON_WM_PAINT()
    ON_WM_MOUSEMOVE()
    ON_WM_MOUSEWHEEL()
    ON_WM_KEYDOWN()
    ON_WM_LBUTTONDOWN()
    ON_WM_CREATE()
    ON_WM_HSCROLL()
    ON_WM_VSCROLL()
END_MESSAGE_MAP()

// CwInformation message handlers

void CwInformation::Redraw(void)
{
    int my_pos;
    
    SCROLLINFO sc_infp;
    sc_infp.fMask=SIF_ALL;
    sc_infp.nMin=0;
    sc_infp.nMax=WINDOW_SIZE-1;
    sc_infp.nPage=m_page.cx;
    sc_infp.nPos=m_pos.x;
    SetScrollInfo(SB_HORZ, &sc_infp);
    
    if (m_Type==5)
      my_pos=max(m_pos.y,(int)program_br1);
    else if (m_Type==7)
      my_pos=max(m_pos.y,buda_br_up+(int)RedLine+1);
    else
      my_pos=m_pos.y;
    m_fild2=max(m_fild+2, max(my_pos+m_page.cy, m_page.cy+2));
    if (m_fild2>32000) // temp for this VC++, because it is 16-bit
      Corrector=1+m_fild2/32000;
    else
      Corrector=1;
    sc_infp.nMin=0;
    sc_infp.nMax=(m_fild2-1)/Corrector;
    sc_infp.nPage=m_page.cy/Corrector;
    sc_infp.nPos=m_pos.y/Corrector;
    SetScrollInfo(SB_VERT, &sc_infp);
}
void CwInformation::OnSize(UINT nType, int cx, int cy) 
{
    CFrameWnd::OnSize(nType, cx, cy);
    
    CRect r;
    GetClientRect(&r);
    m_page.cx=r.right-r.left;
    m_page.cy=(r.bottom-r.top)/m_char.cy;
    Redraw();
}
int CwInformation::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
    if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
        return -1;
    TEXTMETRIC tm;
    CDC* pDC=GetDC();
    pDC->SelectObject((HFONT)InfoFont);
    pDC->GetTextMetrics(&tm);
    m_char.cx=tm.tmMaxCharWidth;
    m_char.cy=tm.tmHeight;
    ReleaseDC(pDC);
    m_fild=0;
    m_pos.x=m_pos.y=0;
    if (m_Type==5)
      m_pos.y=program_br1;
    else if (m_Type==7)
      m_pos.y=buda_br_up+RedLine+1; // +1 for blue line
    return 0;
}
void CwInformation::OnLButtonDown(UINT nFlags, CPoint point) // mouse_click
{
  InvalidateRect(NULL, FALSE); // FALSE for paint indirectly
  CFrameWnd::OnLButtonDown(nFlags, point);
}
void CwInformation::OnPaint() 
{
    CPaintDC dc(this); // device context for painting
    CRect r;
    
	status_fl |= 16; // painting
	dc.GetClipBox(&r);

    dc.SetTextAlign(TA_UPDATECP);
    dc.SetBkColor(GetSysColor(COLOR_WINDOW));
    dc.SelectObject((HFONT)InfoFont);
    dc.SetTextColor(c_black);

	if (pCompiled == NULL || ((status_fl & 2) && !(status_fl & 8)))
	{
		dc.MoveTo(-m_pos.x, 0);
		if (status_fl & 2)
		{
			dc.SetTextColor(c_red);
			TextOutA(dc.m_hDC, 0, 0, "The program is running.", 23);
			dc.MoveTo(-m_pos.x, m_char.cy);
			TextOutA(dc.m_hDC, 0, 0, "You can stop it with \"Break\" button.", 36);
		}
		else
		{
			dc.SetTextColor(c_blue);
			TextOutA(dc.m_hDC, 0, 0, "Start tracing with Ctrl+F5 or compile.", 38);
		}
		goto end;
	}
	
	DWORD yStart, i_counter, ii;
    switch(m_Type)
    {
#if TR
     case 1: // Closed Terms
      i_counter=sv_c;
      break;
     case 2: // Open Terms
      i_counter=sv_v;
      break;
     case 3: // Tree
      i_counter=sv_tr;
      break;
     case 4:
      i_counter=0;
      break;
#endif
     case 5: // System List
      i_counter=program_br-program_br2+program_br1;
      break;
     case 6: // Stack
      i_counter=stack_br/4;
      break;
     case 7: // Variables
#if TR
      i_counter=3+buda_br_up+a1+MAX_VARS/8; // BUDA3+MAX_VARS for debug
#else
      i_counter=3+buda_br_up+a1; // +3 for RedLine and Blue Lines
#endif
      break;
     case 8: // Operators
      i_counter=max(oper_br, 1);
      break;
     case 11: // Objects
      for (i_counter=ii=0; ii<ObjectStore_br; i_counter++)
        ii+=ObjectStore[ObjectStore[ii]+2]?ObjectStore[ObjectStore[ii]+2]:
          (ObjectStore[ii]?ObjectStore[ii+2]:ObjectStore[ii+1]);
      break;
     case 17: // Functions with typed arguments
      for (i_counter=ii=0; ii<ff_pointer; ii++) //FUNC_F+MAX_ARGUMENTS
        if (F_field[ii]&TP_TEMP_FLAG)
          i_counter++;
      break;
#if TR
     case 9: // Constants
      i_counter=150;
      break;
     case 10: // Key Map
      i_counter=256;
      break;
     case 12: // Blocks
      i_counter=sv_blocks+TT_START+MAX_VARS;
      break;
     case 18: // Link
      i_counter=sv_subv;
      break;
     case 13: // Ekler
      i_counter=ekler_br+1;
      break;
     case 14: // D_Field
      i_counter=DEF_F+NUMB_FLAGS;
      break;
     case 15: // Pointers
      i_counter=TT_START+sv_c+sv_v;
      break;
     case 16: // F_Field
      i_counter=FUNC_F+MAX_ARGUMENTS;
#endif
    } 
    m_fild=i_counter;
    yStart=m_pos.y+r.top/m_char.cy;
    if (i_counter<yStart)
	  goto end;
    i_counter=((int)i_counter>m_pos.y+r.bottom/m_char.cy)?1+m_pos.y+r.bottom/m_char.cy:i_counter;
    switch(m_Type)
    {
      DWORD i, j, m, n, k, t, yPos2;

#if TR
     case 1: // Closed Terms
     case 2: // Open Terms
      yPos2=(m_Type==2)?MEMORY_C:0;
      for (i=yStart; i<i_counter; i++)
      {
        dc.MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
        sprintf(string2, "%4d.", i);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        k=Pointers[i+yPos2+TT_START];
        sprintf(string2, "%c", (k & QUARTER)?((k & HALF)?'B':'a'):
                                             ((k & HALF)?'h':' '));
        dc.SetTextColor(c_red);
        TextOutA(dc.m_hDC, 0, 0, string2, 1);
        sprintf(string2, "%c",(Chfil_c[i+yPos2]==2)?'.':(Chfil_c[i+yPos2]==1?'f':'a'));
        dc.SetTextColor(c_blue);
        TextOutA(dc.m_hDC, 0, 0, string2, 1);
        if (i==0 && m_Type==2)
        {
          strcpy(string2, "   Used by the system.");
          dc.SetTextColor(c_red);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          dc.SetTextColor(c_black);
          continue;
        }  
        if (Ufil_c1[i+yPos2]<TT_START)
        {
          dc.SetTextColor(c_red);
          if (Ufil_c1[i+yPos2]==TT_VAR)
            strcpy(string2, "   var");
          else if (Ufil_c1[i+yPos2]==TT_LIST)
            strcpy(string2, "   [] ");
          else if (Ufil_c1[i+yPos2]==TT_SET)
            strcpy(string2, "   set");
          else
          {  
            j=key_oposit[Ufil_c1[i+yPos2]];
            sprintf(string2, "   '%c'", j);
          }  
        }  
        else if (Ufil_c1[i+yPos2]>=MEMORY_c256)
        {
          dc.SetTextColor(c_blue);
          sprintf(string2, " %4d~", Ufil_c1[i+yPos2]-MEMORY_c256);
        }  
        else
        {
          dc.SetTextColor(c_green);
          sprintf(string2, " %4d.", Ufil_c1[i+yPos2]-TT_START);
        }  
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        if (Ufil_c2[i+yPos2]<TT_START)
        {
          dc.SetTextColor(c_red);
          if (Ufil_c2[i+yPos2]==TT_VAR)
            strcpy(string2, "   var");
          else if (Ufil_c2[i+yPos2]==TT_LIST)
            strcpy(string2, "   [] ");
          else if (Ufil_c2[i+yPos2]==TT_SET)
            strcpy(string2, "   set");
          else
          {  
            j=key_oposit[Ufil_c2[i+yPos2]];
            sprintf(string2, "   '%c'", j);
          }  
        }  
        else if (Ufil_c2[i+yPos2]>=MEMORY_c256)
        {
          dc.SetTextColor(c_blue);
          sprintf(string2, " %4d~", Ufil_c2[i+yPos2]-MEMORY_c256);
        }  
        else
        {
          dc.SetTextColor(c_green);
          sprintf(string2, " %4d.", Ufil_c2[i+yPos2]-TT_START);
        }  
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        dc.SetTextColor(c_black);
        if (m_Type==2)
        {
          sprintf(string2, " %3d", Chfil_v[i]);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          dc.SetTextColor(c_green);
          if(Ufil_vs[i]!=M1)
          {
            t=j=Ufil_vs[i];
            for ( t+=Chfil_v[Ufil_c2[i+yPos2]-MEMORY_c256]; j<t; j++)
            {
              sprintf(string2, "%3d", Substi[j]);
              TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            }
          }
          dc.SetTextColor(c_black);
          TextOutA(dc.m_hDC, 0, 0, " *", 2);                    
        }
        len=0;
        write_p(i+(m_Type==2?MEMORY_c256:TT_START), 4, max(a1,global_br2));
        TextOutA(dc.m_hDC, 0, 0, "  ", 2);
        TextOutA(dc.m_hDC, 0, 0, string2, len);
      }
      break;
     case 3: // Tree
      for (i=yStart; i<i_counter; i++)
      {
        dc.MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
        sprintf(string2, "%4d.", i);
        dc.SetTextColor(c_black);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        sprintf(string2, "%6d", Ch_tree[i]);
        dc.SetTextColor(c_red);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        for (j=0; j<4; j++)
        {
          char ch;

          k=Mtree[i][j];
          ch=(k & QUARTER)?((k & HALF)?'B':'a'):((k & HALF)?'h':' ');
          if ((k & OBSEG1) || k==MASKA)
          {
            if (k==MASKA)
              strcpy(string2, "    .  ");
            else
              sprintf(string2, " %4d %c", (int)(k & MASKA), ch);
            dc.SetTextColor(c_black);
          }
          else if (k & OBSEG2)
          {
            sprintf(string2, " %4d-%c", (int)(k & MASKA), ch);
            dc.SetTextColor(c_red);
          }
          else if ((k & MASKA)< MEMORY_C)
          {
            sprintf(string2, " %4d.%c", (int)(k & MASKA), ch);
            dc.SetTextColor(c_green);
          }
          else
          {
            sprintf(string2, " %4d~%c", (int)((k & MASKA)-MEMORY_C), ch);
            dc.SetTextColor(c_blue);
          }
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        }
      }    
      break;
     case 4:
      for (i=yStart; i<i_counter; i++)
      {
      }    
      break;
#endif
     case 5:  // System List
     case 17: // Functions with typed arguments
      if (pCompiled==NULL)
      {
        dc.MoveTo(-m_pos.x, 0);
        dc.SetTextColor(c_red);
        TextOutA(dc.m_hDC, 0, 0, "This window is empty before compilation.", 40);
        break;
      }
      for (i=yStart; i<i_counter; i++)
      {
        DWORD pr_line, pr_line_real, jj, flag_line=1;

        dc.MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
        if (m_Type==5) // System List
        {
          pr_line_real=pr_line=(i<program_br1)?i:(i+program_br2-program_br1);
          if ((Program[pr_line]&HALF) || (Prog_fild[Program[pr_line]+1]&QUARTER))
          {
            for ( ; pr_line>0 && pr_line==ProgTail[pr_line-1]; pr_line--);
            for ( k=0; k<=ff_pointer; k++)
              if (F_field[k]&TP_TEMP_FLAG)
              {
                if (pr_line==(F_field[k]& (M1^(HALF | TP_TEMP_FLAG | OBSEG1 | OBSEG2))))
                {
                  k++;
                  break;
                }
              }
          }
        }
        else // Functions with ...
        {
          for ( j=k=0; j<=i; k++)
            if (F_field[k]&TP_TEMP_FLAG)
              j++;
          pr_line_real=pr_line=F_field[k-1]& (M1^(HALF | TP_TEMP_FLAG | OBSEG1 | OBSEG2));
        }          
        if (pr_line_real>=program_br2)
        {
          sprintf(string2, "%3d. ", pr_line_real-program_br2);
          dc.SetTextColor(c_blue);
        }
        else
        {
          sprintf(string2, "%3d, ", pr_line_real);
          dc.SetTextColor(c_violet);
        }
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));

        dc.SetTextColor(c_green);
        sprintf(string2, "(%d) ", Program3[pr_line_real]);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));

        if ((Program[pr_line]&HALF) || (Prog_fild[Program[pr_line]+1]&QUARTER))
        {
          if (k==ff_pointer+1)
          {
            k=0; // green
            for (jj=sv_c+TT_START-1; jj && (!(Pointers[jj]&OBSEG4) || (D_field[(Pointers[jj]&MASKA3)+5]&HALFM)!=pr_line); jj--);
            if (jj)
              goto et_constant;
            for (jj=sv_c+TT_START-1; jj && (!(Pointers[jj]&OBSEG2) || (D_field[(Pointers[jj]&MASKA3)+3]&HALFM)!=pr_line); jj--);
            if (jj)
              goto et_atom_const;
            dc.SetTextColor(c_red);
            TextOutA(dc.m_hDC, 0, 0, "bad", 3);
            continue;
          }
#if TR
          sprintf(string2, "(%3d/", k);
          dc.SetTextColor(c_black);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          dc.SetTextColor(c_blue);
          sprintf(string2, "%d", F_field[k-2]);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          dc.SetTextColor(c_black);
          TextOutA(dc.m_hDC, 0, 0, ") ", 2);
#endif // TR                    
          if (F_field[k-1]&OBSEG2)
          {
            for (jj=sv_c+TT_START-1; jj && (!(Pointers[jj]&OBSEG3) || D_field[(Pointers[jj]&MASKA3)+4]!=k); jj--);
et_constant:
            dc.SetTextColor(c_red);
            TextOutA(dc.m_hDC, 0, 0, "R", 1);
            dc.SetTextColor(c_black);
            TextOutA(dc.m_hDC, 0, 0, " is ", 4);
          }
          else
          {
            for (jj=sv_c+TT_START-1; jj && (!(Pointers[jj]&OBSEG1) || D_field[(Pointers[jj]&MASKA3)+2]!=k); jj--);
et_atom_const:
            dc.SetTextColor(c_black);
            TextOutA(dc.m_hDC, 0, 0, "*** ", 4);
          }
#if TR
          dc.SetTextColor(c_green);
          if (Program[pr_line]&HALF)
            TextOutA(dc.m_hDC, 0, 0, "#", 1);
          dc.SetTextColor(c_black);
          if (F_field[k-1]&HALF)
            TextOutA(dc.m_hDC, 0, 0, "#", 1);
#endif
          if (k<8) // k==2 || k==7
            dc.SetTextColor(c_green);
          else
            dc.SetTextColor(c_blue);
          if (jj==0)
            strcpy(string2,"######");
          else
          {
            len=0;
            write_p( jj, 4, 0);
          }
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          if (k==0)
            goto et_two_point;
          dc.SetTextColor(c_blue);
          TextOutA(dc.m_hDC, 0, 0, "(", 1);
          for (t=k; flag_line; t++)
          {
            dc.SetTextColor(c_blue);
            if (F_field[t]&TP_TAPA)
            {
              if (F_field[t]&TP_REAL_TAPA)
                break;
              else
              {
                flag_line=0;
                TextOutA(dc.m_hDC, 0, 0, " |", 2);
              }
            }
            else if (F_field[t]&TP_REAL_TAPA)
              TextOutA(dc.m_hDC, 0, 0, " //", 3);
            else if (t>k)
              TextOutA(dc.m_hDC, 0, 0, ",", 1);
            dc.SetTextColor(c_red);
            if ((F_field[t]&TP_CALK)==TP_CALK)
            {
              if (F_field[t]&TP_IO)
                TextOutA(dc.m_hDC, 0, 0, " calc io", 8);
              else
                TextOutA(dc.m_hDC, 0, 0, " calc", 5);
            }
            else if (F_field[t]&TP_METHOD)
              TextOutA(dc.m_hDC, 0, 0, " method", 7);
            else
            {
              DWORD Pointers_flag=TP_VAR;
              for (m=0; m<8; m++, Pointers_flag=Pointers_flag>>1)
              {
                if (F_field[t]&Pointers_flag)
                {
                  switch(m)
                  {
                   case 0:
                    TextOutA(dc.m_hDC, 0, 0, " var", 4);
                    break;
                   case 1:
                    TextOutA(dc.m_hDC, 0, 0, " term", 5);
                    break;
                   case 2:
                    TextOutA(dc.m_hDC, 0, 0, " str", 4);
                    break;
                   case 3:
                    if (F_field[t]&TP_FLOAT)
                    {
                      m++; Pointers_flag=Pointers_flag>>1;
                      TextOutA(dc.m_hDC, 0, 0, " num", 4);
                    }
                    else
                      TextOutA(dc.m_hDC, 0, 0, " int", 4);
                    break;
                   case 4:
                    TextOutA(dc.m_hDC, 0, 0, " float", 6);
                    break;
                   case 5:
                    TextOutA(dc.m_hDC, 0, 0, " obj", 4);
                    break;
                   case 6:
                    TextOutA(dc.m_hDC, 0, 0, " list", 5);
                    break;
                   case 7:
                    TextOutA(dc.m_hDC, 0, 0, " io", 3);
                  }
                }
              }
            }
            if (F_field[t] & MASKA_TP) // maybe this is impossible
            {
              dc.SetTextColor(c_blue);
              sprintf(string2, "(# %d#)", F_field[t] & MASKA_TP);
              TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            }
            else
            {
              dc.SetTextColor(c_black);
              string2[0]=' '; string2[1]=(char)('A'+t-k); string2[2]=0;
              TextOutA(dc.m_hDC, 0, 0, string2, 2);
            }
          }
          dc.SetTextColor(c_blue);
          TextOutA(dc.m_hDC, 0, 0, ")", 1);
et_two_point:          
          dc.SetTextColor(c_black);
          TextOutA(dc.m_hDC, 0, 0, " :-", 3);
          dc.SetTextColor(c_green);
          if (Program[pr_line]&HALF)
            sprintf(string2, " %d", Program[pr_line]&HALFM);
          else
            strcpy(string2, " _");
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          dc.SetTextColor(c_black);
          TextOutA(dc.m_hDC, 0, 0, ".", 1);
        }
#if TR
        else
        {
          sprintf(string2, "%4d<-", Program2[pr_line]);
          dc.SetTextColor(c_black);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        }
        if ((Program[pr_line]&HALF)==0)
        {
          n=Prog_fild[Program[pr_line]];
          if (n>=MEMORY_c256)
          {
            sprintf(string2, "%4d~", n-MEMORY_c256);
            dc.SetTextColor(c_blue);
          }
          else  if (n>=TT_START)
          {
            sprintf(string2, "%4d.", n-TT_START);
            dc.SetTextColor(c_green);
          }
          else
          {
            if (n==TT_VAR)
              strcpy(string2, "  var");
            else if (n==TT_LIST)
              strcpy(string2, "  [] ");
            else if (n==TT_SET)
              strcpy(string2, "  set");
            else
              sprintf(string2, "  '%c'", key_oposit[n]);
            dc.SetTextColor(c_red);
          }
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        }
#endif
        dc.SetTextColor(c_red);
        if (!(Program[pr_line]&HALF) &&(Prog_fild[Program[pr_line]+1]&OBSEG1))
          sprintf(string2, "out ");
#if TR
        else if (ProgTail[pr_line]!=M1)  
        {
          if (i<program_br1)
          {
            if (ProgTail[pr_line]<program_br1)
              sprintf(string2, "%3d>", ProgTail[pr_line]);
            else
            {
              sprintf(string2, "%3d>", ProgTail[pr_line]-program_br2);
              dc.SetTextColor(c_blue);
            }
          }
          else
            sprintf(string2, "%3d>", ProgTail[pr_line]-program_br2);
        }
        else
          sprintf(string2, "   *");
#else
        else
          sprintf(string2, " ");
#endif
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        if (Program[pr_line]&HALF)
          continue;
        dc.SetTextColor(c_black);
        len=0;
          write_p(pr_line, 5, 0);
        TextOutA(dc.m_hDC, 0, 0, string2, len);
        if (Atoms[pr_line]==0)
          TextOutA(dc.m_hDC, 0, 0, ".", 1);
        else
          TextOutA(dc.m_hDC, 0, 0, " :- ", 4);
      }
      break;
      
     case 6: // Stack
      for (i=yStart+1; i<i_counter+1; i++)
      {
        DWORD v1, v2, v3;

        dc.SetTextColor(c_black);
        dc.MoveTo(-m_pos.x, (i-1-m_pos.y)*m_char.cy);
        sprintf(string2, "%3d. ", i);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        if (Stack[4*i]&HALF)
        {
          sprintf(string2, "%5d.", (Stack[4*i]&MASKA2)/4);
          dc.SetTextColor(c_red);
        }
        else if (Stack[4*i]&QUARTER)
        {
          sprintf(string2, "%5d_", (Stack[4*i]&MASKA2)/4);
          dc.SetTextColor(c_violet);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          k=(Stack[4*i]&MASKA2);
          sprintf(string2, " %d:%d ",
                (Stack[4*i+1]-(Stack[k-1]&MASKA2))/4,
                ((Stack[k+7]&MASKA2)-(Stack[k-1]&MASKA2))/4); // -1 to be exact
          dc.SetTextColor(c_black);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          if (4*i==stack_br)
            sprintf(string2, " vars=x   (_%d) ", a1-global_br);
          else
            sprintf(string2, " vars=x   (_%d) ", Link[Stack[4*i+2]]-global_br);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
#if TR
          sprintf(string2, " %5d %5d ", (int)Stack[4*i+2], (int)(Stack[4*i+3]&MASKA2));
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
#endif
          continue;
        }
        else
        {
          sprintf(string2, "%5d ", Stack[4*i]/4);
          dc.SetTextColor(c_blue);
        }
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        dc.SetTextColor(c_black);
        k=Atoms[Link[Ekler[Stack[(j=Stack[4*i]&MASKA2)+3]&MASKA2]]];
        sprintf(string2, " %d:%d ", (int)(1+k-Stack[4*i+1]), (int)k);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        
        TextOutA(dc.m_hDC, 0, 0, " vars=", 6);
        if (4*i==stack_br)
        {
          v1=a1-buda_br;
          v2=M1; // x
          v3=buda_br-global_br;
        }
        else
        {
          v1=Link[Stack[4*i+2]]-Link[Stack[j+2]-Stack[4*i+1]];
          if ((Stack[4*i+4]&QUARTER) && 4*i==(Stack[4*i+4]&MASKA2))// before buit-in
            v2=M1; // -
          else if (4*i==stack_br-4)
            v2=buda_br-Link[Stack[4*i+2]];
          else
            v2=Link[Stack[(Stack[4*i+4]&MASKA2)+2]-Stack[4*i+5]]-Link[Stack[4*i+2]];
          v3=Link[Stack[j+2]-Stack[4*i+1]]-global_br;
        }
        dc.SetTextColor(c_red);
        sprintf(string2, "%d", v1);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        dc.SetTextColor(c_black);
        TextOutA(dc.m_hDC, 0, 0, ":", 1);
        dc.SetTextColor(c_red);
        if (v2==M1)
        {
          if (4*i==stack_br)
            TextOutA(dc.m_hDC, 0, 0, "x", 1);
          else
            TextOutA(dc.m_hDC, 0, 0, "-", 1);
        }
        else
        {
          sprintf(string2, "%d", v2);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        }
        dc.SetTextColor(c_black);
        TextOutA(dc.m_hDC, 0, 0, " (", 2);
        dc.SetTextColor(c_blue);
        sprintf(string2, "_%d", v3);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        dc.SetTextColor(c_black);
        TextOutA(dc.m_hDC, 0, 0, ") ", 2);

        if (4*i==stack_br)
          continue;
#if TR
        sprintf(string2, " %5d %5d ", (int)Stack[4*i+2], (int)(Stack[4*i+3]&MASKA2));
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        if (Stack[4*i+3]&QUARTER)
        {
          dc.SetTextColor(c_green);
          TextOutA(dc.m_hDC, 0, 0, "#", 1);
        }
#endif
        if (k=Stack[4*i+3]&HALF)
        {
          dc.SetTextColor(c_red);
          TextOutA(dc.m_hDC, 0, 0, " *", 2);
        }
        else
          TextOutA(dc.m_hDC, 0, 0, "->", 2);
        if ((Stack[4*i+4]&QUARTER) && 4*i==(Stack[4*i+4]&MASKA2))// before buit-in
        {
          dc.SetTextColor(c_red);
          TextOutA(dc.m_hDC, 0, 0, " Built-in", 9);
          continue;
        }
        m=Link[Ekler[Stack[4*i+3]]];
        if (m<program_br2)
        {
          sprintf(string2, "%d. ", m);
          dc.SetTextColor(c_violet);
        }
        else
        {
          sprintf(string2, "%d ", m-program_br2);
          dc.SetTextColor(c_blue);
        }
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        if (k)
          dc.SetTextColor(c_green);
        else
          dc.SetTextColor(c_black);
        for (n=Stack[4*i+3]&MASKA2; 1;)
        {
          if (ProgTail[m]==M1 || ProgTail[m]==m)
          {
            if (ProgTail[m]==m)
              TextOutA(dc.m_hDC, 0, 0, "<< ", 3);
            if (n>(Stack[4*i-1]&MASKA2)+1)
            {
              TextOutA(dc.m_hDC, 0, 0, "| ", 2);
              m=Link[Ekler[--n]];
            }
            else
              break;
          }
          else
            m=ProgTail[m]; // the print order is not the real one
          if (m<program_br2)
            sprintf(string2, "%d. ", m);
          else
            sprintf(string2, "%d ", m-program_br2);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        }
      }
      break;

     case 7: // Variables
      for (i=yStart; i<i_counter; i++)
      {
        DWORD var;
        
        if (i<buda_br_up)
          var=i;
        else if (i>buda_br_up+global_br+2)
          var=i-3;
        else if (i>buda_br_up && i<buda_br_up+RedLine+1)
          var=i-1;
        else if (i>buda_br_up+RedLine+1 && i<buda_br_up+global_br+2)
          var=i-2;
        else
        {
          if (i==buda_br_up+RedLine+1)
            dc.SelectObject(hMyRedPen);
          else
            dc.SelectObject(hMyBluePen);
          dc.MoveTo(20-m_pos.x, (i-m_pos.y)*m_char.cy+8);
          dc.LineTo(540-m_pos.x, (i-m_pos.y)*m_char.cy+8);
          continue;
        }
        dc.MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
        if (var<buda_br_up)
        {
          if (!(Link[var-buda_br_up]&HALF))
          {
            j=Link[var-buda_br_up];
            goto et_j;
          }
          else if (buda_br_up-var>9)
            sprintf(string2, "M%d. ", buda_br_up-var);
          else
            sprintf(string2, " M%d. ", buda_br_up-var);
        }
        else if (var<buda_br_up+global_br)
        {
          j=var-buda_br_up;
et_j:     string2[0]='G';
          string2[1]='_';
          len=2;
          for(m=global[j]; m>=TT_START; m=Ufil_c2[m-TT_START])
            string2[len++]=key_oposit[Ufil_c1[m-TT_START]];
          string2[len++]=key_oposit[m];
          string2[len]=0;
          strcat(string2, "       ");
          string2[((len+6)/6)*6]=0;
        }
        else
          sprintf(string2, "%3d. ", var-global_br-buda_br_up);
#if TR 
        if (var>=a1+buda_br_up) // for debug
        {
          dc.SetTextColor(c_red);
          if (var-buda_br_up==a1)
          {
            for (j=a1+MAX_VARS/2; j>a1 && Buda1[--j]==TT_VAR; );
            if (j>a1)
              TextOutA(dc.m_hDC, 0, 0, "ERROR ", 6);
          }
          if (Buda1[var-buda_br_up]==TT_VAR)
            continue;
        }
        else
#endif
          dc.SetTextColor(c_black);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        m=Buda1[var-buda_br_up];
        n=Buda2[var-buda_br_up];
        if (Buda1[var-buda_br_up]==TT_LINK)
        {
          dc.SetTextColor(c_blue);
          TextOutA(dc.m_hDC, 0, 0, "=> ", 3);
          if (Buda2[var-buda_br_up]>HALF) // <0
          {
            if (!(Link[Buda2[var-buda_br_up]]&HALF))
            {
              j=Link[Buda2[var-buda_br_up]];
              goto et_j2;
            }
            else
              sprintf(string2, "    M%d -> ", 0-Buda2[var-buda_br_up]);
          }
          else if (Buda2[var-buda_br_up]<global_br)
          {
            j=Buda2[var-buda_br_up];
et_j2:      string2[0]='G';
            string2[1]='_';
            len=2;
            for(m=global[j]; m>=TT_START; m=Ufil_c2[m-TT_START])
              string2[len++]=key_oposit[Ufil_c1[m-TT_START]];
            string2[len++]=key_oposit[m];
            string2[len]=0;
            strcat(string2, " -> ");
          }
          else
            sprintf(string2, "%6d -> ", Buda2[var-buda_br_up]-global_br);
          dc.SetTextColor(c_red);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          for(m=var-buda_br_up; Buda1[m]==TT_LINK; m=Buda2[m]);
          n=Buda2[m];
          m=Buda1[m];
        }
        if (m<TT_START)
        {
          dc.SetTextColor(c_red);
          if (m==TT_VAR)
            strcpy(string2, "   var");
          else if (m==TT_LIST)
            strcpy(string2, "   [] ");
          else if (m==TT_SET)
            strcpy(string2, "   set");
          else if (m==TT_STR)
            sprintf(string2, "\"%s\"", StringStore+n);
          else if (m==TT_INT)
            sprintf(string2, "%6d", n);
          else if (m==TT_FLOAT)
            sprintf(string2, G_STR, (double)(*(float*)&n));
          else if (m==TT_OBJ)
            sprintf(string2, "0j%d", n);
          else
          {  
            j=key_oposit[m];
            sprintf(string2, "   '%c'", j);
          }  
        }  
        else
        {
#if TR
          if (m>=MEMORY_c256)
          {
            dc.SetTextColor(c_blue);
            sprintf(string2, " %4d~", m-MEMORY_c256);
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            dc.SetTextColor(c_green);
            for (j=0; j<Chfil_v[m-MEMORY_c256]; j++)
            {
              sprintf(string2, " %d", Link[n+j]);
              TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            }
            dc.SetTextColor(c_black);
            strcpy(string2, "*");
          }  
          else
          {
            dc.SetTextColor(c_green);
            sprintf(string2, " %4d.", m-TT_START);
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          }
#endif
          dc.SetTextColor(c_black);
          //Buda1[BUDA3+MAX_VARS-1]=TT_LINK;
          //Buda2[BUDA3+MAX_VARS-1]=var-buda_br_up;
          len=0;
          write_p( TT_VAR, 4, var-buda_br_up); // BUDA3+MAX_VARS-1
          TextOutA(dc.m_hDC, 0, 0, "  ", 2);
          string2[len]=0; // ? do we need this
        }  
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
      }
      //Buda1[BUDA3+MAX_VARS-1]=TT_VAR;
      break;

     case 8:  // Operators
      for (i=yStart; i<i_counter; i++)
      {
        dc.MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
        if (oper_br==0)
        {
          dc.SetTextColor(c_red);
          TextOutA(dc.m_hDC, 0, 0, "This window is empty before compilation.", 40);
          continue;
        }
#if TR
        if (Oper[i]<TT_START)
        {
          sprintf(string2, "%5d ", Oper[i]);
          dc.SetTextColor(c_red);
        }
        else
        {
          sprintf(string2, "%5d.", Oper[i]-TT_START);
          dc.SetTextColor(c_green);
        }
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
#endif
        dc.SetTextColor(c_black);
        len=0;
        write_p(Oper[i], 4, 0);
        strcat(string2, "        ");
        string2[(len<8)?8:len]=0;
        TextOutA(dc.m_hDC, 0, 0, "   ", 3);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        sprintf(string2, " %4d ", OpPr[i]);
        dc.SetTextColor(c_red);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        if (OpType[i]==0)
          k=DF_TERM;
        else
        {
          if ((k=OpType[i]-1)>=32)
            k=16+(k-34)/8;
          else
          {
            if (k>16)
              k=3+(k&12);
            else if (k%4==1 && (k&16))
              k-=8;          // -16+8
          }
          k+=DF_FX;
        }
        len=0;
        write_p(Definition[k], 4, 0);
        dc.SetTextColor(c_blue);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        if (Oper[i]!=OpMin[i])
        {
          dc.SetTextColor(c_black);
          strcpy(string2, "  ");
          len=2;
          write_p(OpMin[i], 4, 0);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        }
      }
      break;

     case 11: // Objects
      if (pCompiled==NULL)
      {
        dc.MoveTo(-m_pos.x, 0);
        dc.SetTextColor(c_red);
        TextOutA(dc.m_hDC, 0, 0, "This window is empty before compilation.", 40);
        break;
      }
      for (j=k=0; j<yStart; j++)
        k+=ObjectStore[ObjectStore[k]+2]?ObjectStore[ObjectStore[k]+2]:
          (ObjectStore[k]?ObjectStore[k+2]:ObjectStore[k+1]);
      for (i=yStart; i<i_counter; i++)
      {
        dc.MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
        sprintf(string2, "%3d. ", i);
        dc.SetTextColor(c_black);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        if (ObjectStore[k]==0)  // ObjectStore[ObjectStore[k]+1]==M1
          TextOutA(dc.m_hDC, 0, 0, "dead object", 11);
        else
        {
          dc.SetTextColor(c_blue);
          len=0;
          write_p(ObjectStore[ObjectStore[k]+1], 4, 0);
          TextOutA(dc.m_hDC, 0, 0, string2, len);
        }
        sprintf(string2, " 0j%d ", k);
        dc.SetTextColor(c_red);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        if (ObjectStore[k]==0)  // ObjectStore[ObjectStore[k]+1]==M1
          goto e_cont;
        if (ObjectStore[k+1]==M1 || ObjectStore[k+1]==M2)
        {
          dc.SetTextColor(c_blue);
          if (ObjectStore[k+1]==M1)
            TextOutA(dc.m_hDC, 0, 0, " - ", 3);
          else
            TextOutA(dc.m_hDC, 0, 0, "temporal ", 9);
        }
        else
        {
          dc.SetTextColor(c_black);
          len=0;
          write_p(ObjectStore[k+1], 4, 0);
          TextOutA(dc.m_hDC, 0, 0, string2, len);
        }
        if (SUBTYPE(ObjectStore[k],CLASS_S_CLASS))
        {
          dc.SetTextColor(c_blue);
          if (ObjectStore[k+3]!=M1)
          {
            strcpy(string2, " << ");
            len=4;
              write_p(ObjectStore[ObjectStore[k+3]+1], 4, 0);
            TextOutA(dc.m_hDC, 0, 0, string2, len);
          }
          else
            TextOutA(dc.m_hDC, 0, 0, " ----- ", 7);
          dc.SetTextColor(c_red);
          if (ObjectStore[k+2])
          {
            sprintf(string2, " size=%d", ObjectStore[k+2]);
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          }
          else
            TextOutA(dc.m_hDC, 0, 0, " variable size ", 15);
          dc.SetTextColor(c_black);
          if (ObjectStore[k+3]!=M1)
          {
            sprintf(string2, " N=%d ", ObjectStore[k+4]/(ObjectStore[ObjectStore[k+3]+5]+1));
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          }
          else
            TextOutA(dc.m_hDC, 0, 0, " N=0 ", 5);
        }
        else if (SUBTYPE(ObjectStore[k],C_S_WIN))
        {
          dc.SetTextColor(ObjectStore[k+7]);
          dc.SetBkColor(ObjectStore[k+8]);
          if (!IsWindow(((CWnd*)ObjectStore[k+2])->m_hWnd))
            TextOutA(dc.m_hDC, 0, 0, " Bad Window", 11);
          else if (1 || SUBTYPE(ObjectStore[k],C_S_WIN_Edit) || SUBTYPE(ObjectStore[k],C_S_WIN_Embedded))
            TextOutA(dc.m_hDC, 0, 0, " Text", 5);
          else // problem - this window is from different thread
          {
            ((CWnd*)ObjectStore[k+2])->GetWindowText(string3, L_BUFER);
            TextOut(dc.m_hDC, 0, 0, string3, my_strlen(string3));
          }
          dc.SetTextColor(c_black);
          dc.SetBkColor(GetSysColor(COLOR_WINDOW));
          len=2; string2[0]=','; string2[1]=' ';
            write_p(ObjectStore[k+3], 4, 0);
          TextOutA(dc.m_hDC, 0, 0, string2, len);

          dc.SetTextColor(c_blue);
          sprintf(string2, " Win:%x", ObjectStore[k+2]);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          if (ObjectStore[k+9]==(DWORD)hbrGreen)
            TextOutA(dc.m_hDC, 0, 0, " Standard Brush", 15);
          else
          {
            sprintf(string2, " Brush:%x", ObjectStore[k+9]);
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          }
        }
        else if (SUBTYPE(ObjectStore[k],CLASS_SYSTEM_LIST) && ObjectStore[k+1]!=M2)
        {
          dc.SetTextColor(c_red);
          switch(ObjectStore[k+6])
          {
            case TT_STR:   TextOutA(dc.m_hDC, 0, 0,   " str", 4); break;
            case TT_INT:   TextOutA(dc.m_hDC, 0, 0,   " int", 4); break;
            case TT_FLOAT: TextOutA(dc.m_hDC, 0, 0, " float", 6); break;
            case TT_OBJ:   TextOutA(dc.m_hDC, 0, 0,   " obj", 4); break;
          }
          dc.SetTextColor(c_blue);
          TextOutA(dc.m_hDC, 0, 0,   " size=", 6);
          dc.SetTextColor(c_red);
          sprintf(string2, "%d [", ObjectStore[k+2]);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          DWORD *Temp=(LPDWORD)ObjectStore[k+4];
          BYTE TempString[11];
          TempString[7]='.'; TempString[8]='.'; TempString[9]='.'; TempString[10]='\0';
          for (n=0; n<min(30,ObjectStore[k+2]); n++)
          {
            dc.SetTextColor(c_black);
            sprintf(string2, "a%d=", n);
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            dc.SetTextColor(c_red);
            switch(ObjectStore[k+6])
            {
              case TT_STR:   for(m=0; m<7; TempString[m]=StringStore[Temp[n]+m], m++);
                              sprintf(string2, "\"%s\", ", TempString); break;
              case TT_INT:   sprintf(string2, "%d, ", Temp[n]); break;
              case TT_FLOAT: sprintf(string2, "%G, ", *(float*)&(Temp[n])); break;
              case TT_OBJ:   sprintf(string2, "0j%d, ", Temp[n]); break;
            }
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          }
        }
e_cont: k+=ObjectStore[ObjectStore[k]+2]?ObjectStore[ObjectStore[k]+2]:
        (ObjectStore[k]?ObjectStore[k+2]:ObjectStore[k+1]);
      }
      break;
#if TR
     case 9: // Constants
      for (i=yStart; i<i_counter; i++)
      {
        dc.MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
        if (i<TT_LINK)  
          dc.SetTextColor(c_black);
        else
          dc.SetTextColor(c_green);
        sprintf(string2, "%3d. ", i);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        dc.SetTextColor(c_red);
        if (i>123 && i<131)
        {
          switch (i)
          {
           case 124:
            strcpy(string2, "  used");
            break;
           case 125:
            strcpy(string2, "   set");
            break;
           case 126:
            strcpy(string2, "   [] ");
            break;
           case 127:
            strcpy(string2, "   var");
            break;
           case 128:
            strcpy(string2, "nothing");
            break;
           case 129:
            strcpy(string2, " space");
            break;
           case 130:
            strcpy(string2, " enter");
          }
        }
        else
        {  
          j=key_oposit[i];
          if (j<TT_START)
            sprintf(string2, "   '%c'", j);
          else
            sprintf(string2, "  free");
        }
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
      }
      break;

     case 10: // Key Map
      for (i=yStart; i<i_counter; i++)
      {
        dc.MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
        sprintf(string2, "%3d. ", i);
        dc.SetTextColor(c_black);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        sprintf(string2, "'%c' ", i);
        dc.SetTextColor(c_red);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        if (key_map[i]<128)  
          dc.SetTextColor(c_black);
        else
          dc.SetTextColor(c_green);
        sprintf(string2, "%3d ", key_map[i]);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        dc.SetTextColor(c_red);
        if (key_map[i]>123 && key_map[i]<131)
        {
          switch (key_map[i])
          {
           case 124:
            strcpy(string2, "  used");
            break;
           case 125:
            strcpy(string2, "   set");
            break;
           case 126:
            strcpy(string2, "   [] ");
            break;
           case 127:
            strcpy(string2, "   var");
            break;
           case 128:
            strcpy(string2, "nothing");
            break;
           case 129:
            strcpy(string2, " space");
            break;
           case 130:
            strcpy(string2, " enter");
          }
        }
        else
        {  
          j=key_oposit[key_map[i]];
          if (j<TT_START)
            sprintf(string2, "   '%c'", j);
          else
            sprintf(string2, "  free");     // we don't need
        }
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
      }
      break;

     case 12: // Blocks
      for (i=yStart; i<i_counter; i++)
      {
        dc.MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
        sprintf(string2, "%3d. ", i);
        if (i<sv_blocks)
          dc.SetTextColor(c_green);
        else
          dc.SetTextColor(c_blue);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        if (Blocks_val[i]==SM1)
        {
          dc.SetTextColor(c_black);
          TextOutA(dc.m_hDC, 0, 0, " --- ", 5);
        }
        else if (Blocks_val[i]==SM2)
        {
          dc.SetTextColor(c_red);
          TextOutA(dc.m_hDC, 0, 0, " *** ", 5);
        }
        else
        {
          char ch;

          dc.SetTextColor(c_red);
          sprintf(string2, "%4d ", Blocks_val[i]);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          
          k=Blocks[i];
          ch=(k & QUARTER)?((k & HALF)?'B':'a'):((k & HALF)?'h':' ');
          if (k & OBSEG1)
          {
            sprintf(string2, "%5d %c ", (int)(k & MASKA), ch);
            dc.SetTextColor(c_black);
          }
          // else if (k & OBSEG2) // imposible
          else if ((k & MASKA)< MEMORY_C)
          {
            sprintf(string2, "%5d.%c ", (int)(k & MASKA), ch);
            dc.SetTextColor(c_green);
          }
          else
          {
            sprintf(string2, "%5d~%c ", (int)((k & MASKA)-MEMORY_C), ch);
            dc.SetTextColor(c_blue);
          }
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          
          if (Blocks_next[i]==SM1)
            strcpy(string2, " -|  ");
          else
            sprintf(string2, "%3d  ", Blocks_next[i]);
          dc.SetTextColor(c_blue);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          
          if (!(k & (OBSEG1|OBSEG2)))
          {
            len=0;
            write_p((k & MASKA)+TT_START, 4, max(a1,global_br2));
            dc.SetTextColor(c_black);
            TextOutA(dc.m_hDC, 0, 0, string2, len);
          }
        }
      }
      break;

     case 18: // Link
      {
        DWORD Ek1, Ek_2, Ek3, St_g1, St_g1p, St_g2, St_atoms, St_b;

        for(Ek_2=0; Ek_2<=ekler_br && (Ekler[Ek_2]<yStart || Ekler[Ek_2]>=sv_subv); Ek_2++);
        Ek3=(Ek_2>0?Ekler[Ek_2-1]+4:0);
        Ek1=(Ek_2<=ekler_br?Ekler[Ek_2]-3*(Link[Ekler[Ek_2]+3]-Link[Ekler[Ek_2]+2]):sv_subv);
        for(St_g2=0; St_g2<stack_br && Stack[St_g2+2]<yStart; St_g2+=4);
        St_atoms=Atoms[Link[Ekler[Stack[St_g2+3]&MASKA2]]];
        for(St_b=0; St_b<stack_br && Ekler[(Stack[St_b+3]&MASKA2)]<yStart; St_b+=4); 
        St_g1=(St_b>0?Stack[St_b-4+2]-1-Atoms[Link[Ekler[(Stack[St_b-4+3]&MASKA2)]]]:sv_subv);
        St_g1p=(St_b>0?St_g1-Link[St_g1]:sv_subv);

        for (i=yStart; i<i_counter; i++)
        {
          dc.MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
          sprintf(string2, "%3d. ", i);
          dc.SetTextColor(c_black);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          if (i<Stack[St_g2+2] && i>=Stack[St_g2+2]-St_atoms)
          {
            dc.SetTextColor(c_black);
            sprintf(string2, "atom%d -> ", 1+i-Stack[St_g2+2]+St_atoms);
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            dc.SetTextColor(c_green);
            sprintf(string2, "%d ", Link[i]-global_br);
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          }
          else if (i==Stack[St_g2+2])
          {
            dc.SetTextColor(c_black);
            sprintf(string2, "head  -> %d ", Link[i]-global_br);
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            dc.SetTextColor(c_green);
            sprintf(string2, "<= stack %d ", St_g2/4);
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            St_g2+=4;
            St_atoms=Atoms[Link[Ekler[Stack[St_g2+3]&MASKA2]]];
          }
          else if (i!=Ekler[Ek_2] || Ek_2>ekler_br)
          {
            if (i>=Ek1)
            {
              dc.SetTextColor(c_red);
              TextOutA(dc.m_hDC, 0, 0, ". ", 2);
              if ((i-Ek1)%3==0)
              {
                dc.SetTextColor(c_blue);
                sprintf(string2, "var%d ", Link[i]-global_br);
                TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
              }
              else if ((i-Ek1)%3==1)
              {
                if (Link[i]==M2)
                  TextOutA(dc.m_hDC, 0, 0, "Value not used.", 15);
                else
                  TextOut_Var(Link[i], Link[i+1], dc.m_hDC);
              }
              if (i==Ek1)
              {
                dc.SelectObject(hMyRedPen);
                dc.MoveTo(80-m_pos.x, (i-m_pos.y)*m_char.cy-2);
                dc.LineTo(540-m_pos.x, (i-m_pos.y)*m_char.cy-2);
              }
            }
            else if (i<Ek3)
            {
              dc.SetTextColor(c_red);
              TextOutA(dc.m_hDC, 0, 0, "* ", 2);
              if (Ek3-i==1)
                sprintf(string2, "%d is all subs ", Link[i]);
              else if (Ek3-i==2)
                sprintf(string2, "%d here, (rest %d) ", (int)(Link[i+1]-Link[i]), (int)Link[i]);
              else if (Link[i]==0)
                sprintf(string2, "goto nowhere ");
              else
                sprintf(string2, "goto %d ", Link[i]);
              TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
              if (Ek3-i==1)
              {
                dc.SelectObject(hMyRedPen);
                dc.MoveTo(80-m_pos.x, (i-m_pos.y+1)*m_char.cy-2);
                dc.LineTo(540-m_pos.x, (i-m_pos.y+1)*m_char.cy-2);
              }
            }
            else if (i==St_g1)
            {
              dc.SetTextColor(c_green);
              TextOutA(dc.m_hDC, 0, 0, "clean ", 6);
              dc.SetTextColor(c_black);
              TextOutA(dc.m_hDC, 0, 0, "num=", 4);
              dc.SetTextColor(c_violet);
              sprintf(string2, "%d ", Link[i]);
              TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            }
            else if (i>=St_g1p && i<St_g1)
            {
              dc.SetTextColor(c_green);
              TextOutA(dc.m_hDC, 0, 0, "clean ", 6);
              dc.SetTextColor(c_black);
              sprintf(string2, "%d ", Link[i]-global_br);
              TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            }
            else
            {
              dc.SetTextColor(c_blue);
              sprintf(string2, "%d ", Link[i]);
              TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            }
          }
          else // i==Ekler[Ek_2]
          {
            dc.SetTextColor(c_red);
            TextOutA(dc.m_hDC, 0, 0, "<- ", 3);
            if (Link[i]>=program_br2)
            {
              sprintf(string2, "%6d. ", Link[i]-program_br2);
              dc.SetTextColor(c_blue);
            }
            else
            {
              sprintf(string2, "%6d, ", Link[i]);
              dc.SetTextColor(c_violet);
            }
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            dc.SetTextColor(c_red);
            sprintf(string2, "<= ekler %d ", Ek_2);
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            if (Ek_2==(Stack[St_b+3]&MASKA2))
            {
              dc.SetTextColor(c_black);
              sprintf(string2, "(stack %d) ", St_b/4);
              TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
              for(St_b+=4; St_b<stack_br && Ekler[(Stack[St_b+3]&MASKA2)]<=i; St_b+=4);
              St_g1=(St_b>0?Stack[St_b-4+2]-1-Atoms[Link[Ekler[(Stack[St_b-4+3]&MASKA2)]]]:sv_subv);
              St_g1p=(St_b>0?St_g1-Link[St_g1]:sv_subv);
            }
            Ek3=i+4;
            for(Ek_2++; Ek_2<=ekler_br && (Ekler[Ek_2]<=i || Ekler[Ek_2]>=sv_subv); Ek_2++);
            Ek1=(Ek_2<=ekler_br && Ekler[Ek_2]<sv_subv?Ekler[Ek_2]-3*(Link[Ekler[Ek_2]+3]-Link[Ekler[Ek_2]+2]):sv_subv);
            if (Link[i+3]==0)
            {
              dc.SelectObject(hMyRedPen);
              dc.MoveTo(80-m_pos.x, (i-m_pos.y)*m_char.cy-2);
              dc.LineTo(540-m_pos.x, (i-m_pos.y)*m_char.cy-2);
            }
          }
        }
      }
      break;

     case 13: // Ekler
      {
        DWORD St_b, type;

        for(St_b=0; St_b<stack_br && (Stack[St_b+3]&MASKA2)<yStart; St_b+=4); 

        for (i=yStart; i<i_counter; i++)
        {
          dc.MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
          sprintf(string2, "%3d. ", i);
          dc.SetTextColor(c_black);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          dc.SetTextColor(c_blue);
          j=Ekler[i];
          if (j<0 || j>=sv_subv)
          {
            dc.SetTextColor(c_red);
            TextOutA(dc.m_hDC, 0, 0, "Built-in ", 9);
            dc.SetTextColor(c_blue);
            type=j&TP_ALL;
            if (type&TP_TAPA)
              TextOutA(dc.m_hDC, 0, 0, "TAPA ", 5);
            if (type&TP_REAL_TAPA)
              TextOutA(dc.m_hDC, 0, 0, "REAL_TAPA ", 10);
            if ((type&TP_CALK)==TP_CALK)
              TextOutA(dc.m_hDC, 0, 0, "CALK ", 5);
            else
            {
              if (type&TP_VAR)
                TextOutA(dc.m_hDC, 0, 0, "VAR ", 4);
              if (type&TP_TERM)
                TextOutA(dc.m_hDC, 0, 0, "TERM ", 5);
              if (type&TP_STR)
                TextOutA(dc.m_hDC, 0, 0, "STR ", 4);
              if (type&TP_INT)
                TextOutA(dc.m_hDC, 0, 0, "INT ", 4);
              if (type&TP_FLOAT)
                TextOutA(dc.m_hDC, 0, 0, "FLOAT ", 6);
              if (type&TP_OBJ)
                TextOutA(dc.m_hDC, 0, 0, "OBJ ", 4);
            }
            if (type&TP_LIST)
              TextOutA(dc.m_hDC, 0, 0, "LIST ", 5);
            if (type&TP_IO)
              TextOutA(dc.m_hDC, 0, 0, "IO ", 3);
            if (type&TP_METHOD)
              TextOutA(dc.m_hDC, 0, 0, "METHOD ", 7);
            if (type&TP_STRICT)
              TextOutA(dc.m_hDC, 0, 0, "STRICT ", 7);
            if (type&TP_TEMP_FLAG)
              TextOutA(dc.m_hDC, 0, 0, "TEMP_FLAG ", 10);
            dc.SetTextColor(c_black);
            sprintf(string2, "Args=%d ", j&MASKA_TP2);
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            continue;
          }
          m=Link[j+3];
          sprintf(string2, "%d->num=%d ", j, m);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          dc.SetTextColor(c_red);
          k=Link[j+2]; // > 0 or ==0
          n=Link[j+1];
          sprintf(string2, "k=%d, n=%d ", k, n);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
          for (; m>k; m--)
          { 
            j-=3;
            dc.SetTextColor(c_blue);
            sprintf(string2, " var%d=", Link[j]-global_br);
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
			if (Link[j+1]==M2)
			  TextOutA(dc.m_hDC, 0, 0, "Value not used.", 15);
			else
			  TextOut_Var(Link[j+1], Link[j+2], dc.m_hDC);
          }
          if (i==(Stack[St_b+3]&MASKA2))
          {
            dc.SetTextColor(c_black);
            sprintf(string2, "(stack %d) ", St_b/4);
            TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            for(St_b+=4; St_b<stack_br && (Stack[St_b+3]&MASKA2)<=i; St_b+=4); // maybe St_b+=4; s enough
          }
        }
      }
      break;

     case 14: // D_Field
      for (i=yStart; i<i_counter; i++)
      {
        dc.MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
        sprintf(string2, "%3d. ", i);
        dc.SetTextColor(c_black);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        dc.SetTextColor(c_blue);
        if (D_field[i]==M1)
          TextOutA(dc.m_hDC, 0, 0, "---", 3);
        else
        {  
          sprintf(string2, "%d", D_field[i]);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        }
      }
      break;

     case 15: // Pointers
      for (i=yStart; i<i_counter; i++)
      {
        dc.MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
        if (i<TT_START)
        {
          j=i;
          sprintf(string2, "%3d' ", i);
          dc.SetTextColor(c_red);
        }
        else if (i<TT_START+sv_c)
        {
          j=i;
          sprintf(string2, "%3d. ", i-TT_START);
          dc.SetTextColor(c_green);
        }
        else
        {
          j=MEMORY_C+i-sv_c;
          sprintf(string2, "%3d~ ", i-sv_c-TT_START);
          dc.SetTextColor(c_blue);
        }
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        if (Pointers[j])
        {
          dc.SetTextColor(c_black);
          DWORD Pointers_flag=HALF;
          for (k=0; k<8; k++, Pointers_flag=Pointers_flag>>1)
          {
            if (Pointers[j]&Pointers_flag)
            {
              switch(k)
              {
               case 0:
                TextOutA(dc.m_hDC, 0, 0, "H", 1);
                break;
               case 1:
                TextOutA(dc.m_hDC, 0, 0, "A", 1);
                break;
               case 2:
                TextOutA(dc.m_hDC, 0, 0, "P", 1);
                break;
               case 3:
                TextOutA(dc.m_hDC, 0, 0, "p", 1);
                break;
               case 4:
                TextOutA(dc.m_hDC, 0, 0, "F", 1);
                break;
               case 5:
                TextOutA(dc.m_hDC, 0, 0, "f", 1);
                break;
               case 6:
                TextOutA(dc.m_hDC, 0, 0, "N", 1);
                break;
               case 7:
                TextOutA(dc.m_hDC, 0, 0, "O", 1);
              }
            }
            else
              TextOutA(dc.m_hDC, 0, 0, ".", 1);
          }
          Pointers_flag=HALF;
          for (k=0; k<8; k++, Pointers_flag=Pointers_flag>>1)
          {
            dc.SetTextColor(c_blue);
            if (Pointers[j]&Pointers_flag)
            {
              switch(k)
              {
               case 0:
                TextOutA(dc.m_hDC, 0, 0, " H", 2);
                break;
               case 1:
                TextOutA(dc.m_hDC, 0, 0, " A", 2);
                break;
               case 2:
                TextOutA(dc.m_hDC, 0, 0, " P", 2);
                break;
               case 3:
                TextOutA(dc.m_hDC, 0, 0, " p", 2);
                break;
               case 4:
                TextOutA(dc.m_hDC, 0, 0, " F", 2);
                break;
               case 5:
                TextOutA(dc.m_hDC, 0, 0, " f", 2);
                break;
               case 6:
                TextOutA(dc.m_hDC, 0, 0, " N", 2);
                break;
               case 7:
                TextOutA(dc.m_hDC, 0, 0, " O", 2);
              }
              dc.SetTextColor(c_red);
              n=D_field[(Pointers[j]&MASKA3)+k];
              sprintf(string2, "%s%s%d", (n&HALF?"*":""), (n&QUARTER?"#":""), (n&MASKA2));
              TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
            }
          }
          dc.SetTextColor(c_black);
          sprintf(string2, " %d", Pointers[j]&MASKA3);
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        }
        else
        {
          dc.SetTextColor(c_blue);
          TextOutA(dc.m_hDC, 0, 0, "---", 3);
        }
      }
      break;

     case 16: // F_Field
      for (i=yStart; i<i_counter; i++)
      {
        dc.MoveTo(-m_pos.x, (i-m_pos.y)*m_char.cy);
        sprintf(string2, "%3d. ", i);
        dc.SetTextColor(c_black);
        TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        dc.SetTextColor(c_blue);
        if (F_field[i]==0)
          TextOutA(dc.m_hDC, 0, 0, "---", 3);
        else
        {  
          sprintf(string2, "%3x  %d", (int)(F_field[i]/0x100000), (int)(F_field[i]&0xfffff));
          TextOutA(dc.m_hDC, 0, 0, string2, strlen(string2));
        }
      }
      break;

#endif // TR
    }
end:
	status_fl &= M1 ^ 16;
	Redraw();
    // Do not call CFrameWnd::OnPaint() for painting messages
}

BOOL CwInformation::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) // mouse_wheel
{
  CPoint OldPos=m_pos;
  int Delta=zDelta/WHEEL_DELTA;
  if (Delta<0)    //  Down
  {
    if (m_pos.y<m_fild2-m_page.cy+Delta)
      m_pos.y-=Delta;
    else
      m_pos.y=m_fild2-m_page.cy;
  }
  else    //  Up
  {
    if (m_pos.y > Delta)
      m_pos.y-=Delta;
    else
      m_pos.y=0;
  }
  ScrollWindow(0, m_char.cy*(OldPos.y-m_pos.y));
  return(CFrameWnd::OnMouseWheel(nFlags, zDelta, pt));
}
void CwInformation::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
    CPoint OldPos=m_pos;
    switch(nChar)
    {
     case 35:    // End
      m_pos.x=WINDOW_SIZE-m_page.cx;
      break;
     case 36:    // Home
      m_pos.x=0;
      break;
     case 37:    // Left
      if (m_pos.x>m_char.cx)
        m_pos.x-=m_char.cx;
      else
        m_pos.x=0;
      break;
     case 39:    // Right
      if (m_pos.x<WINDOW_SIZE-m_page.cx-m_char.cx)
        m_pos.x+=m_char.cx;
      else
        m_pos.x=WINDOW_SIZE-m_page.cx;
      break;
     case 34:    // Page Down
      m_pos.y=min(m_pos.y+m_page.cy-1,m_fild2-m_page.cy);
      break;   
     case 40:    //  Down
      if (m_pos.y<m_fild2-m_page.cy-1)
        m_pos.y++;
      else
        m_pos.y=m_fild2-m_page.cy;
      break;
     case 33:    // Page Up
      m_pos.y=(m_pos.y>m_page.cy-1)?(m_pos.y-m_page.cy+1):0;
      break;
     case 38:    //  Up
      if (m_pos.y)
        m_pos.y--;
      break;
    }
    ScrollWindow(OldPos.x-m_pos.x, m_char.cy*(OldPos.y-m_pos.y));
    CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CwInformation::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    CPoint OldPos=m_pos;
    switch(nSBCode)
    {
     case SB_THUMBPOSITION:    // Moved to
     case SB_THUMBTRACK:    // Drag to
      m_pos.x=nPos;
      break;
     case SB_LINELEFT:    // Left
      if (m_pos.x>m_char.cx)
        m_pos.x-=m_char.cx;
      else
        m_pos.x=0;
      break;
     case SB_LINERIGHT:    // Right
      if (m_pos.x<WINDOW_SIZE-m_page.cx-m_char.cx)
        m_pos.x+=m_char.cx;
      else
        m_pos.x=WINDOW_SIZE-m_page.cx;
      break;
     case SB_PAGELEFT:    // Page Left
      if (m_pos.x>m_page.cx-m_char.cx)
        m_pos.x-=m_page.cx-m_char.cx;
      else
        m_pos.x=0;
      break;
     case SB_PAGERIGHT:    // Page Right
      if (m_pos.x<WINDOW_SIZE-2*m_page.cx+m_char.cx)
        m_pos.x+=m_page.cx-m_char.cx;
      else
        m_pos.x=WINDOW_SIZE-m_page.cx;
      break;
    }
    ScrollWindow(OldPos.x-m_pos.x, m_char.cy*(OldPos.y-m_pos.y));
    CFrameWnd::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CwInformation::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    CPoint OldPos=m_pos;
    switch(nSBCode)
    {
     case SB_THUMBPOSITION:    // Moved to
     case SB_THUMBTRACK:    // Drag to
      m_pos.y=nPos*Corrector;
      break;
     case SB_PAGEDOWN:    // Page Down
      m_pos.y=min(m_pos.y+m_page.cy-1,m_fild2-m_page.cy);
      break;   
     case SB_LINEDOWN:    //  Down
      if (m_pos.y<m_fild2-m_page.cy-1)
        m_pos.y++;
      else
        m_pos.y=m_fild2-m_page.cy;
      break;
     case SB_PAGEUP:    // Page Up
      m_pos.y=(m_pos.y>m_page.cy-1)?(m_pos.y-m_page.cy+1):0;
      break;
     case SB_LINEUP:    //  Up
      if (m_pos.y>0)
        m_pos.y--;
      break;
    }
    ScrollWindow(OldPos.x-m_pos.x, m_char.cy*(OldPos.y-m_pos.y));
    CFrameWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CwInformation::OnClose() 
{
  if (pStack==this)
    pStack=NULL;
  else if (pVariables==this)
    pVariables=NULL;
  else if (pSysList==this)
    pSysList=NULL;
  else if (pFunctions==this)
    pFunctions=NULL;
#if TR
  else if (pEkler==this)
	  pEkler=NULL;
  else if (pLink==this)
	  pLink=NULL;
#endif
  CFrameWnd::OnClose();
}
/////////////////////////////////////////////////////////////////////////////
// CwClasses

IMPLEMENT_DYNCREATE(CwClasses, CFrameWnd)

CwClasses::CwClasses()
{
  m_pTreeBox=NULL;
}

CwClasses::~CwClasses()
{
}


BEGIN_MESSAGE_MAP(CwClasses, CFrameWnd)
    ON_WM_SIZE()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CwClasses message handlers

void CwClasses::OnSize(UINT nType, int cx, int cy) 
{
    CFrameWnd::OnSize(nType, cx, cy);
    if (m_pTreeBox!=NULL)
      m_pTreeBox->SetWindowPos(0, 0, 0, cx, cy-45, SWP_NOMOVE | SWP_NOZORDER);
}
BOOL CwClasses::OnCommand(WPARAM wParam, LPARAM lParam) 
{
  if (LOWORD(wParam)==100)
  {
    m_pTreeBox->DeleteAllItems();
    AddClasses();
  }
  return CFrameWnd::OnCommand(wParam, lParam);
}
void CwClasses::AddClasses(void)
{
  int i, j;
  HTREEITEM item=TVI_ROOT;

  i=Pointers[Definition[DF_CLASSES]]; // object
  if (i&OBSEG5)
  {
    j=D_field[(i&MASKA3)+6];
    while(1)
    {
      len=0; 
      write_p(ObjectStore[j+1], 4, 0);
      i=(j>C_S_WIN_Embedded);
      item=m_pTreeBox->InsertItem(TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE,
           make_long((BYTE *)string2), i, i,  0,0,0, item, TVI_LAST);
      if (ObjectStore[j+6]!=M1)
        j=ObjectStore[j+6];
      else
      {
        item=m_pTreeBox->GetParentItem(item);
        if (ObjectStore[j+7]!=M1)
          j=ObjectStore[j+7];
        else
        {
          do
          {
            if ((j=ObjectStore[j+3])==M1)
              return;
          }
          while(ObjectStore[j+7]==M1);
          j=ObjectStore[j+7];
        }
      }
    }
  }
  else
    m_pTreeBox->InsertItem(TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE,
     _T("This window is empty before compilation."), 10, 10,  0,0,0, item, TVI_LAST);
}
